program covplot
!
!  only standard fortran 90 structures are used, nevertheless
!  the lahey graph90.lib graphic subroutine library is required
!
character*80 crd,fil
character*76 tskname
character*72 titcrd,det_ident
character*17 :: nsp=' neutron spectrum'
character*8 name
character*6, dimension (3) :: spkind=(/'input ','norm-d','output'/)
character*3 keywrd
character*2 cover
character*1 c
logical ex
integer bgr,i,ibid,j,kovflg,l,lim,m,mat,mt,n1u,ngu,ngu1,noc,nol,res
real anis,g1,g2,g3,g4
real, allocatable, dimension (:) :: cl,crs,e,std
real, allocatable, dimension (:,:) :: cor
integer, dimension (:), allocatable :: kl
integer, allocatable, dimension (:,:) :: kor
integer, dimension (8) :: pens
!
!  graphic environment
!
inquire (file='covplot.ini',exist=ex)
if (ex) then
   open (unit=1,file='covplot.ini',status='old',form='formatted')
   read (1,1) ibid
   read (1,2) res
   call graph_envir(ibid,res,pens,noc,nol)
   read (1,3) bgr
   if (res/=99) then
      read (1,3) lim
      allocate (cl(lim),kl(lim))
      read (1,4) (cl(i),kl(i),i=1,lim)
   end if
else
   open (unit=1,file='covplot.ini',status='new',form='formatted')
   ibid=0 ; write (1,1) ibid
   res=0 ; write (1,2) res
   call graph_envir(ibid,res,pens,noc,nol)
   bgr=merge(0,15,pens(1)==1) ; write (1,3) bgr
   if (res/=99) then
      lim=7 ; write (1,3) lim
      allocate (cl(lim),kl(lim))
      cl=(/.7,.4,.1,-.1,-.4,-.7,-1./) ; kl=(/15,14,2,0,11,9,1/)
      write (1,4) (cl(i),kl(i),i=1,7)
   end if
   endfile (unit=1)
end if
close (unit=1,status='keep')
1 format (i1)
2 format (i2)
3 format (i3)
4 format (f6.3,i4)
!
!  select the task
!
write (6,70)
6 write (6,71)
read (5,80) tskname
do l=76,1,-1 ; if (tskname(l:l)/=' ') go to 7 ; end do
go to 6
!
!  taskname.out
!
7 fil=tskname(1:l)//'.out'
inquire (file=fil,exist=ex)
if (.not.ex) then ; write (*,*) fil,' does not exist' ; go to 100 ; end if
write (*,*) 'processing ',fil
open (unit=8,file=fil,form='formatted',status='old',err=99)
read (8,80) crd ; read (8,80) crd ; titcrd=crd(1:72)
10 if (crd(74:78)=='INPUT') go to 11
read (8,80) crd ; go to 10
11 read (8,*) ngu ; ngu1=ngu+1
allocate (e(ngu1),crs(ngu),std(ngu),cor(ngu,ngu),kor(ngu,ngu))
do m=1,3
   20 read (8,80) keywrd ; if (keywrd/='STD') go to 20
   read (8,*) std(1:ngu) ; read (8,*)
   kor=0
   do i=1,ngu ; read (8,*) kor(1:i,i) ; end do
   kor=kor+transpose(kor)
   cor=kor/float(kor(1,1))
   21 read (8,80) keywrd ; if (keywrd/='END') go to 21
   read (8,*) e
   if (m==2) cycle
   30 write (6,72) spkind(m)//nsp
   if (pens(7)>1) then ; write (6,73) ; else ; write (6,74) ; end if
   read (5,80) c
   select case (c)
   case ('q','Q') ; exit
   case ('s','S') ; cycle
   case ('2')
      if (pens(7)>1) &
         &   call two_dim(titcrd,spkind(m)//nsp,1,ngu,ngu1,e,cor,noc,nol,   &
         &   ibid,res,bgr,lim,pens,cl,kl)
   case ('3')
      call three_dim(titcrd,spkind(m)//nsp,1,ngu,ngu1,e,cor,ibid,res,pens,   &
         &   noc,nol)
   case ('b','B')
      if (pens(7)>1) &
         &   call two_dim(titcrd,spkind(m)//nsp,1,ngu,ngu1,e,cor,noc,nol,   &
         &   ibid,res,bgr,lim,pens,cl,kl)
      call three_dim(titcrd,spkind(m)//nsp,1,ngu,ngu1,e,cor,ibid,res,pens,   &
         &   noc,nol)
   case default
      go to 30
   end select
end do
close (unit=8,status='keep')
go to 100
70 format (10(/),13x,'COVPLOT utility to plot the correlation matrices'/ &
   & 13x,'written by the codes X333 and STAYNL')
71 format (///' [drive:] [path] taskname ?  ')
72 format (1x,a,/' select the style of the plot')
73 format (' enter { 2 | 3 | b | B | s | S | q | Q }'/ &
   & ' for 2|3 dimensional plot, for both plots, for skipping, for quit'/)
74 format (' enter { 3 | s | S | q | Q }'/ &
   & ' for 3 dimensional plot, for skipping, for quit'/)
75 format (a8,es10.2,f5.2,'  (',a2,es10.2,f5.2,')',f7.2,i5,i4)
80 format (a)
81 format (i11)
82 format (7f11.0)
83 format (2(a8,3x,2f11.0))
84 format (f11.0,4i11)
99 stop 'dos open error, file=taskname.out'
!
!  taskname.xsx
!
100 fil=tskname(1:l)//'.xsx'
inquire (file=fil,exist=ex)
if (.not.ex) then ; write (*,*) fil,' does not exist' ; stop ; end if
open (unit=8,file=fil,form='formatted',status='old',err=199)
write (*,*) 'processing ',fil
read (8,80) titcrd
read (8,81) ngu ; ngu1=ngu+1
if (.not.allocated(e))   &
   &   allocate (e(ngu1),crs(ngu),std(ngu),cor(ngu,ngu),kor(ngu,ngu))
read (8,82) e
do
   read (8,83) name,g1,g2,cover,g3,g4
   if (name(1:3)=='***') exit
   read (8,84) anis,mat,mt,n1u,kovflg
   write (det_ident,75) name,g1,g2,cover,g3,g4,anis,mat,mt
   if (kovflg<2) then
      read (8,82) (crs(j),j=n1u,ngu)
   else
      read (8,83) name,g1,g2,cover,g3,g4
      read (8,82)
      do i=n1u,ngu ; read (8,82) (cor(i,j),j=n1u,ngu) ; end do
   end if
   if (kovflg/=1) cycle
   cor=0.
   do i=n1u,ngu ; read (8,82) (cor(i,j),j=n1u,ngu) ; end do
   if (kovflg==1) then
      do i=n1u,ngu ; std(i)=sqrt(cor(i,i)) ; end do
      do i=n1u,ngu ; cor(n1u:ngu,i)=cor(n1u:ngu,i)/std(i) ; end do
      do i=n1u,ngu ; cor(i,n1u:ngu)=cor(i,n1u:ngu)/std(i) ; end do
   end if
   130 write (6,72) det_ident
   if (pens(7)>1) then ; write (6,73) ; else ; write (6,74) ; end if
   read (5,80) c
   select case (c)
   case ('q','Q') ; exit
   case ('s','S') ; cycle
   case ('2')
      if (pens(7)>1) &
         &   call two_dim(titcrd,det_ident,n1u,ngu,ngu1,e,cor,noc,nol,ibid,   &
         &   res,bgr,lim,pens,cl,kl)
   case ('3')
      call three_dim(titcrd,det_ident,n1u,ngu,ngu1,e,cor,ibid,res,pens,noc,nol)
   case ('b','B')
      if (pens(7)>1) &
         &   call two_dim(titcrd,det_ident,n1u,ngu,ngu1,e,cor,noc,nol,ibid,   &
         &   res,bgr,lim,pens,cl,kl)
      call three_dim(titcrd,det_ident,n1u,ngu,ngu1,e,cor,ibid,res,pens,noc,nol)
   case default
      go to 130
   end select
end do
close (unit=8,status='keep')
stop
199 stop 'dos open error, file=taskname.xsx'
end program
!
!
!
subroutine graph_envir(ibid,res,pens,noc,nol)
!  determine display parameters
integer, intent (in) :: ibid,res
integer, intent (out), dimension (8) :: pens
integer, intent (out) :: noc,nol
integer, dimension (9) :: iarray
real, dimension (7) :: rarray
character*40 string
call plots(0,ibid,res)
call grinfo(iarray,rarray,string)
if (iarray(4)<16) then
   pens=1
else
   pens(1)=9 ; pens(2)=10 ; pens(3)=14 ; pens(4)=1
   pens(5)=2 ; pens(6)=4 ; pens(7)=15 ; pens(8)=8
end if
noc=iarray(8) ; nol=iarray(9)
call plot(0.,0.,999)
end subroutine graph_envir
!
!
!
subroutine two_dim(t1,t2,n1u,ngu,ngu1,e,c,noc,nol,ibid,res,bgr,lim,pens,cl,kl)
character*(*) t1,t2
character*4 ch
integer bgr,res,i,ibid,ixkey,j,k,lim,n1u,ngu,ngu1,noc,nol
integer, dimension (8), intent (in) :: pens
real, dimension (ngu,ngu), intent (in) :: c
real, dimension (ngu1) :: e,ep
real, dimension (lim) :: cl
integer, dimension (lim) :: kl
integer, dimension (ngu,ngu) :: kol
real, dimension (5) :: x,y
real :: b=.12,x0=0.4,y0=7.0,w,yw
!
ep=.5*(alog10(e)+10.)
!
call plots(0,ibid,res)
x(1)=0.4 ; x(2)=10.6 ; x(3)=10.6 ; x(4)=0.4
y(1)=0.2 ; y(2)=0.2 ; y(3)=7.0 ; y(4)=7.0
call newpen(pens(7))
call fill(4,x,y)
i=(noc-len(t1))/2
if (nol>25) then
   call gtext(4,i,t1) ; call gtext(6,i,t2)
else
   call gtext(1,i,t1) ; call gtext(2,i,t2)
end if
!
x(1)=x0 ; x(2)=x0+6. ; x(3)=x0+6. ; x(4)=x0 ; x(5)=x(1)
y(1)=y0 ; y(2)=y0 ; y(3)=y0-6. ; y(4)=y0-6. ; y(5)=y(1)
call newpen(pens(3)) ; call fill(4,x,y)
call newpen(0) ; call line(5,x,y)
call newpen(pens(6))
call plot(x0,y0-0.5,3) ; call plot(x0+6.,y0-0.5,2)
call symbol(x0+6.1,y0-0.5,b,'1meV',0.,4)
call plot(x0,y0-2.0,3) ; call plot(x0+6.,y0-2.0,2)
call symbol(x0+6.1,y0-2.0,b,'1eV',0.,3)
call plot(x0,y0-3.5,3) ; call plot(x0+6.,y0-3.5,2)
call symbol(x0+6.1,y0-3.5,b,'1keV',0.,4)
call plot(x0,y0-5.0,3) ; call plot(x0+6.,y0-5.0,2)
call symbol(x0+6.1,y0-5.0,b,'1MeV',0.,4)
call plot(x0,y0-6.0,3) ; call plot(x0+6.,y0-6.0,2)
call symbol(x0+6.1,y0-6.0,b,'100MeV',0.,6)
call plot(x0+0.5,y0,3) ; call plot(x0+0.5,y0-6.,2)
call symbol(x0+0.5,y0-6.-4.5*b,b,'1meV',90.,4)
call plot(x0+2.0,y0,3) ; call plot(x0+2.0,y0-6.,2)
call symbol(x0+2.0,y0-6.-3.5*b,b,'1eV',90.,3)
call plot(x0+3.5,y0,3) ; call plot(x0+3.5,y0-6.,2)
call symbol(x0+3.5,y0-6.-4.5*b,b,'1keV',90.,4)
call plot(x0+5.0,y0,3) ; call plot(x0+5.0,y0-6.,2)
call symbol(x0+5.0,y0-6.-4.5*b,b,'1MeV',90.,4)
call plot(x0+6.0,y0,3) ; call plot(x0+6.0,y0-6.,2)
call symbol(x0+6.0,y0-6.-6.5*b,b,'100MeV',90.,6)
!
do i=n1u,ngu
   do j=n1u,ngu
      do k=1,lim
         if (c(j,i)>cl(k)) then ; kol(j,i)=kl(k) ; exit ; end if
      end do
   end do
end do
do i=n1u,ngu
   do j=n1u,ngu
      x(1)=x0+ep(i) ; x(2)=x0+ep(i+1) ; x(3)=x(2) ; x(4)=x(1) ; x(5)=x(1)
      y(1)=y0-ep(j) ; y(2)=y(1) ; y(3)=y0-ep(j+1) ; y(4)=y(3) ; y(5)=y(1)
      call newpen(kol(j,i)) ; call fill(4,x,y)
      call newpen(merge(pens(8),0,kol(j,i)==0)) ; call line(5,x,y)
   end do
end do
!
call newpen(pens(6))
call symbol(8.05,0.75,.2,'Correlation coefficients',90.,24)
w=(y0-1.)/2.
x(1)=8.3 ; x(2)=x(1)+1. ; x(3)=x(2) ; x(4)=x(1) ; x(5)=x(1)
do k=1,lim
   if (k==1) then ; y(1)=y0-.5 ; else ; y(1)=y0/2.+w*cl(k-1) ; end if
   y(2)=y(1) ; y(3)=y0/2.+w*cl(k) ; y(4)=y(3) ; y(5)=y(1)
   call newpen(kl(k)) ; call fill(4,x,y)
   call newpen(merge(pens(8),0,kl(k)==0)) ; call line(5,x,y)
end do
call newpen(pens(6)) ; w=(y0-1.)/20
do i=-10,10
   yw=.5+w*(i+10)
   call plot(x(2),yw,3) ; call plot(x(2)+.3,yw,2)
   if (mod(i,2)/=0) cycle
   write (ch,'(f4.1)') i/10. ; call symbol(x(2)+.4,yw-b/2.,b,ch,0.,4)
end do
!
i=ixkey()
call plot(0.,0.,999)
!
end subroutine two_dim
!
!
subroutine three_dim(t1,t2,nu1,ngu,ngu1,e,cor,ibid,res,pens,noc,nol)
character*(*) t1,t2
integer i,ibid,ixkey,j,k,nu1,ngu,ngu1,noc,nol,res
integer, dimension (8) :: pens
real, dimension (ngu,ngu) :: cor
real, dimension (ngu1) :: e,ep
real, dimension (5) :: x,y
real :: b=0.12,x0=5.0,y0=4.5
real a,cij,f,wx,wy,x1,x2,x3,x4,xl,dxl,xr,dxr,y1,y2,y3,y4,yl,dyl,yr,dyr,z
!
dxr(z)=+.99228*z ; xr(z)=x0+dxr(z)
dyr(z)=-.06201*z ; yr(z)=y0+dyr(z)
dxl(z)=-.75258*z ; xl(z)=x0+dxl(z)
dyl(z)=-.32825*z ; yl(z)=y0+dyl(z)
!
ep(nu1:ngu1)=.4*(alog10(e(nu1:ngu1))+10.)
!
call plots(0,ibid,res)
x(1)=0.2 ; x(2)=10.8 ; x(3)=10.8 ; x(4)=0.2
y(1)=0.2 ; y(2)=0.2 ; y(3)=7.0 ; y(4)=7.0
call newpen(pens(7))
call fill(4,x,y)
i=(noc-len(t1))/2
if (nol>25) then
   call gtext(4,i,t1) ; call gtext(6,i,t2)
else
   call gtext(1,i,t1) ; call gtext(2,i,t2)
end if
!
x(1)=xl(4.8) ; x(2)=x(1)+dxr(4.8) ; x(3)=xr(4.8) ; x(4)=x0 ; x(5)=x(1)
y(1)=yl(4.8) ; y(2)=y(1)+dyr(4.8) ; y(3)=yr(4.8) ; y(4)=y0 ; y(5)=y(1)
call newpen(pens(3)) ; call fill(4,x,y)
call newpen(0) ; call line(5,x,y)
call newpen(pens(6))
a=atan(dyr(1.)/dxr(1.))*57.3
call plot(xl(0.4),yl(0.4),3) ; call plot(dxr(5.2),dyr(5.2),12)
call where(wx,wy,f)
call symbol(wx+dxr(.1),wy+dyr(.1),b,'1meV',a,4)
call plot(xl(1.6),yl(1.6),3) ; call plot(dxr(5.2),dyr(5.2),12)
call where(wx,wy,f)
call symbol(wx+dxr(.1),wy+dyr(.1),b,'1eV',a,3)
call plot(xl(2.8),yl(2.8),3) ; call plot(dxr(5.2),dyr(5.2),12)
call where(wx,wy,f)
call symbol(wx+dxr(.1),wy+dyr(.1),b,'1keV',a,4)
call plot(xl(4.0),yl(4.0),3) ; call plot(dxr(5.2),dyr(5.2),12)
call where(wx,wy,f)
call symbol(wx+dxr(.1),wy+dyr(.1),b,'1MeV',a,4)
call plot(xl(4.8),yl(4.8),3) ; call plot(dxr(5.2),dyr(5.2),12)
call where(wx,wy,f)
call symbol(wx+dxr(.1),wy+dyr(.1),b,'100MeV',a,6)
a=atan(dyl(1.)/dxl(1.))*57.3
call plot(xr(0.4),yr(0.4),3) ; call plot(dxl(5.2),dyl(5.2),12)
call where(wx,wy,f)
call symbol(wx+dxl(7*b),wy+dyl(7*b),b,'1meV',a,4)
call plot(xr(1.6),yr(1.6),3) ; call plot(dxl(5.2),dyl(5.2),12)
call where(wx,wy,f)
call symbol(wx+dxl(6*b),wy+dyl(6*b),b,'1eV',a,3)
call plot(xr(2.8),yr(2.8),3) ; call plot(dxl(5.2),dyl(5.2),12)
call where(wx,wy,f)
call symbol(wx+dxl(7*b),wy+dyl(7*b),b,'1keV',a,4)
call plot(xr(4.0),yr(4.0),3) ; call plot(dxl(5.2),dyl(5.2),12)
call where(wx,wy,f)
call symbol(wx+dxl(7*b),wy+dyl(7*b),b,'1MeV',a,4)
call plot(xr(4.8),yr(4.8),3) ; call plot(dxl(5.2),dyl(5.2),12)
call where(wx,wy,f)
call symbol(wx+dxl(9*b),wy+dyl(9*b),b,'100MeV',a,6)
!
do i=nu1,ngu
   do j=nu1,ngu
      cij=cor(i,j)*1.75
      x(1)=xl(ep(j+1))+dxr(ep(i)) ; x1=x(1)
      x(2)=x1+dxr(ep(i+1)-ep(i)) ; x2=x(2)
      x(3)=xl(ep(j))+dxr(ep(i+1)) ; x3=x(3)
      x(4)=x3+dxr(ep(i)-ep(i+1)) ; x4=x(4)
      x(5)=x(1)
      y(1)=yl(ep(j+1))+dyr(ep(i)) ; y1=y(1)
      y(2)=y1+dyr(ep(i+1)-ep(i)) ; y2=y(2)
      y(3)=yl(ep(j))+dyr(ep(i+1)) ; y3=y(3)
      y(4)=y3+dyr(ep(i)-ep(i+1)) ; y4=y(4)
      y(5)=y(1)
!     top or bottom
      do k=1,5 ; y(k)=y(k)+cij ; end do
      call newpen(pens(3))
      call fill(4,x,y)
      call newpen(0)
      call line(5,x,y)
      if (cij<0.) then
!        back
         x(1)=x4 ; x(2)=x3 ; x(3)=x3 ; x(4)=x4 ; x(5)=x(1)
         y(1)=y4+cij ; y(2)=y3+cij ; y(3)=y3 ; y(4)=y4 ; y(5)=y(1)
         call newpen(pens(1))
         call fill(4,x,y)
         call newpen(0)
         call line(5,x,y)
!        left side
         x(1)=x1 ; x(2)=x1 ; x(3)=x4 ; x(4)=x4 ; x(5)=x(1)
         y(1)=y1 ; y(2)=y1+cij ; y(3)=y4+cij ; y(4)=y4 ; y(5)=y(1)
         call newpen(pens(2))
         call fill(4,x,y)
         call newpen(0)
         call line(5,x,y)
      end if
      if (cij/=0.) then
!        front
         x(1)=x1 ; x(2)=x2 ; x(3)=x2 ; x(4)=x1 ; x(5)=x(1)
         y(1)=y1 ; y(2)=y2 ; y(3)=y2+cij ; y(4)=y1+cij ; y(5)=y(1)
         call newpen(pens(1))
         call fill(4,x,y)
         call newpen(0)
         call line(5,x,y)
!        right side
         x(1)=x2 ; x(2)=x2 ; x(3)=x3 ; x(4)=x3 ; x(5)=x(1)
         y(1)=y2+cij ; y(2)=y2 ; y(3)=y3 ; y(4)=y3+cij ; y(5)=y(1)
         call newpen(pens(2))
         call fill(4,x,y)
         call newpen(0)
         call line(5,x,y)
      end if
   end do
end do
!
x(1)=xl(4.8) ; x(2)=x(1)+dxr(4.8)
x(3)=xl(ep(ngu1))+dxr(4.8) ; x(4)=xl(ep(ngu1))
y(1)=yl(4.8) ; y(2)=y(1)+dyr(4.8)
y(3)=yl(ep(ngu1))+dyr(4.8) ; y(4)=yl(ep(ngu1))
call newpen(pens(3))
call fill(4,x,y)
x(1)=xl(ep(ngu1))+dxr(4.8) ; x(2)=xr(4.8)
x(3)=xr(ep(ngu1)) ; x(4)=xl(ep(ngu1))+dxr(ep(ngu1))
y(1)=yl(ep(ngu1))+dyr(4.8) ; y(2)=yr(4.8)
y(3)=yr(ep(ngu1)) ; y(4)=yl(ep(ngu1))+dyr(ep(ngu1))
call fill(4,x,y)
call newpen(0)
x(1)=xl(ep(ngu1)) ; x(2)=xl(4.8) ; x(3)=x(2)+dxr(4.8)
x(4)=xr(4.8) ; x(5)=xr(ep(ngu1))
y(1)=yl(ep(ngu1)) ; y(2)=yl(4.8) ; y(3)=y(2)+dyr(4.8)
y(4)=yr(4.8) ; y(5)=yr(ep(ngu1))
call line(5,x,y)
!
i=ixkey()
call plot(0.,0.,999)
end subroutine three_dim
!
!
!
subroutine line(n,x,y)
integer, intent (in) :: n
real, dimension (n), intent (in) :: x,y
integer i
call plot(x(1),y(1),3)
do i=2,n ; call plot(x(i),y(i),2) ; end do
end subroutine line
!
!
subroutine symbol(xf,yf,ht,char,ang,nchar)
!
!  plot a character string
!
!  xf    = horizontal position of the bottom-left corner of
!          the first character field
!  yf    = vertical position of the bottom-left corner of
!          the first character field
!  ht    = height of the character fields
!  char  = character string (ascii 32...127)
!  ang   = angle from the positive x-axis (in grad)
!  nchar = number of the characters in the string
!
integer, intent(in) :: nchar
real, intent(in) :: xf,yf,ht,ang
character (len=1), intent (in), dimension (nchar) :: char
integer (kind=2), dimension (95) :: index
integer (kind=2), dimension (120) :: j1,j2,j3,j4,j5
integer (kind=2), dimension (122) :: j6
integer (kind=2), dimension (722) :: jndex
equivalence (jndex(1),j1(1)),(jndex(121),j2(1)),(jndex(241),j3(1)),   &
   &   (jndex(361),j4(1)),(jndex(481),j5(1)),(jndex(601),j6(1))
real cosa,gradrad,five7,sina,winkli,x,xb,xc,xs,y,yc,ys
integer i,ic,ii,j,k,l,nc,nkli
parameter (gradrad=1.74533e-2,five7=5./7.)
data index/  1,  2,  7, 12, 21, 32, 45, 58, 61, 66, 71, 78,  &
   &        83, 90, 93, 99,102,113,119,127,136,142,152,162,  &
   &       166,183,193,204,216,220,225,229,238,251,260,274,  &
   &       283,292,299,305,316,323,330,338,346,350,358,365,  &
   &       375,383,395,405,418,423,430,436,444,449,455,460,  &
   &       465,468,473,477,480,483,493,501,508,516,526,533,  &
   &       544,551,559,567,575,581,593,599,609,617,625,632,  &
   &       641,649,656,660,668,677,686,691,701,706,716/
data j1/  0,175, 47,177, 53,  0,162, 35,199, 70,  0,157,  &
   &     35,199, 65,141, 85,143, 87,  0,140, 75, 85, 77,  &
   &     23, 15, 25, 88,181, 47,  0,145, 35, 34, 16, 17,  &
   &    208, 20,193, 83, 84, 66, 65,  0,204, 56, 29, 12,  &
   &     13, 32, 52, 44, 26, 16, 32, 83,  0,190, 52,  0,  &
   &    199, 51, 49, 65,  0,163, 51, 49, 29,  0,142, 86,  &
   &    198, 30,162, 66,  0,142, 86,180, 48,  0,184, 38,  &
   &     39, 57, 55, 45,  0,142, 86,  0,157, 47, 48, 30,  &
   &     29,  0,148, 80,  0,148, 12, 16, 26, 80, 88, 84,  &
   &     74, 20, 80,  0,162, 53, 47,157, 65,  0,144, 26/
data j2/ 80, 88, 87, 11, 83,  0,145, 89, 51, 85, 84, 74,  &
   &     20, 12,  0,193, 71, 53, 13, 85,  0,140, 20, 74,  &
   &     84, 86, 78, 15, 17, 89,  0,181, 13, 12, 20, 74,  &
   &     84, 85, 77, 23,  0,145, 89, 29,  0,151, 15, 16,  &
   &     26, 80, 88, 87, 77, 23, 13, 12, 20, 74, 84, 85,  &
   &     77,  0,175, 87, 88, 80, 26, 16, 15, 23, 77,  0,  &
   &    157, 47, 48, 30, 29,160, 50, 51, 33, 32,  0,175,  &
   &     29, 30, 48, 46, 36,160, 50, 51, 33, 32,  0,193,  &
   &     14, 71,  0,141, 85,215, 15,  0,139, 68, 17,  0,  &
   &    144, 26, 80, 88, 87, 49,175, 47,  0,215, 51, 41/
data j3/ 49, 85, 88, 80, 35, 15, 13, 29, 83,  0,139, 14,  &
   &     44, 62, 86, 83,213, 13,  0,139, 74, 84, 85, 77,  &
   &     23,205, 87, 88, 80, 17,154, 20,  0,212, 74, 20,  &
   &     12, 16, 26, 80, 88,  0,139, 65, 85, 87, 71, 17,  &
   &    154, 20,  0,211, 11, 17, 89,142, 68,  0,139, 17,  &
   &     89,142, 68,  0,178, 86, 84, 74, 20, 12, 16, 26,  &
   &     80, 88,  0,139, 17,217, 83,142, 86,  0,157, 65,  &
   &    175, 53,163, 71,  0,140, 20, 56, 66, 71,172, 80,  &
   &      0,139, 17,217, 32, 14,160, 83,  0,145, 11, 83,  &
   &      0,139, 17, 34, 50, 70, 89, 83,  0,139, 17, 34/
data j4/ 66, 83, 89,  0,140, 16, 26, 80, 88, 84, 74, 20,  &
   &     12,  0,139, 17, 71, 88, 87, 68, 14,  0,148, 12,  &
   &     16, 26, 80, 88, 85, 47, 20,177, 83,  0,139, 17,  &
   &     71, 88, 87, 68, 14,187, 83,  0,140, 20, 74, 84,  &
   &     85, 77, 23, 15, 16, 26, 80, 88,  0,145, 89,181,  &
   &     47,  0,145, 12, 20, 74, 84, 89,  0,145, 15, 47,  &
   &     87, 89,  0,145, 12, 20, 50, 74, 84, 89,  0,148,  &
   &     80,154, 74,  0,145, 49, 47,177, 89,  0,154, 80,  &
   &     20, 74,  0,199, 35, 29, 65,  0,202, 26,  0,163,  &
   &     71, 65, 29,  0,143, 53, 87,  0,137, 90,  0,181/
data j5/ 61,  0,161, 69, 77, 74,204, 22, 12, 20, 92,  0,  &
   &    145, 11, 65, 75, 77, 69, 15,  0,206, 24, 14, 12,  &
   &     20, 74,  0,206, 24, 14, 12, 20, 74, 80,  0,141,  &
   &     85, 86, 78, 24, 14, 12, 20, 74,  0,199, 53, 43,  &
   &     38,142, 68,  0,202, 20, 12, 14, 24, 69, 77, 73,  &
   &     63, 27,  0,139, 17,143, 69, 77, 74,  0,148, 56,  &
   &    166, 42, 24,172, 44,  0,146, 54, 64, 69, 51,199,  &
   &     71,  0,148, 26,150, 31, 69,159, 65,  0,154, 44,  &
   &     38,148, 56,  0,139, 14, 24, 42, 50, 47,178, 60,  &
   &     78, 86, 83,  0,139, 15, 69, 77, 74,  0,148, 12/
data j6/ 14, 24, 78, 86, 84, 74, 20,  0,137, 15, 69, 77,  &
   &     75, 65, 11,  0,202, 20, 12, 14, 24, 78, 72,  0,  &
   &    139, 15,141, 33, 78, 86,  0,148, 74, 84, 76, 22,  &
   &     14, 24, 78,  0,143, 69,163, 30, 38, 74, 84,  0,  &
   &    143, 12, 20, 83,206, 74,  0,143, 47, 87,  0,143,  &
   &     12, 20, 50, 74, 84, 87,  0,139, 31, 49, 69,143,  &
   &     31,177, 65,  0,143, 12, 20, 74,206, 73, 63, 27,  &
   &      0,143, 69, 11, 65,  0,208, 62, 52, 51, 32, 49,  &
   &     48, 56, 74,  0,181, 51,177, 47,  0,154, 44, 52,  &
   &     51, 68, 49, 48, 38, 20,  0,144, 26, 44, 60, 78, 88,  0/
!
winkli=mod(ang,360.) ; nkli=nint(winkli)
if (abs(winkli-nkli)<.1) then
   if (nkli==0.) then
      sina=0. ; cosa=1.
   else if (nkli==90.or.nkli==-270) then
      sina=1. ; cosa=0.
   else if (nkli==180.or.nkli.eq.-180) then
      sina=0. ; cosa=-1.
   else if (nkli==270.or.nkli==-90) then
      sina=-1. ; cosa=0.
   else
      sina=sin(ang*gradrad) ; cosa=cos(ang*gradrad)
   end if
else
   sina=sin(ang*gradrad) ; cosa=cos(ang*gradrad)
end if
xs=ht*five7/12. ; ys=ht/8. ; xb=ht*1.1339 ; xc=xf ; yc=yf
do nc=1,nchar
   ic=ichar(char(nc))-31
   if (ic<1) ic=1
   if (ic>95) ic=32
   ii=index(ic)
   1 l=jndex(ii)
   if (l==0) go to 2
   k=2
   if (l>127) then ; k=3 ; l=l-128 ; end if
   j=l/9 ; i=l-9*j ; ii=ii+1
   x=xc+(j*xs*cosa-i*ys*sina)
   y=yc+(j*xs*sina+i*ys*cosa)
   call plot(x,y,k)
   go to 1
   2 xc=xc+xb*cosa
   yc=yc+xb*sina
   call plot(xc,yc,3)
end do
end subroutine symbol
