      SUBROUTINE ACTCLC(NR,NG,F,C,A,ZS)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     ACTIVITY CALCULATION USING THE UNMODIFIED DATA
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C***** DOUBLE *****
      DOUBLE PRECISION A,C,F
C***** DOUBLE *****
C***** SINGLE *****
C     REAL A,C,F
C***** SINGLE *****
      REAL ZS
      INTEGER I,J,NR,NG
      DIMENSION F(NG),C(NR,NG),A(NR),ZS(NG)
      REWIND (10)
      DO 1 I=1,NR
      READ (10) ZS
      DO 2 J=1,NG
    2 C(I,J)=ZS(J)
      A(I)=0.
      DO 3 J=1,NG
      C(I,J)=C(I,J)*F(J)
      A(I)=A(I)+C(I,J)
    3 CONTINUE
    1 CONTINUE
      RETURN
      END
      SUBROUTINE CHIDIS(N,CHILIM)
C-=-=-
C     MINIMUM & MAXIMUM VALUES OF THE CHI-SQUARE WITH 95 % PROBABILITY
C-=-=-
      INTEGER I,J,K,N
C***** DOUBLE *****
      DOUBLE PRECISION A,B,CHILIM
C***** DOUBLE *****
C***** SINGLE *****
C     REAL A,B,CHILIM
C***** SINGLE *****
      DIMENSION CHILIM(2),A(32),B(32)
      DATA A/
     1  .023,.068,.115,.160,.199,.234,.265,.292,
     2  .317,.339,.359,.377,.394,.410,.424,.437,
     3  .450,.461,.472,.492,.510,.525,.540,.553,
     4  .581,.605,.641,.669,.710,.734,.736,.783/
      DATA B/
     1  3.781,3.184,2.840,2.613,2.449,2.324,2.225,2.144,
     2  2.076,2.019,1.970,1.926,1.888,1.854,1.823,1.796,
     3  1.770,1.747,1.726,1.688,1.656,1.627,1.602,1.580,
     4  1.532,1.495,1.438,1.397,1.340,1.302,1.269,1.244/
      IF (N.LE.1) THEN
         CHILIM(1)=0D0
         CHILIM(2)=1D10
      ELSE IF (N.LE.20) THEN
         CHILIM(1)=A(N-1)
         CHILIM(2)=B(N-1)
      ELSE IF (N.LE.30) THEN
         I=N/2
         J=I+9
         K=2*I
         CHILIM(1)=A(J)+(N-K)*(A(J+1)-A(J))/2.
         CHILIM(2)=B(J)+(N-K)*(B(J+1)-B(J))/2.
      ELSE IF (N.LE.40) THEN
         I=N/5
         J=I+18
         K=5*I
         CHILIM(1)=A(J)+(N-K)*(A(J+1)-A(J))/5.
         CHILIM(2)=B(J)+(N-K)*(B(J+1)-B(J))/5.
      ELSE IF (N.LE.60) THEN
         I=N/10
         J=I+22
         K=10*I
         CHILIM(1)=A(J)+(N-K)*(A(J+1)-A(J))/10.
         CHILIM(2)=B(J)+(N-K)*(B(J+1)-B(J))/10.
      ELSE IF (N.LE.100) THEN
         I=N/20
         J=I+26
         K=20*I
         CHILIM(1)=A(J)+(N-K)*(A(J+1)-A(J))/20.
         CHILIM(2)=B(J)+(N-K)*(B(J+1)-B(J))/20.
      ELSE IF (N.LE.150) THEN
         I=N/25
         J=I+25
         K=25*I
         CHILIM(1)=A(J)+(N-K)*(A(J+1)-A(J))/25.
         CHILIM(2)=B(J)+(N-K)*(B(J+1)-B(J))/25.
      ELSE
         CHILIM(1)=A(32)
         CHILIM(2)=B(32)
      END IF
      RETURN
      END
      SUBROUTINE CNCTIO(PRD,L06,L613,NGLIB,IER,RINF,CONCHK)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CONNECTS THE I/O FILES TO THE LOGICAL UNITS
C     UNIT #0:  STANDARD ERROR OUTPUT
C     UNIT #1:  SCRATCH
C     UNIT #2:  SCRATCH
C     UNIT #3:  SCRATCH
C     UNIT #4:  PROBLEM-DEPENDENT X-SECTION LIBRARY
C     UNIT #5:  STANDARD INPUT
C     UNIT #6:  STANDARD OUTPUT
C     UNIT #7:  OUTPUT (ACTIVIY AND SPECTRUM WITH COVARIANCE MATRICES)
C     UNIT #8:  USER'S INPUT
C     UNIT #9:  SCRATCH
C     UNIT #10: SCRATCH
C     UNIT #11: SCRATCH
C     UNIT #13: DUMMY ('NUL') FILE
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      CHARACTER*72 TSKNAM,FILSP,FIL4,FIL6,FIL7,FIL8,DSC
      CHARACTER*3 CHNGUS
      CHARACTER*1 CHNGI,O
      INTEGER I,IER,L,L06,L613,LDSC,LFIL,LR,LTSKN,NGLIB
C***** DOUBLE *****
      DOUBLE PRECISION RINF
C***** DOUBLE *****
C***** SINGLE *****
C     REAL RINF
C***** SINGLE *****
      LOGICAL CONCHK,EX,EY,PRD
    1 FORMAT (A)
C***** IBM PC/AT *****
    2 FORMAT (/1X,A/' IS NOT IN THE CURRENT DIRECTORY.')
    3 FORMAT (/1X,A/' EXISTS IN THE CURRENT DIRECTORY.')
    4 FORMAT (' TYPE THE FILE-SPEC',
     1        ' ([DRIVE:][PATH]FILENAME.EXTENSION):'/)
    5 FORMAT (/' TYPE [DRIVE:][PATH\] FOR THE SCRATCH FILES:'/)
C***** IBM PC/AT *****
      PRD=.FALSE.
   10 WRITE (0,11)
   11 FORMAT (/' NAME OF THE TASK: ')
      READ (5,1) TSKNAM
      CALL LASTCH(TSKNAM,LTSKN)
      IF (LTSKN.EQ.0) GO TO 10
      FIL8=TSKNAM(1:LTSKN)//'.DAT'
      L=LTSKN+4
      INQUIRE (FILE=FIL8,EXIST=EX)
      IF (.NOT.EX) THEN
   12    WRITE (0,2) FIL8(1:L)
         WRITE (0,4)
         READ (5,1) FILSP
         FIL8=FILSP
         CALL LASTCH(FIL4,LFIL)
         IF (LFIL.EQ.0) GO TO 12
         INQUIRE(FILE=FIL8,EXIST=EY)
         IF (.NOT.EY) GO TO 30
      END IF
      FIL4=TSKNAM(1:LTSKN)//'.XSL'
      INQUIRE (FILE=FIL4,EXIST=EX)
      IF (.NOT.EX) THEN
   13    WRITE (0,2) FIL4(1:L)
         WRITE (0,4)
         READ (5,1) FILSP
         FIL4=FILSP
         CALL LASTCH(FIL4,LFIL)
         IF (LFIL.EQ.0) GO TO 13
         INQUIRE(FILE=FIL4,EXIST=EY)
         IF (.NOT.EY) GO TO 30
      END IF
      FIL7=TSKNAM(1:LTSKN)//'.OUT'
      INQUIRE (FILE=FIL7,EXIST=EX)
      IF (EX) THEN
   15    WRITE (0,3) FIL7(1:L)
   16    WRITE (0,17)
   17    FORMAT (' DO YOU WANT TO SCRATCH THE OLD VERSION {Y|N} ? '/)
         READ (5,1) O
         IF (O.EQ.'N' .OR. O.EQ.'n') THEN
            WRITE (0,4)
            READ (5,1) FILSP
            FIL7=FILSP
            CALL LASTCH(FIL7,LFIL)
            IF (LFIL.EQ.0) GO TO 15
            INQUIRE(FILE=FIL7,EXIST=EY)
            IF (EY) THEN
               GO TO 32
            ELSE
               OPEN (UNIT=7,FILE=FIL7,STATUS='NEW')
            END IF
         ELSE IF (O.EQ.'Y' .OR. O.EQ.'y') THEN
            OPEN (UNIT=7,FILE=FIL7,STATUS='OLD')
         ELSE
            GO TO 16
         END IF
      ELSE
         OPEN (UNIT=7,FILE=FIL7,STATUS='NEW')
      END IF
   20 WRITE (0,21)
   21 FORMAT (/' SELECT THE STANDARD OUTPUT {S|P|D}:'/
     1  ' ENTER "S" FOR THE SCREEN'/
     2  ' ENTER "P" FOR THE PRINTER'/
     3  ' ENTER "D" FOR THE DISK FILE taskname.LPT'/)
      READ (5,1) O
      IF (O.EQ.'P' .OR. O.EQ.'p') THEN
         OPEN (UNIT=6,FILE='PRN')
         WRITE (0,*)
     1      'PUT WIDE PAPER INTO PRINTER OR SET "CONDENSED" MODE'
         WRITE (0,*) 'HIT ENTER WHEN READY'
         READ (5,*)
   22    WRITE (0,23)
   23    FORMAT (' DO YOU WANT LOGGING THE USER''S INPUT ',
     1           'ON THE PRINTED LIST {Y|N} ? ')
         READ (5,1) O
         IF (O.EQ.'N'.OR.O.EQ.'n') THEN
            L613=13
         ELSE IF (O.EQ.'Y'.OR.O.EQ.'y') THEN
            L613=6
         ELSE
            GO TO 22
         END IF
         L06=6
      ELSE IF (O.EQ.'D' .OR. O.EQ.'d') THEN
         FIL6=TSKNAM(1:LTSKN)//'.LPT'
         INQUIRE (FILE=FIL6,EXIST=EX)
         IF (EX) THEN
   24       WRITE (0,3) FIL6(1:L)
   25       WRITE (0,17)
            READ (5,1) O
            IF (O.EQ.'N' .OR. O.EQ.'n') THEN
               WRITE (0,4)
               READ (5,1) FILSP
               FIL6=FILSP
               CALL LASTCH(FIL6,LFIL)
               IF (LFIL.EQ.0) GO TO 24
               INQUIRE(FILE=FIL6,EXIST=EY)
               IF (EY) THEN
                  CLOSE (7,STATUS='DELETE')
                  GO TO 32
               ELSE
                  PRD=.TRUE.
                  OPEN (UNIT=6,FILE=FIL6,STATUS='NEW')
               END IF
            ELSE IF (O.EQ.'Y' .OR. O.EQ.'y') THEN
               PRD=.TRUE.
               OPEN (UNIT=6,FILE=FIL6,STATUS='OLD')
            ELSE
               GO TO 25
            END IF
         ELSE
            PRD=.TRUE.
            OPEN (UNIT=6,FILE=FIL6,STATUS='NEW')
         END IF
   26    WRITE (0,23)
         READ (5,1) O
         IF (O.EQ.'N'.OR.O.EQ.'n') THEN
            L613=13
         ELSE IF (O.EQ.'Y'.OR.O.EQ.'y') THEN
            L613=6
         ELSE
            GO TO 26
         END IF
         L06=6
      ELSE IF (O.EQ.'S'.OR.O.EQ.'s') THEN
         L613=13
         L06=0
      ELSE
         GO TO 20
      END IF
      WRITE (0,5)
      READ (5,1) DSC
      CALL LASTCH(DSC,LDSC)
      FILSP=DSC(1:LDSC)//'STAYNL'
      L=LDSC+6
      DSC=FILSP(1:L)//'01.SCR'
      OPEN (UNIT=1,FILE=DSC,STATUS='UNKNOWN',FORM='UNFORMATTED')
      DSC=FILSP(1:L)//'02.SCR'
      OPEN (UNIT=2,FILE=DSC,STATUS='UNKNOWN',FORM='UNFORMATTED')
      DSC=FILSP(1:L)//'03.SCR'
      OPEN (UNIT=3,FILE=DSC,STATUS='UNKNOWN',FORM='UNFORMATTED')
      OPEN (UNIT=4,FILE=FIL4,STATUS='OLD',ACCESS='DIRECT',
     1   FORM='UNFORMATTED',RECL=1)
      DO 27 I=1,3
      READ (4,REC=I) CHNGI
      CHNGUS(I:I)=CHNGI
   27 CONTINUE
      READ (CHNGUS,34) NGLIB
      CLOSE (UNIT=4,STATUS='KEEP')
      LR=MAX((NGLIB+1)*4,54)
      OPEN (UNIT=4,FILE=FIL4,STATUS='OLD',ACCESS='DIRECT',
     1   RECL=LR,FORM='UNFORMATTED')
      OPEN (UNIT=8,FILE=FIL8,STATUS='OLD',FORM='FORMATTED')
      DSC=FILSP(1:L)//'09.SCR'
      OPEN (UNIT=9,FILE=DSC,STATUS='UNKNOWN',FORM='UNFORMATTED')
      DSC=FILSP(1:L)//'10.SCR'
      OPEN (UNIT=10,FILE=DSC,STATUS='UNKNOWN',FORM='UNFORMATTED')
      DSC=FILSP(1:L)//'11.SCR'
      OPEN (UNIT=11,FILE=DSC,STATUS='UNKNOWN',FORM='FORMATTED')
      OPEN (UNIT=13,FILE='NUL',STATUS='UNKNOWN')
      WRITE (0,*) 'TYPE YOUR VALUE FOR THE RELATIVE IMPORTANCE OF THE',
     1   ' NORMALIZATION FACTOR'
   28 WRITE (0,*) 'RINF = { 0 (NONE) | 1 (FULL) }'
      READ (5,*) RINF
      IF (RINF.NE.0.D0.AND.RINF.NE.1.D0) GO TO 28
      WRITE (0,*) 'DO YOU WANT TO PERFORM RIGOROUS CONSISTENCY CHECK?'
   29 WRITE (0,*) '{Y/N} ? '
      READ (5,'(A)') O
      IF (O.EQ.'Y'.OR.O.EQ.'y') THEN
         CONCHK=.TRUE.
      ELSE IF (O.EQ.'N'.OR.O.EQ.'n') THEN
         CONCHK=.FALSE.
      ELSE
         GO TO 29
      END IF
      RETURN
   30 IER=51
      WRITE (0,31) FILSP(1:L)
   31 FORMAT (/' ??? 51 ???'/1X,A/' DOES NOT EXIST.'//'SORRY.'//)
      RETURN
   32 IER=52
      WRITE (0,33) FILSP(1:L)
   33 FORMAT (/' ??? 52 ???'/1X,A/' ALREADY EXISTS.'//'SORRY.'//)
      RETURN
   34 FORMAT (I3)
      END
      SUBROUTINE CONSIS(NR,NG,NP,A0,A0M,F,A,FP,DW,NC,NS,DP,WP,
     1  DWP,BS,CHILIM,NFR,L,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     CALCULATION OF THE CHI-SQUARE AS CONSISTENCY PARAMETER
C
C     THE FORMULAE USED:
C
C     BEFORE AND AFTER SCALING (L=1,2):
C                        T          -1
C                  [A-Ao]  [COV(Ao)]   [A-Ao]
C
C     AFTER OPTIMAL NORMALIZATION (L=3) AND ADJUSTMENT (L=4):
C                        T                   -1
C                  [A-Ao]  [COV(Ao)  0      ]   [A-Ao]
C                  [F-Fo]  [0        COV(Fo)]   [F-Fo]
C
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C***** DOUBLE *****
      DOUBLE PRECISION A,A0,A0M,BS,CHILIM,CHISQ,DP,DW,DWP,F,FP,WP
C***** DOUBLE *****
C***** SINGLE *****
C     REAL A,A0,A0M,BS,CHILIM,CHISQ,DP,DW,DWP,F,FP,WP
C***** SINGLE *****
      INTEGER I,J,IER,L,NC,NFR,NG,NP,NR,NR1,NS
      DIMENSION A0(NR),A0M(NR,NR),F(NG),A(NR),FP(NG),DW(NR,NR),
     1  NC(NP),NS(NP),DP(NP),WP(NP,NP),DWP(NP,NP),BS(NP),
     2  CHILIM(2)
      NR1=NR+1
      DO 2 I=1,NR
      IF (L.EQ.1) THEN
         DP(I)=(A(I)-A0(I))/A0(I)
      ELSE
         DP(I)=(A(I)-A0(I))
      END IF
    2 CONTINUE
      IF (L.LT.3) THEN
         DO 103 I=1,NR
         DO 3 J=1,NR
         DW(J,I)=A0M(J,I)
         DW(I,J)=DW(J,I)
    3    CONTINUE
  103     CONTINUE
         CALL C2CALC(NR,DP,DW,WP,NC,NS,BS,CHISQ,IER)
         IF (IER.GT.0) THEN
            WRITE (6,4)
            WRITE (6,5)
    4       FORMAT (' ??? 21 ??? CONSISTENCY CHECK FAILED.')
    5       FORMAT (12X,'THE COVARIANCE MATRIX OF THE MEASURED',
     1         ' ACTIVITIES:')
            DO 6 I=1,NR
            WRITE (6,9) (A0M(J,I),J=1,I)
    6       CONTINUE
    9       FORMAT (1P,10E12.3)
            RETURN
         END IF
      ELSE
         REWIND (1)
         DO 113 I=1,NR
         DO 11 J=1,I
         DWP(J,I)=A0M(J,I)
   11    CONTINUE
         DO 12 J=NR1,NP
C***** DOUBLE *****
         DWP(J,I)=0.D0
C***** DOUBLE *****
C***** SINGLE *****
C        DWP(J,I)=0.
C***** SINGLE *****
   12    CONTINUE
         DO 13 J=1,NP
         DWP(I,J)=DWP(J,I)
   13    CONTINUE
  113    CONTINUE
         DO 114 I=NR1,NP
         READ (1) (WP(J,I),J=NR1,NP)
         DO 14 J=NR1,NP
         DWP(J,I)=WP(J,I)
   14    CONTINUE
  114    CONTINUE
         DO 115 I=1,NP
         DO 15 J=1,I
         WP(J,I)=DWP(J,I)
   15    CONTINUE
  115    CONTINUE
         DO 16 I=NR1,NP
         J=I-NR
         DP(I)=(FP(J)-F(J))/F(J)
   16    CONTINUE
         CALL C2CALC(NP,DP,DWP,WP,NC,NS,BS,CHISQ,IER)
         IF (IER.GT.1) THEN
            WRITE (6,4)
            WRITE (6,17)
   17       FORMAT (12X,'THE COVARIANCE MATRIX OF THE MEASURED',
     1         ' ACTIVITIES AND THE SPECTRUM:')
            DO 18 I=1,NP
            WRITE (6,9) (WP(J,I),J=1,I)
   18       CONTINUE
            RETURN
         END IF
      END IF
      IF (L.EQ.1) THEN
         WRITE (6,21) CHISQ
   21    FORMAT (/' CHI-SQUARE/N BEFORE SCALING:',F40.3)
      ELSE IF (L.EQ.2) THEN
         WRITE (6,22) CHISQ
   22    FORMAT (/' CHI-SQUARE/N AFTER SCALING, BEFORE',
     1           ' OPTIMAL NORMALIZATION:',F11.3)
      ELSE IF (L.EQ.3) THEN
         WRITE (6,23) CHISQ
   23    FORMAT (/' CHI-SQUARE/N AFTER NORMALIZATION,',
     1           ' BEFORE ADJUSTMENT:',F16.3)
      ELSE
         WRITE (6,24) CHISQ
   24    FORMAT (/' CHI-SQUARE/N AFTER ADJUSTMENT:',F38.3)
      END IF
      WRITE (6,25) NFR
   25 FORMAT (' N (DEGREE OF FREEDOM):',I46)
      CALL CNF95(CHILIM(1),CHILIM(2))
      IF (L.EQ.1) RETURN
      IF (CHISQ.LT.CHILIM(1)) THEN
         WRITE (6,26)
         IER=12
      END IF
      IF (CHISQ.GT.CHILIM(2)) THEN
         WRITE (6,27)
         IER=13
      END IF
   26 FORMAT (' ??? 12 ??? WARNING. THE CHI-SQUARE IS TOO LOW!')
   27 FORMAT (' ??? 13 ??? WARNING. THE CHI-SQUARE IS TOO HIGH!')
      RETURN
      END
      SUBROUTINE ERXPLN(IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     EXPLAIN THE ERROR CODE(S) AND SET DOS RETURN CODE
C     STOP 0: NO ERRORS
C     STOP 1: ERRONEOUS VALUE IN THE INPUT
C     STOP 2: ERRONEOUS KEYWORD IN THE INPUT
C     STOP 3: LACK OF DATA IN THE ENDF-6 CROSS SECTION LIBRARY
C     STOP 4: ERRONEOUS I/O ORGANIZATION
C     STOP 5: FATAL PROGRAM AND/OR ENDF-6 LIBRARY ERROR
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER IER,JER,K,LER
      DIMENSION LER(11:61)
      DATA LER/51*0/
      IF (IER.EQ.0) STOP
      WRITE (6,1)
      IF (LER(11).GT.0) WRITE (6,11) LER(11)
      IF (LER(12).GT.0) WRITE (6,12) LER(12)
      IF (LER(13).GT.0) WRITE (6,13) LER(13)
      IF (LER(21).GT.0) WRITE (6,21) LER(21)
      IF (LER(30).GT.0) WRITE (6,30) LER(30)
      IF (LER(31).GT.0) WRITE (6,31) LER(31)
      IF (LER(32).GT.0) WRITE (6,32) LER(32)
      IF (LER(33).GT.0) WRITE (6,33) LER(33)
      IF (LER(34).GT.0) WRITE (6,34) LER(34)
      IF (LER(35).GT.0) WRITE (6,35) LER(35)
      IF (LER(36).GT.0) WRITE (6,36) LER(36)
      IF (LER(37).GT.0) WRITE (6,37) LER(37)
      IF (LER(38).GT.0) WRITE (6,38) LER(38)
      IF (LER(39).GT.0) WRITE (6,39) LER(39)
      IF (LER(41).GT.0) WRITE (6,41) LER(41)
      IF (LER(51).GT.0) WRITE (6,51) LER(51)
      IF (LER(52).GT.0) WRITE (6,52) LER(52)
      IF (LER(53).GT.0) WRITE (6,53) LER(52)
      JER=IER/10
      IF (JER.EQ.1) STOP 1
      IF (JER.EQ.2) STOP 2
      IF (JER.EQ.3) STOP 3
      IF (JER.EQ.4) STOP 4
      IF (JER.EQ.5) STOP 5
      STOP 'ILLEGAL IER CODE'
    1 FORMAT (' SUMMARY OF ERROR MESSAGES'//
     1        ' CASES     EXPLANATION'//)
   11 FORMAT (I6,5X,'?11 UNUSUAL VALUE IN THE USER''S INPUT')
   12 FORMAT (I6,5X,'?12 TOO LOW CHI-SQUARE')
   13 FORMAT (I6,5X,'?12 TOO HIGH CHI-SQUARE')
   21 FORMAT (I6,5X,'?21 SINGULAR COVARIANCE MATRIX')
   30 FORMAT (I6,5X,'?30 ERRONEOUS CORRELATION COEFFICIENT')
   31 FORMAT (I6,5X,'?31 NUMBER OF DETECTORS INCORRECT (KEYWORD READ)')
   32 FORMAT (I6,5X,'?32 NUMBER OF DETECTORS INCORRECT (EOF READ)')
   33 FORMAT (I6,5X,'?33 ILLEGAL COVER DATA')
   34 FORMAT (I6,5X,'?34 ERRONEOUS REACTION RATE')
   35 FORMAT (I6,5X,'?35 ERRONEOUS STD OF THE REACTION RATE')
   36 FORMAT (I6,5X,'?36 ERRONEOUS ENERGY GRID')
   37 FORMAT (I6,5X,'?37 ERRONEOUS GROUP FLUX')
   38 FORMAT (I6,5X,'?38 ERRONEOUS STD OF THE GROUP FLUX')
   39 FORMAT (I6,5X,'?39 ERRONEOUS CROSS SECTION LIBRARY OR WRONG DETECT
     1OR DESCRIPTION IN THE USER''S INPUT)')
   41 FORMAT (I6,5X,'?41 ERRONEOUS KEYWORD')
   51 FORMAT (I6,5X,'?51 FATAL DOS ERROR (MISSING DATA SET)')
   52 FORMAT (I6,5X,'?52 FATAL DOS ERROR (EXISTING DATA SET)')
   53 FORMAT (I6,5X,'?53 FATAL I/O ERROR USING THE USER''S INPUT')
   61 FORMAT (I6,5X,'?61 INSUFFICIENT MEMORY. MODIFY STAYPARM.FOR AND CO
     1MPILE AND LINK THE CODE. THEN RUN THE JOB AGAIN.')
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      ENTRY ERRLOG(K)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     COUNT THE ERROR MESSAGES
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      LER(K)=LER(K)+1
      RETURN
      END
      SUBROUTINE HEAD(TITLE,L,L06,IER)
      CHARACTER TITLE*72,SUBTITLE(3)*45,CMONTH(12)*3,MINUCH*2
      INTEGER YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,L,L06,IER
      DATA SUBTITLE/
     1  'TOP OF THE LOG',
     2  'OUTPUT OF THE NEUTRON SPECTRUM ADJUSTMENT JOB',
     3  'END OF JOB'/
      DATA CMONTH/
     1  'JAN','FEB','MAR','APR','MAY','JUN',
     2  'JUL','AUG','SEP','OCT','NOV','DEC'/
      CALL TODAY(YEAR,MONTH,DAY)
      CALL OCLOCK(HOUR,MINUTE,SECOND)
      MINUCH=CHAR(MINUTE/10+48)//CHAR(MOD(MINUTE,10)+48)
      WRITE (L06,1) CMONTH(MONTH),DAY,YEAR,HOUR,MINUCH
    1 FORMAT (''/////////////
     1   17X,' SSSS   TTTTT     A     Y   Y   N   N    L    '/
     2   17X,'S         T      A A     Y Y    NN  N    L    '/
     3   17X,' SSS      T     A   A     Y     N N N    L    '/
     4   17X,'    S     T     AAAAA     Y     N  NN    L    '/
     5   17X,'SSSS      T     A   A     Y     N   N    LLLLL'//
     6   17X,'VERSION 95-1',13X,A3,I3,',',I5,I6,':',A2////)
      IF (L.EQ.0) RETURN
      IF (L.EQ.1) WRITE (7,2) CMONTH(MONTH),DAY,YEAR,HOUR,MINUCH
      WRITE (L06,3) TITLE
      IF (L.EQ.3) THEN
         WRITE (L06,4) SUBTITLE(L),IER
      ELSE
         WRITE (L06,3) SUBTITLE(L)
      END IF
      IF (L.EQ.2) WRITE (L06,5)
    2 FORMAT('STAYNL/PC VERSION 95-1',3X,A3,I3,',',I5,I6,':',A2)
    3 FORMAT (1X,A//)
    4 FORMAT (1X,A/' CONDITION CODE =',I4//)
    5 FORMAT(' THE " %" VALUES ARE 1 SIGMAS (67 % CONF. LEVEL)'//)
      RETURN
      END
      SUBROUTINE PRENRM(NR,NG,NAME,A0,A0M,F,C,A,SCFACT)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     DETERMINE THE ROUGH NORMALIZATION (SCALING) FACTOR
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C***** DOUBLE *****
      DOUBLE PRECISION A,A0,A0M,C,ENTIER,F,R,SCFACT
C***** DOUBLE *****
C***** SINGLE *****
C     REAL A,A0,A0M,C,ENTIER,F,R,SCFACT
C***** SINGLE *****
      INTEGER I,J,NG,NR
      CHARACTER*60 NAME
      DIMENSION NAME(NR),A0(NR),A0M(NR,NR),F(NG),C(NR,NG),A(NR)
      SCFACT=0.
      DO 1 I=1,NR
      SCFACT=SCFACT+A0(I)/A(I)
    1 CONTINUE
      SCFACT=10.**(ENTIER(LOG10(SCFACT/NR)+.5))
      DO 2 I=1,NR
      A(I)=A(I)*SCFACT
    2 CONTINUE
      DO 103 I=1,NR
      DO 3 J=1,I
      A0M(J,I)=A0M(J,I)*A0(I)*A0(J)
      A0M(I,J)=A0M(J,I)
    3 CONTINUE
  103  CONTINUE
      DO 105 I=1,NR
      DO 5 J=1,NG
      C(I,J)=C(I,J)*SCFACT
    5 CONTINUE
  105 CONTINUE
      DO 6 I=1,NG
      F(I)=F(I)*SCFACT
    6 CONTINUE
      WRITE (6,10) SCFACT
   10 FORMAT (/' THE INPUT SPECTRUM HAS BEEN SCALED',
     1         ' BY MULTIPLICATION WITH',1P,E11.1)
      WRITE (6,11)
   11 FORMAT (/'  NO.    CALC/EXP    DETECTOR IDENTIFICATION'/)
      DO 12 I=1,NR
      R=A(I)/A0(I)
      WRITE (6,13) I,R,NAME(I)
   12 CONTINUE
   13 FORMAT (I5,F12.3,5X,A60)
      RETURN
      END
      SUBROUTINE READER(L613,NR,NG,NG1,NAME60,A0,SDA0R,A0M,
     1    EL,F,SDFR,FM,EN,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     READ THE USER'S DATA AND WRITE THE INPUT LOG
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C***** DOUBLE *****
      DOUBLE PRECISION A0,A0M,C11,EL,F,FM,SDA0R,SDFR,SI,WSP
C***** DOUBLE *****
C***** SINGLE *****
C     REAL A0,A0M,C11,EL,F,FM,SDA0R,SDFR,SI
C***** SINGLE *****
      REAL EN
      INTEGER I,IER,J,JER,L613,L811,NG,NG1,NR
      CHARACTER*80 SPECID,CARD
      CHARACTER*60 NAME60
      CHARACTER*5 KEYW2
      CHARACTER*3 KEYW0,KEYW1
      LOGICAL ALTRET,PAGE
      DIMENSION A0(NR),SDA0R(NR),A0M(NR,NR),EL(NG1),F(NG),
     1  SDFR(NG),FM(NG,NG),NAME60(NR),EN(NG1),WSP(640)
    1 FORMAT (/' ??? 41 ??? KEYWORD ERROR: ',A)
    2 FORMAT ('1'//' INPUT LOG:'//2I5)
    3 FORMAT (/1X,A)
    4 FORMAT (12F10.3)
    5 FORMAT (1P,12E10.3)
    6 FORMAT (A)
    7 FORMAT ('')
      JER=0
      PAGE=L613.EQ.13
C-=-=-
C     NUMBER OF REACTIONS, NUMBER OF ENERGY GROUPS
C-=-=-
      WRITE (L613,2) NR,NG
      CALL NOCOMM(8,L811)
C-=-=-
C     REACTIONS
C-=-=-
      CALL USERQL(L613,L811,NR,NG,NG1,EN,A0,NAME60,JER)
      IER=MAX(IER,JER)
      DO 12 I=1,NR
      IF (A0(I).LE.0.) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,11) I,NAME60(I),A0(I)
   11    FORMAT (/I3,3X,A,1P,E13.4/,' ??? 34 ??? MEANINGLESS ACTIVITY!')
         IER=MAX(IER,34)
         CALL ERRLOG(34)
      END IF
   12 CONTINUE
C-=-=-
C     COVARIANCE MATRIX OF ACTIVITIES
C-=-=-
      CALL TRALER(L811,CARD,L613,ALTRET)
      IF (ALTRET) GO TO 99
      KEYW1=CARD(1:3)
      WRITE (L613,3) KEYW1
      IF (KEYW1.EQ.'STD') THEN
         READ (L811,*,ERR=99,END=99) SDA0R
         WRITE (L613,4) SDA0R
         CALL TRALER(L811,CARD,L613,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW2=CARD(1:5)
         WRITE (L613,3) KEYW2
         IF (KEYW2.EQ.'UPPER') THEN
            READ (L811,*,END=99) ((A0M(J,I),J=1,I),I=1,NR)
            DO 13 I=1,NR
            WRITE (L613,4) (A0M(J,I),J=1,I)
   13       CONTINUE
         ELSE IF (KEYW2.EQ.'LOWER') THEN
            READ (L811,*,END=99) ((A0M(J,I),J=I,NR),I=1,NR)
            DO 14 I=1,NR
            WRITE (L613,4) (A0M(J,I),J=I,NR)
   14       CONTINUE
         ELSE IF (KEYW2.EQ.'QUADR') THEN
            READ (L811,*,END=99) A0M
            DO 15 I=1,NR
            WRITE (L613,4) (A0M(J,I),J=1,NR)
   15       CONTINUE
         ELSE
            WRITE (6,1) KEYW2
            IER=MAX(IER,41)
            CALL ERRLOG(41)
            RETURN
         END IF
      ELSE IF (KEYW1.EQ.'MIX') THEN
         CALL TRALER(L811,CARD,L613,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW2=CARD(1:5)
         WRITE (L613,3) KEYW2
         IF (KEYW2.EQ.'UPPER') THEN
            READ (L811,*,END=99) (SDA0R(I),(A0M(J,I),J=1,I),I=1,NR)
            DO 16 I=1,NR
            WRITE (L613,4) SDA0R(I)
            WRITE (L613,4) (A0M(J,I),J=1,I)
   16       CONTINUE
         ELSE IF (KEYW2.EQ.'LOWER') THEN
            READ (L811,*,END=99) (SDA0R(I),(A0M(J,I),J=I,NR),I=1,NR)
            DO 17 I=1,NR
            WRITE (L613,4) SDA0R(I)
            WRITE (L613,4) (A0M(J,I),J=I,NR)
   17       CONTINUE
         ELSE IF (KEYW2.EQ.'QUADR') THEN
            READ (L811,*) (SDA0R(I),(A0M(J,I),J=1,NR),I=1,NR)
            DO 18 I=1,NR
            WRITE (L613,4) SDA0R(I)
            WRITE (L613,4) (A0M(J,I),J=1,NR)
   18       CONTINUE
         ELSE
            WRITE (6,1) KEYW2
            IER=MAX(IER,41)
            CALL ERRLOG(41)
            RETURN
         END IF
      ELSE IF (KEYW1.EQ.'REL') THEN
         CALL TRALER(L811,CARD,L613,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW2=CARD(1:5)
         WRITE (L613,3) KEYW2
         IF (KEYW2.EQ.'UPPER') THEN
            READ (L811,*,END=99) ((A0M(J,I),J=1,I),I=1,NR)
            DO 19 I=1,NR
            WRITE (L613,4) (A0M(J,I),J=1,I)
   19       CONTINUE
         ELSE IF (KEYW2.EQ.'LOWER') THEN
            READ (L811,*,END=99) ((A0M(J,I),J=I,NR),I=1,NR)
            DO 20 I=1,NR
            WRITE (L613,4) (A0M(J,I),J=I,NR)
   20       CONTINUE
         ELSE IF (KEYW2.EQ.'QUADR') THEN
            READ (L811,*) ((A0M(J,I),J=1,NR),I=1,NR)
            DO 21 I=1,NR
            WRITE (L613,4) (A0M(J,I),J=1,NR)
   21       CONTINUE
         ELSE
            WRITE (6,1) KEYW2
            IER=MAX(IER,41)
            CALL ERRLOG(41)
            RETURN
         END IF
         DO 22 I=1,NR
         SDA0R(I)=SQRT(A0M(I,I))
   22    CONTINUE
      ELSE
         WRITE (6,1) KEYW1
         IER=MAX(IER,41)
         CALL ERRLOG(41)
         RETURN
      END IF
      DO 32 I=1,NR
      IF (SDA0R(I).LE.0.D0) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,30) I,NAME60(I),SDA0R(I)
   30    FORMAT (/I3,3X,A,F12.5/
     1      ' ??? 35 ??? MEANINGLESS ACTIVITY STD!')
         IER=MAX(IER,35)
         CALL ERRLOG(35)
      ELSE IF (SDA0R(I).LT.1.D0 .OR. SDA0R(I).GT.10.D0) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,31) I,NAME60(I),SDA0R(I)
   31    FORMAT (/I3,3X,A,F12.5/
     1      ' ??? 11 ??? CHECK THE ACTIVITY STD VALUE!')
         IER=MAX(IER,11)
         CALL ERRLOG(11)
      END IF
   32 CONTINUE
      IF (KEYW2.EQ.'UPPER') THEN
         DO 140 J=2,NR
         DO 40 I=1,J-1
         A0M(J,I)=A0M(I,J)
   40    CONTINUE
  140     CONTINUE
      ELSE IF (KEYW2.EQ.'LOWER') THEN
         DO 141 J=2,NR
         DO 41 I=1,J-1
         A0M(I,J)=A0M(J,I)
   41    CONTINUE
  141    CONTINUE
      END IF
      C11=A0M(1,1)
      DO 143 I=1,NR
      DO 43 J=1,I
      A0M(J,I)=A0M(J,I)/C11
      IF ((I.EQ.J).AND.DABS(A0M(J,I)-1.D0).GT..00001D0
     1   .OR. A0M(J,I).LT.-1.00001D0
     2   .OR. A0M(J,I).GT.+1.00001D0) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,42) I,J,A0M(J,I)
   42    FORMAT (/2I3,F10.5,
     1      ' ??? 30 ??? MEANINGLESS CORRELATION COEFFICIENT!')
         IER=MAX(IER,36)
         CALL ERRLOG(36)
      ELSE
         A0M(I,J)=A0M(J,I)
      END IF
   43 CONTINUE
  143 CONTINUE
C-=-=-
C     USER'S ENERGY GRID
C-=-=-
      CALL TRALER(L811,CARD,L613,ALTRET)
      IF (ALTRET) GO TO 99
   45 KEYW2=CARD(1:5)
      WRITE (L613,3) KEYW2
      IF (KEYW2.NE.'ENLIM') THEN
         WRITE (6,1) KEYW2
         IER=MAX(IER,41)
         CALL ERRLOG(41)
         RETURN
      END IF
      READ (L811,*,END=99) EL
      WRITE (L613,5) EL
      DO 51 I=1,NG1
      IF (EL(I).LE.0.) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,50) I,EL(I)
   50    FORMAT (/I3,1P,E11.3,' ??? 36 ??? MEANINGLESS ENERGY!')
         IER=MAX(IER,36)
         CALL ERRLOG(36)
      END IF
      IF (I.EQ.1) GO TO 51
      IF (EL(I-1).GE.EL(I)) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,50) I,EL(I)
         IER=MAX(IER,36)
         CALL ERRLOG(36)
      END IF
   51 CONTINUE
C-=-=-
C     INPUT SPECTRUM
C-=-=-
      CALL TRALER(L811,CARD,L613,ALTRET)
      IF (ALTRET) GO TO 99
      KEYW2=CARD(1:5)
      WRITE (L613,3) KEYW2
      IF (KEYW2.EQ.'DFIDE') THEN
         READ (L811,*,END=99) F
         WRITE (L613,5) F
         DO 53 I=1,NG
         IF (F(I).GT.0.D0) THEN
            F(I)=F(I)*(EL(I+1)-EL(I))
         ELSE
            IF (PAGE) THEN
               PAGE=.FALSE.
               WRITE (6,7)
            END IF
            WRITE (6,52) I,F(I)
   52       FORMAT (/I3,1P,E11.3,' ??? 37 ??? MEANINGLESS FLUX!')
            IER=MAX(IER,37)
            CALL ERRLOG(37)
         END IF
   53    CONTINUE
      ELSE IF (KEYW2.EQ.'DFIDU') THEN
         READ (L811,*,END=99) F
         WRITE (L613,5) F
         DO 54 I=1,NG
         IF (F(I).GT.0.) THEN
            F(I)=F(I)*LOG(EL(I+1)/EL(I))
         ELSE
            IF (PAGE) THEN
               PAGE=.FALSE.
               WRITE (6,7)
            END IF
            WRITE (6,52) I,F(I)
            IER=MAX(IER,37)
            CALL ERRLOG(37)
         END IF
   54    CONTINUE
      ELSE IF (KEYW2.EQ.'FIGRP') THEN
         READ (L811,*,END=99) F
         WRITE (L613,5) F
         DO 55 I=1,NG
         IF (F(I).LE.0.D0) THEN
            IF (PAGE) THEN
               PAGE=.FALSE.
               WRITE (6,7)
            END IF
            WRITE (6,52) I,F(I)
            IER=MAX(IER,37)
            CALL ERRLOG(37)
         END IF
   55    CONTINUE
      ELSE
         WRITE (6,1) KEYW2
         IER=MAX(IER,41)
         CALL ERRLOG(41)
         RETURN
      END IF
C-=-=-
C     INPUT SPECTRUM COVARIANCE MATRIX
C-=-=-
      CALL TRALER(L811,CARD,L613,ALTRET)
      IF (ALTRET) GO TO 99
      KEYW1=CARD(1:3)
   56 WRITE (L613,3) KEYW1
      IF (KEYW1.EQ.'STD') THEN
         READ (L811,*,END=99) SDFR
         WRITE (L613,4) SDFR
         CALL TRALER(L811,CARD,L613,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW2=CARD(1:5)
         WRITE (L613,3) KEYW2
         IF (KEYW2.EQ.'UPPER') THEN
            READ (L811,*,END=99) ((FM(J,I),J=1,I),I=1,NG)
            DO 60 I=1,NG
            WRITE (L613,4) (FM(J,I),J=1,I)
   60       CONTINUE
         ELSE IF (KEYW2.EQ.'LOWER') THEN
            READ (L811,*,END=99) ((FM(J,I),J=I,NG),I=1,NG)
            DO 61 I=1,NG
            WRITE (L613,4) (FM(J,I),J=I,NG)
   61       CONTINUE
         ELSE IF (KEYW2.EQ.'QUADR') THEN
            READ (L811,*,END=99) FM
            DO 62 I=1,NG
            WRITE (L613,4) (FM(J,I),J=1,NG)
   62       CONTINUE
         ELSE
            WRITE (6,1) KEYW2
            IER=MAX(IER,41)
            CALL ERRLOG(41)
            RETURN
         END IF
      ELSE IF (KEYW1.EQ.'MIX') THEN
         CALL TRALER(L811,CARD,L613,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW2=CARD(1:5)
         IF (KEYW2.EQ.'UPPER') THEN
            READ (L811,*,END=99) (SDFR(I),(FM(J,I),J=1,I),I=1,NG)
            DO 63 I=1,NG
            WRITE (L613,4) SDFR(I)
            WRITE (L613,4) (FM(J,I),J=1,I)
   63       CONTINUE
         ELSE IF (KEYW2.EQ.'LOWER') THEN
            READ (L811,*,END=99) (SDFR(I),(FM(J,I),J=I,NG),I=1,NG)
            DO 64 I=1,NG
            WRITE (L613,4) SDFR(I)
            WRITE (L613,4) (FM(J,I),J=I,NG)
   64       CONTINUE
         ELSE IF (KEYW2.EQ.'QUADR') THEN
            READ (L811,*) (SDFR(I),(FM(J,I),J=1,NG),I=1,NG)
            DO 65 I=1,NG
            WRITE (L613,4) SDFR(I)
            WRITE (L613,4) (FM(J,I),J=1,NG)
   65       CONTINUE
         ELSE
            WRITE (6,1) KEYW2
            IER=MAX(IER,41)
            CALL ERRLOG(41)
            RETURN
         END IF
      ELSE IF (KEYW1.EQ.'REL') THEN
         CALL TRALER(L811,CARD,L613,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW2=CARD(1:5)
         WRITE (L613,3) KEYW2
         IF (KEYW2.EQ.'UPPER') THEN
            READ (L811,*,END=99) ((FM(J,I),J=1,I),I=1,NR)
            DO 66 I=1,NR
            WRITE (L613,4) (FM(J,I),J=1,I)
   66       CONTINUE
         ELSE IF (KEYW2.EQ.'LOWER') THEN
            READ (L811,*,END=99) ((FM(J,I),J=I,NR),I=1,NR)
            DO 67 I=1,NR
            WRITE (L613,4) (FM(J,I),J=I,NR)
   67       CONTINUE
         ELSE IF (KEYW2.EQ.'QUADR') THEN
            READ (L811,*) ((FM(J,I),J=1,NR),I=1,NR)
            DO 68 I=1,NR
            WRITE (L613,4) (FM(J,I),J=1,NR)
   68       CONTINUE
         ELSE
            WRITE (6,1) KEYW2
            IER=MAX(IER,41)
            CALL ERRLOG(41)
            RETURN
         END IF
         DO 69 I=1,NR
         SDFR(I)=SQRT(FM(I,I))
   69    CONTINUE
      ELSE
         WRITE (6,1) KEYW1
         IER=MAX(IER,41)
         CALL ERRLOG(41)
         RETURN
      END IF
      DO 78 I=1,NG
      IF (SDFR(I).LE.0.D0) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,76) I,SDFR(I)
   76    FORMAT (/I3,F10.5,' ??? 38 ??? MEANINGLESS FLUX STD!')
         IER=MAX(IER,38)
         CALL ERRLOG(38)
      ELSE IF (SDFR(I).LT.10.D0 .OR. SDFR(I).GT.25.D0) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,77) I,SDFR(I)
   77    FORMAT (/I3,F10.5,' ??? 11 ??? CHECK THE FLUX STD VALUE!')
         IER=MAX(IER,11)
         CALL ERRLOG(11)
      END IF
   78 CONTINUE
      IF (KEYW2.EQ.'UPPER') THEN
         DO 180 J=2,NG
         DO 80 I=1,J-1
         FM(J,I)=FM(I,J)
   80    CONTINUE
  180    CONTINUE
      ELSE IF (KEYW2.EQ.'LOWER') THEN
         DO 181 J=2,NG
         DO 81 I=1,J-1
         FM(I,J)=FM(J,I)
   81    CONTINUE
  181    CONTINUE
      END IF
      C11=FM(1,1)
      DO 183 I=1,NG
      DO 83 J=1,I
      FM(J,I)=FM(J,I)/C11
      IF ((I.EQ.J).AND.ABS(FM(J,I)-1.D0).GT..00001D0
     1   .OR. FM(J,I).LT.-1.00001D0
     2   .OR. FM(J,I).GT.+1.00001D0) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,42) I,J,FM(J,I)
         IER=MAX(IER,30)
         CALL ERRLOG(30)
      ELSE
         FM(I,J)=FM(J,I)
      END IF
   83 CONTINUE
  183 CONTINUE
C-=-=-
C     OPTIONAL WEIGHTING SPECTRUM
C-=-=-
      CALL TRALER(L811,CARD,L613,ALTRET)
      IF (ALTRET) GO TO 99
      KEYW1=CARD(1:3)
   84 WRITE (L613,3) KEYW1
      KEYW0=KEYW1
      IF (KEYW1.EQ.'WSP') THEN
         READ (L811,6,END=99) SPECID
         READ (L811,*,END=99) WSP
         CALL TRALER(L811,CARD,L613,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW1=CARD(1:3)
         WRITE (L613,3) KEYW1
         IF (KEYW1.NE.'END') THEN
            WRITE (6,1) KEYW1
            IER=MAX(IER,41)
            CALL ERRLOG(41)
            RETURN
         END IF
      END IF
      IF (KEYW0.EQ.'END'.OR.KEYW0.EQ.'WSP') THEN
C-=-=-
C        COMPARISON OF THE USER'S AND LIBRARY ENERGY GRIDS
C-=-=-
         DO 86 I=1,NG1
         IF (ABS(EL(I)/EN(I)-1.).GT..001) THEN
            WRITE (6,50) I,EL(I)
            IER=MAX(IER,36)
            CALL ERRLOG(36)
         END IF
   86    CONTINUE
C-=-=-
C        CONVERSION A0M & FM TO RELATIVE COVARIANCE MATRIX
C-=-=-
         DO 190 I=1,NR
         SI=SDA0R(I)/1E4
         DO 90 J=1,I
         A0M(J,I)=A0M(J,I)*SDA0R(J)*SI
         IF (J.NE.I) A0M(I,J)=A0M(J,I)
   90    CONTINUE
  190    CONTINUE
         DO 191 I=1,NG
         SI=SDFR(I)/1E4
         DO 91 J=1,I
         FM(J,I)=FM(J,I)*SDFR(J)*SI
         IF (J.NE.I) FM(I,J)=FM(J,I)
   91    CONTINUE
  191    CONTINUE
         DO 92 I=1,NG
         WRITE (1) (FM(J,I),J=1,NG)
         WRITE (3) (FM(J,I),J=1,NG)
   92    CONTINUE
         REWIND (3)
      ELSE
         WRITE (6,1) KEYW1
         IER=MAX(IER,41)
         CALL ERRLOG(41)
      END IF
      RETURN
   99 IER=53
      WRITE (6,98)
   98 FORMAT (' ??? 53 ??? DOS ERROR READING THE USER''S INPUT')
      CALL ERRLOG(53)
      RETURN
      END
      SUBROUTINE STAYSL(TITLE,NR,NG,NG1,FSOLV,CHILIM,SCFACT,NAME,
     1  A0,A0M,F,C,A,DA,U,TS,TB,AFM,ASM,AN,W,Y,DF,AP,SC,BS,
     2  EL,PF,FP,TC,TD,PFP,IC,DW,NC,NS,TBNL,ANL,BUFF,ZS,IER,RINF)
C-=-=-
C     THIS IS THE STAY'SL PROGRAM
C     ADJUSTED TO THE BATCH PROCESSING ON THE IBM PC/AT
C-=-=-
      INTEGER I,IC,IER,J,JER,K,K1,K2,KA,KG,KK1,KP,KZS,
     1   L,M,NC,NG,NG1,NR,NS
C***** DOUBLE *****
      DOUBLE PRECISION A,A0,A0I,A0M,AFM,AI,AN,ANL,AP,API,ASM,BS,BUFF,
     1   C,C1,C2,C21,C3,C31,C4,CHI,CHILIM,CWC,DA,DF,DF0,DW,EL,
     2   EWC,F,F0,FC,FP,PF,PFP,RINF,S,SC,SCFACT,SP,SV,SVP,SUMFIC,
     3   TB,TBNL,TC,TD,TS,U,VAK,W,Y
C***** DOUBLE *****
C***** SINGLE *****
C     REAL A,A0,A0I,A0M,AFM,AI,AN,ANL,AP,API,ASM,BS,BUFF,
C    1   C,C1,C2,C21,C3,C31,C4,CHI,CHILIM,CWC,DA,DF,DF0,DW,EL,
C    2   EWC,F,F0,FC,FP,PF,PFP,RINF,S,SC,SCFACT,SP,SV,SVP,SUMFIC,
C    3   TB,TBNL,TC,TD,TS,U,VAK,W,Y
C***** SINGLE *****
      REAL ZS
      LOGICAL FSOLV
      CHARACTER*72 TITLE
      CHARACTER*60 NAME
      DIMENSION A0(NR),A0M(NR,NR),F(NG),C(NR,NG),A(NR),DA(NR),
     1  U(NR,NG),TS(NR),TB(NG),AFM(NR,NR),ASM(NR,NR),AN(NR,NR),
     2  W(NR,NR),Y(NR),DF(NG),AP(NR),SC(NR),BS(NR),EL(NG1),PF(NG),
     3  FP(NG),TC(NG),TD(NG),PFP(NG),IC(NG),DW(NR,NR),NC(NR),
     4  NS(NR),TBNL(NG),ANL(NR,NR),BUFF(NG,NG),CHILIM(2),ZS(NG)
      DIMENSION NAME(NR)
      EXTERNAL SCALE
      KA=NR
      KG=NG
      REWIND (1)
      REWIND (2)
      REWIND (9)
      DO 2007 I=1,KA
      DA(I)=A0(I)-A(I)
      DO 7 J=1,KG
      U(I,J)=0.
    7 CONTINUE
 2007 CONTINUE
      KP=1
      S=0.
      SV=0.
      DO 3008 J=1,KG
      S=S+F(J)
      READ (1) TB
      DO 56 L=1,KG
      SV=SV+TB(L)*F(J)*F(L)
   56 CONTINUE
      PF(J)=SQRT(TB(KP))
      KP=KP+1
      DO 2008 I=1,KA
      DO 8 L=1,KG
      U(I,J)=U(I,J)+TB(L)*C(I,L)
    8 CONTINUE
 2008 CONTINUE
 3008 CONTINUE
      DO 2010 I=1,KA
      DO 10 J=I,KA
      AFM(I,J)=0.
      DO 9 L=1,KG
      AFM(I,J)=AFM(I,J)+C(I,L)*U(J,L)
    9 CONTINUE
      AFM(J,I)=AFM(I,J)
   10 CONTINUE
 2010 CONTINUE
      DO 2016 I=1,KA
      DO 16 J=I,KA
      ASM(I,J)=0.
      READ (9) ZS(1)
      FC=ZS(1)
      IF (FC.EQ.0.D0) GO TO 15
      IF (FC.NE.1.D0) GO TO 600
      DO 14 K=1,KG
      READ (9) ZS
      DO 6014 KZS=1,NG
      TB(KZS)=ZS(KZS)
 6014 CONTINUE
      C1=0.
      DO 13 L=1,KG
      C1=C1+TB(L)*C(J,L)
   13 CONTINUE
   14 ASM(I,J)=ASM(I,J)+C1*C(I,K)
      GO TO 15
  600 ASM(I,J)=FC*A(I)*A(J)
   15 CONTINUE
      ASM(J,I)=ASM(I,J)
   16 CONTINUE
 2016 CONTINUE
C-=-=-
C     NONLINEAR TERM
C-=-=-
      REWIND (1)
      SUMFIC=0.
      DO 2114 K=1,KG
      READ (1) TBNL
      DO 8114 L=1,KG
      SUMFIC=SUMFIC+TBNL(L)
 8114 CONTINUE
 2114 CONTINUE
      REWIND (9)
      DO 3016 I=1,KA
      DO 8016 J=I,KA
      ANL(I,J)=0.
      READ (9) ZS(1)
      FC=ZS(1)
      IF (FC.EQ.0.D0) GO TO 8015
      IF (FC.NE.1.D0) GO TO 8600
      REWIND (1)
      DO 8014 K=1,KG
      READ (1) TBNL
      READ (9) ZS
      DO 6114 KZS=1,NG
      TB(KZS)=ZS(KZS)
 6114 CONTINUE
      DO 8014 L=1,KG
 8014 ANL(I,J)=ANL(I,J)+TBNL(L)*TB(L)*C(I,K)*C(J,L)
      GO TO 8015
 8600 ANL(I,J)=FC*SUMFIC
 8015 CONTINUE
      ANL(J,I)=ANL(I,J)
 8016 CONTINUE
 3016 CONTINUE
      DO 2019 I=1,KA
      DO 19 J=I,KA
      AN(I,J)=A0M(I,J)+AFM(I,J)+ASM(I,J)+ANL(I,J)
      AN(J,I)=AN(I,J)
   19 CONTINUE
 2019 CONTINUE
      IF (FSOLV) GO TO 9100
C-=-=-
C     LINEARIZED NEUTRON SPECTRUM ADJUSTMENT
C-=-=-
      CALL SCALE(AN,BS,KA)
      DO 2040 I=1,KA
      DO 40 J=1,KA
      DW(J,I)=AN(J,I)
   40 CONTINUE
 2040 CONTINUE
      CALL PIVOT(DW,KA,NC,NS,IER)
      JER=1
      IF (IER.LT.20) GO TO 7021
      WRITE (6,1021)
 7033 IF (JER.EQ.1) WRITE (6,1000)
      WRITE (6,1001)
      DO 33 I=1,KA
      WRITE (6,1002) (AN(J,I),J=1,I)
   33 CONTINUE
      WRITE (6,1003)
      DO 7034 I=1,KA
      WRITE (6,1002) (A0M(J,I),J=1,I)
 7034 CONTINUE
      WRITE (6,1004)
      DO 7035 I=1,KA
      WRITE (6,1002) (AFM(J,I),J=1,I)
 7035 CONTINUE
      WRITE (6,1005)
      DO 7036 I=1,KA
      WRITE (6,1002) (ASM(J,I),J=1,I)
 7036 CONTINUE
      WRITE (6,1006)
      DO 7037 I=1,KA
      WRITE (6,1002) (ANL(J,I),J=1,I)
 7037 CONTINUE
 1000 FORMAT (12X,'ADJUSTMENT FAILED.'/)
 1001 FORMAT (/' THE SUM OF THE MEASURED AND CALCULATED',
     1         ' COVARIANCE MATRICES OF THE ACTIVITIES:')
 1002 FORMAT (1P,10E12.3)
 1003 FORMAT (' MEASURED (A0M):')
 1004 FORMAT (' FLUX CONTRIBUTION (AFM):')
 1005 FORMAT (' X-SECTION CONTRIBUTION (ASM):')
 1006 FORMAT (' NONLINEAR CONTRIBUTION (ANL):')
 1021 FORMAT (' ??? 21 ??? THE WEIGHTING MATRIX IS SINGULAR.')
      RETURN
 7021 DO 2021 I=1,KA
      DO 21 J=1,KA
      W(I,J)=DW(I,J)
   21 CONTINUE
 2021 CONTINUE
      CALL RESCAL(W,BS,KA)
      DO 2022 I=1,KA
      Y(I)=0.
      DO 22 J=1,KA
      Y(I)=Y(I)+W(I,J)*DA(J)
   22 CONTINUE
 2022 CONTINUE
      DO 2023 L=1,KG
      DF(L)=0.
      DO 23 I=1,KA
      DF(L)=DF(L)+Y(I)*U(I,L)
   23 CONTINUE
 2023 CONTINUE
C-=-=-
C     ESTIMATE ON THE MINIMUM CHI-SQUARE
C-=-=-
      CHI=0.
      DO 24 I=1,KA
      SC(I)=DA(I)*Y(I)
      CHI=CHI+SC(I)
   24 CONTINUE
      CHI=CHI/KA
C-=-=-
C     SPECTRUM MODIFICATION
C-=-=-
      DO 25 I=1,KG
      TB(I)=1.+DF(I)
      FP(I)=TB(I)*F(I)
   25 CONTINUE
C-=-=-
C     OUTPUT ACTIVITIES
C-=-=-
      DO 2026 I=1,KA
      AP(I)=0.
      DO 26 J=1,KG
      AP(I)=AP(I)+C(I,J)*TB(J)
   26 CONTINUE
 2026 CONTINUE
C-=-=-
C     ESTIMATE ON THE OUTPUT SPECTRUM COVARIANCE MATRIX
C-=-=-
      SP=0.
      SVP=0.
      REWIND (1)
      DO 28 K=1,KG
      SP=SP+FP(K)
      DO 3027 L=1,KG
      TB(L)=0.
      DO 2027 I=1,KA
      DO 27 J=1,KA
      TB(L)=TB(L)-W(I,J)*U(I,K)*U(J,L)
   27 CONTINUE
 2027 CONTINUE
 3027 CONTINUE
      READ (1) TC
      DO 30 M=1,KG
      TD(M)=TC(M)+TB(M)
   30 CONTINUE
      SVP=SVP+TD(K)*FP(K)*FP(K)
      IF (K.EQ.KG) GO TO 58
      KK1=K+1
      DO 57 M=KK1,KG
      SVP=SVP+2.*TD(M)*FP(K)*FP(M)
   57 CONTINUE
   58 CONTINUE
      PFP(K)=SQRT(TD(K))
      WRITE (2) TD
   28 CONTINUE
      REWIND (2)
C-=-=-
C     OUTPUT
C-=-=-
      C1=SCFACT*F0
      WRITE (6,302) C1,CHI,KA
  302 FORMAT (//' INPUT FLUX SCALED & NORMALIZED BY MULTIPLICATION',
     1  ' WITH',1P,E15.3//
     2  ' LINEARIZED ESTIMATE ON THE MINIMUM CHI-SQUARE/N:',0P,F20.3/
     3  ' N (DEGREE OF FREEDOM):',I46)
      CALL CHIDIS(KA,CHILIM)
      CALL CNF95(CHILIM(1),CHILIM(2))
      IF (CHI.GT.CHILIM(2)) IER=12
      WRITE (6,303)
  303 FORMAT (//' DOSIMETRY DATA'//' DETECTOR ACTIVITIES'//
     1  7X,'MEASURED     %',23X,'C A L C U L A T E D',20X,'CHI',
     2  6X,'CODE'/30X,'BEFORE   DIFF %  CONF',8X,
     3  'AFTER   DIFF %  CONF')
      DO 50 I=1,KA
      TS(I)=SQRT(A0M(I,I))
      A0I=A0(I)
      AI=A(I)
      API=AP(I)
      C1=TS(I)/A0(I)*100.
      C2=(AI-A0I)/A0I*100.
      C21=C2/C1
      C3=(API-A0I)/A0I*100.
      C31=C3/C1
      C4=SC(I)/KA
      WRITE (6,304) I,A0I,C1,AI,C2,C21,API,C3,C31,C4,NAME(I)(1:8),
     1   NAME(I)(32:33)
   50 CONTINUE
  304 FORMAT(I3,1P,E12.3,0P,F8.2,1P,E14.3,0P,2F7.2,1P,E14.3,
     1  0P,2F7.2,0P,F10.3,3X,A8,1X,A2)
      WRITE (6,319)
  319 FORMAT (/' INPUT CORRELATION MATRIX',/)
      DO 64 I=1,KA
      DO 63 J=1,I
      IC(J)=1000.*A0M(I,J)/(TS(I)*TS(J))+.5
   63 CONTINUE
      WRITE (6,324) I,(IC(J),J=1,I)
   64 CONTINUE
  324 FORMAT (21I6/(I12,20I6))
      WRITE (6,323)
  323 FORMAT (///' RELATIVE COV. MATRIX OF ACTIVITIES'//
     1  9X,'%',10X,'CORRELATION MATRIX'/)
      DO 65 I=1,KA
      TS(I)=SQRT(AFM(I,I)+ASM(I,I))
   65 CONTINUE
      DO 67 I=1,KA
      Y(I)=TS(I)/A(I)
      ZS(I)=Y(I)
      DO 66 J=1,I
      IC(J)=1000.*(AFM(I,J)+ASM(I,J))/(TS(I)*TS(J))+.5
   66 CONTINUE
      WRITE (6,320) I,Y(I),(IC(J),J=1,I)
   67 CONTINUE
  320 FORMAT (I3,2P,F8.2,20I6/(I17,19I6))
      WRITE (6,321)
  321 FORMAT (/' CONTRIBUTION DUE TO INPUT FLUX COV. MATRIX'//
     1  9X,'%',10X,'CORRELATION MATRIX'/)
      DO 68 I=1,KA
      TS(I)=SQRT(AFM(I,I))
   68 CONTINUE
      DO 70 I=1,KA
      Y(I)=TS(I)/A(I)
      DO 69 J=1,I
      IC(J)=1000.*AFM(I,J)/(TS(I)*TS(J))+.5
   69 CONTINUE
      WRITE (6,320) I,Y(I),(IC(J), J=1,I)
   70 CONTINUE
      WRITE (6,322)
  322 FORMAT (/' CONTRIBUTION DUE TO INPUT X-SEC. COV. MATRIX'//
     1  9X,'%',10X,'CORRELATION MATRIX'/)
      DO 71 I=1,KA
      TS(I)=SQRT(ASM(I,I))
   71 CONTINUE
      DO 73 I=1,KA
      Y(I)=TS(I)/A(I)
      DO 72 J=1,I
      IC(J)=0.
      IF (ASM(I,J).NE.0.) IC(J)=1000.*ASM(I,J)/(TS(I)*TS(J))+.5
   72 CONTINUE
      WRITE (6,320) I,Y(I),(IC(J),J=1,I)
   73 CONTINUE
      WRITE (6,8322)
 8322 FORMAT (//' CONTRIBUTION DUE TO NONLINEAR TERMS'/
     1  ' (SUM OF COV(FLUX)*COV(X-SECT) TERMS)'//
     2  9X,'%',10X,'CORRELATION MATRIX'/)
      DO 8071 I=1,KA
      TS(I)=SQRT(ANL(I,I))
 8071 CONTINUE
      DO 8073 I=1,KA
      Y(I)=TS(I)/A(I)
      DO 8072 J=1,I
      IC(J)=0.
      IF (ANL(I,J).NE.0.) IC(J)=1000.*ANL(I,J)/(TS(I)*TS(J))+.5
 8072 CONTINUE
      WRITE (6,320) I,Y(I),(IC(J),J=1,I)
 8073 CONTINUE
 7700 FORMAT (A72,' MEAS-D')
 7701 FORMAT (A72,' NORM-D')
 7702 FORMAT (A72,' OUTPUT')
 7703 FORMAT (A72,' INPUT')
 7710 FORMAT (I3)
 7720 FORMAT (1P,7E11.3)
 7730 FORMAT ('STD')
 7740 FORMAT (2P,7F11.2)
 7750 FORMAT ('KOR')
 7760 FORMAT (7I11)
 7770 FORMAT ('END')
      WRITE (7,7700) TITLE
      WRITE (7,7710) KA
      WRITE (7,7100)
 7100 FORMAT ('ACT')
      DO 7110 I=1,KA
      TS(I)=SQRT(A0M(I,I))/A0(I)
 7110 CONTINUE
      WRITE (7,7720) A0
      WRITE (7,7730)
      WRITE (7,7740) TS
      WRITE (7,7750)
      DO 7115 I=1,KA
      TS(I)=SQRT(A0M(I,I))
 7115 CONTINUE
      DO 7125 I=1,KA
      DO 7120 J=1,I
      IC(J)=1000000.*(A0M(J,I)/(TS(J)*TS(I)))+.5
 7120 CONTINUE
      WRITE (7,7760) (IC(J),J=1,I)
 7125 CONTINUE
      WRITE (7,7770)
      WRITE (7,7130) NAME
 7130 FORMAT (A60,20X)
      WRITE (7,7770)
      WRITE (7,7701) TITLE
      WRITE (7,7710) KA
      WRITE (7,7720) A
      WRITE (7,7130) NAME
      WRITE (7,7770)
      WRITE (7,7702) TITLE
      WRITE (7,7710) KA
      WRITE (7,7720) AP
      WRITE (7,7740) (ZS(J),J=1,KA)
      WRITE (7,7130) NAME
      WRITE (7,7770)
      WRITE (6,305)
  305 FORMAT (//' GROUP FLUXES'//
     1  '   G',6X,'ENERGY',11X,'NEW',11X,'OLD',3X,'RATIO',
     2  '  STD DEV % NEW     OLD*  RATIO      ADJUSTMENT (CONF)'/)
      DO 51 I=1,KG
      C1=FP(I)/F(I)
      C2=PFP(I)/PF(I)
      C3=(C1-1.)/PF(I)
      WRITE (6,306) I,EL(I),FP(I),F(I),C1,PFP(I),PF(I),C2,C3
   51 CONTINUE
      IF (RINF.EQ.0.D0) THEN
         WRITE (6,7306) EL(NG1)
      ELSE
         WRITE (6,7316) EL(NG1)
      END IF
  306 FORMAT (I4,1P,E12.3,2E14.3,0P,F8.3,10X,2P,F5.2,3X,2P,F5.2,0P,F8.3,
     1   0P,F19.2)
 7306 FORMAT (1P,E16.3//
     1   ' * UNCERTAINTY OF THE OPTIMAL NORMALIZATION NEGLECTED')
 7316 FORMAT (1P,E16.3//
     1   ' * UNCERTAINTY OF THE OPTIMAL NORMALIZATION INCLUDED')
      C1=SQRT(SV)/S
      C2=SQRT(SVP)/SP
      WRITE (6,311) S,C1,SP,C2
  311 FORMAT (/' INTEGRALS OF SPECTRA'//
     1  ' OLD SPECTRUM ',1P,E12.3,'  ',2P,F7.2,' %'/
     2  ' NEW SPECTRUM ',1P,E12.3,'  ',2P,F7.2,' %')
      DO 7300 I=KG,1,-1
      TB(I)=FP(I)
      IF (I.LT.KG) TB(I)=TB(I)+TB(I+1)
 7300 CONTINUE
      WRITE (6,7310)
 7310 FORMAT (//' OTHER FORMS OF THE OUTPUT SPECTRUM'/
     1  '   G',6X,'ENERGY    REL.GR.     DPHI/DE    INTEGRAL ',
     2  '    %      REL.INT.   LETHARGY    DPHI/DU'/)
      DO 7320 I=1,KG
      REWIND (2)
      C1=FP(I)/SP
      C2=FP(I)/(EL(I+1)-EL(I))
      C21=0.
      DO 7315 J=1,KG
      READ (2) TC
      IF (J.GE.I) THEN
         DO 7314 L=I,KG
         C21=C21+TC(L)*FP(J)*FP(L)
 7314    CONTINUE
      END IF
 7315 CONTINUE
      C21=SQRT(C21)/TB(I)
      C3=TB(I)/SP
      C31=-LOG(EL(I))
      C4=FP(I)/LOG(EL(I+1)/EL(I))
      WRITE (6,7330) I,EL(I),C1,C2,TB(I),C21,C3,C31,C4
 7320 CONTINUE
 7330 FORMAT
     1   (I4,1P,E12.3,0P,F11.5,1P,2E12.3,2P,F10.2,0P,2F11.5,1P,E11.3)
      C1=0.
      C2=-LOG(EL(NG1))
      WRITE (6,7331) EL(NG1),C1,C1,C1,C1,C2,C1
 7331 FORMAT (1P,E16.3,0P,F11.5,1P,2E12.3,0P,F21.5,0P,F11.5,1P,E11.3)
      WRITE (6,7340)
 7340 FORMAT (//' RELATIVE RESPONSE VS NEUTRON ENERGY'//
     1  '    G    ENERGY     D E T E C T O R S'/)
      DO 7360 I=1,KA
      DO 7350 J=KG-1,1,-1
      C(I,J)=C(I,J)+C(I,J+1)
 7350 CONTINUE
      C1=C(I,1)
      DO 7355 J=1,KG
      C(I,J)=C(I,J)/C1
 7355 CONTINUE
 7360 CONTINUE
      L=KA/10
      IF (L*10.NE.KA) L=L+1
      DO 7400 K=1,L
      K1=(K-1)*10+1
      K2=K1+9
      IF (K2.GT.KA) K2=KA
      WRITE (6,7370)
 7370 FORMAT (1X)
      WRITE (6,7380) (NAME(I)(1:8),I=K1,K2)
      WRITE (6,7381) (NAME(I)(32:33),I=K1,K2)
 7380 FORMAT (17X,10(3X,A8))
 7381 FORMAT (11X,10(9X,A2))
      WRITE (6,7370)
      DO 7390 J=1,KG
      WRITE (6,7391) J,EL(J),(C(I,J),I=K1,K2)
 7390 CONTINUE
 7391 FORMAT (I5,1P,E11.3,0P,10F11.5)
      C1=0.
      WRITE (6,7392) EL(NG1),(C1,I=K1,K2)
 7392 FORMAT (1P,E16.3,0P,10F11.5)
      WRITE (6,7370)
 7400 CONTINUE
      WRITE (6,307)
  307 FORMAT (///' NORMALIZED INPUT FLUX CORRELATION MATRIX'/)
      REWIND (1)
      DO 53 I=1,KG
      READ (1) TB
      DO 52 J=1,I
      IC(J)=1000.*TB(J)/(PF(I)*PF(J))+.5
   52 CONTINUE
      WRITE (6,324) I,(IC(L),L=1,I)
   53 CONTINUE
      WRITE (6,309)
  309 FORMAT (///' OUTPUT FLUX CORRELATION MATRIX'/)
      REWIND (2)
      DO 55 I=1,KG
      READ (2) TB
      DO 54 J=1,I
      IC(J)=1000.*TB(J)/(PFP(I)*PFP(J))+.5
   54 CONTINUE
      WRITE (6,324) I,(IC(L),L=1,I)
   55 CONTINUE
      C1=F0*SCFACT
      DO 7220 L=1,2
      K=5-2*L
      IF (L.EQ.1) THEN
         WRITE (7,7703) TITLE
      ELSE
         WRITE (7,7701) TITLE
      END IF
      WRITE (7,7710) KG
      WRITE (7,7200)
 7200 FORMAT ('SPE')
      IF (L.EQ.1) THEN
         DO 7201 I=1,KG
         F(I)=F(I)/C1
 7201    CONTINUE
      ELSE
         DO 7203 I=1,KG
         F(I)=F(I)*C1
 7203    CONTINUE
      END IF
      WRITE (7,7720) F
      WRITE (7,7730)
      REWIND (K)
      DO 7205 I=1,KG
      READ (K) TB
      PF(I)=SQRT(TB(I))
 7205 CONTINUE
      WRITE (7,7740) PF
      WRITE (7,7750)
      REWIND (K)
      DO 7210 I=1,KG
      READ (K) TB
      DO 7209 J=1,I
      IC(J)=1000000.*(TB(J)/(PF(I)*PF(J)))+.5
 7209 CONTINUE
      WRITE (7,7760) (IC(J),J=1,I)
 7210 CONTINUE
      WRITE (7,7770)
      WRITE (7,7720) EL
      WRITE (7,7770)
 7220 CONTINUE
      WRITE (7,7702) TITLE
      WRITE (7,7710) KG
      WRITE (7,7200)
      WRITE (7,7720) FP
      WRITE (7,7730)
      WRITE (7,7740) PFP
      WRITE (7,7750)
      REWIND (2)
      DO 7230 I=1,KG
      READ (2) TB
      DO 7225 J=1,I
      IC(J)=1000000.*(TB(J)/(PFP(I)*PFP(J)))+.5
 7225 CONTINUE
      WRITE (7,7760) (IC(J),J=1,I)
 7230 CONTINUE
      WRITE (7,7770)
      WRITE (7,7720) EL
      WRITE (7,7770)
      ENDFILE 7
      RETURN
C-=-=-
C     CALCULATE 'F0'
C-=-=-
 9100 CONTINUE
      CALL SCALE(AN,BS,KA)
      DO 2140 I=1,KA
      DO 9140 J=1,KA
      DW(I,J)=AN(I,J)
 9140 CONTINUE
 2140 CONTINUE
      CALL PIVOT(DW,KA,NC,NS,IER)
      IF (IER.GT.19) THEN
         WRITE (6,1021)
         WRITE (6,1010)
 1010    FORMAT (12X,'OPTIMAL NORMALIZATION FAILED.'/)
         JER=2
         GO TO 7033
      END IF
      DO 2121 I=1,KA
      DO 9121 J=1,KA
      W(I,J)=DW(I,J)
 9121 CONTINUE
 2121 CONTINUE
      CALL RESCAL(W,BS,KA)
      DO 2122 I=1,KA
      Y(I)=0.
      DO 9122 J=1,KA
      Y(I)=Y(I)+W(I,J)*A(J)
 9122 CONTINUE
 2122 CONTINUE
      CWC=0.
      DO 9123 I=1,KA
      CWC=CWC+Y(I)*A(I)
 9123 CONTINUE
      EWC=0.
      DO 9143 I=1,KA
      EWC=EWC+Y(I)*A0(I)
 9143 CONTINUE
      F0=EWC/CWC
C-=-=-
C     CALCULATION OF STD(F0) BY SENSITIVITY ANALYSIS
C-=-=-
      DO 2500 I=1,KA
      DO 7500 J=1,I
      AN(J,I)=AFM(J,I)+ASM(J,I)+ANL(J,I)
      AN(I,J)=AN(J,I)
 7500 CONTINUE
 2500 CONTINUE
      VAK=0.
      DO 2520 I=1,KA
      DO 7520 J=1,KA
      VAK=VAK+Y(I)*A0M(I,J)*Y(J)
 7520 CONTINUE
 2520 CONTINUE
      DO 2530 I=1,KA
      Y(I)=-2.*F0*Y(I)
      DO 7530 J=1,KA
      Y(I)=Y(I)+W(I,J)*A0(J)/CWC
 7530 CONTINUE
 2530 CONTINUE
      DO 2540 I=1,KA
      DO 7540 J=1,KA
      VAK=VAK+Y(I)*AN(I,J)*Y(J)
 7540 CONTINUE
 2540 CONTINUE
      VAK=VAK/CWC/CWC
      DF0=SQRT(VAK)/F0
      WRITE (6,9300) F0,DF0
 9300 FORMAT (/' OPTIMAL NORMALIZATION FACTOR (F0) =',
     1 F33.3,' ',2P,F6.2,' %')
      C1=1.-2*DF0
      C2=1.+2*DF0
      CALL CNF95(C1,C2)
      IF (RINF.EQ.0.D0) THEN
         VAK=0.D0
         WRITE (6,910)
  910    FORMAT (//' WARNING. UPON THE USER''S REQUEST THE UNCERTAINTY',
     1   ' WILL BE NEGLECTED IN THE ADJUSTMENT PROCEDURE')
      END IF
      DO 2005 I=1,KA
      A(I)=A(I)*F0
      DO 5 J=1,KG
      C(I,J)=C(I,J)*F0
    5 CONTINUE
 2005 CONTINUE
      DO 6 I=1,KG
      F(I)=F(I)*F0
    6 CONTINUE
      REWIND (1)
      DO 7600 I=1,KG
      READ (1) (BUFF(J,I),J=1,KG)
 7600 CONTINUE
      DO 2610 I=1,KG
      DO 7610 J=1,I
      BUFF(J,I)=BUFF(J,I)+VAK
      IF (J.NE.I) BUFF(I,J)=BUFF(J,I)
 7610 CONTINUE
 2610 CONTINUE
      REWIND (1)
      DO 7620 I=1,KG
      WRITE(1) (BUFF(J,I),J=1,KG)
 7620 CONTINUE
      RETURN
      END
