      SUBROUTINE C2CALC(NP,DP,DW,W,NC,NS,BS,CHISQ,IER)
C-=-=-
C     CALCULATION OF THE CHI-SQUARE OF THE SAMPLE
C-=-=-
      INTEGER I,IER,J,NC,NP,NS
C***** DOUBLE *****
      DOUBLE PRECISION BS,CHISQ,DP,DW,W
C***** DOUBLE *****
C***** SINGLE *****
C     REAL BS,CHISQ,DP,DW,W
C***** SINGLE *****
      DIMENSION DP(NP),DW(NP,NP),W(NP,NP),NC(NP),NS(NP),BS(NP)
      EXTERNAL SCALE
      CALL SCALE(DW,BS,NP)
      CALL PIVOT(DW,NP,NC,NS,IER)
      IF (IER.GT.1) RETURN
      DO 21 I=1,NP
      DO 11 J=1,NP
      W(I,J)=DW(I,J)
   11 CONTINUE
   21 CONTINUE
      CALL RESCAL(W,BS,NP)
      CHISQ=0.
      DO 22 I=1,NP
      DO 12 J=1,NP
      CHISQ=CHISQ+DP(I)*W(I,J)*DP(J)
   12 CONTINUE
   22 CONTINUE
      CHISQ=CHISQ/NP
      RETURN
      END
      SUBROUTINE CNF95(A,B)
C***** DOUBLE *****
      DOUBLE PRECISION A,B
C***** DOUBLE *****
C***** SINGLE *****
C     REAL A,B
C***** SINGLE *****
      WRITE (6,1) A,B
      RETURN
    1 FORMAT (' LOWER LIMIT WITH 95 % CONFIDENCE LEVEL:',F29.3/
     1        ' UPPER LIMIT WITH 95 % CONFIDENCE LEVEL:',F29.3)
      END
      FUNCTION ENTIER(X)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     TRUNCTATE TO THE LEFT-SIDE INTEGER NUMBER
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      DOUBLE PRECISION ENTIER,X
      ENTIER=X-MOD(X,1.D0)
      IF (X.LT.0.) ENTIER=ENTIER-1.
      RETURN
      END
      SUBROUTINE LASTCH(STRING,LNGTH)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     LOOK FOR THE LAST NOT-BLANK CHARACTER IN THE STRING
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      CHARACTER*(*) STRING
      INTEGER I,L,LNGTH
      L=LEN(STRING)
      DO 1 I=L,1,-1
      IF (STRING(I:I).NE.' ') GO TO 2
    1 CONTINUE
      LNGTH=0
      RETURN
    2 LNGTH=I
      RETURN
      END
      SUBROUTINE NOCOMM(INOLD,INNEW)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     CHECK IF THE INPUT IS CARD NUMBERED
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      CHARACTER*80 LONG
      CHARACTER*72 SHORT
      INTEGER INNEW,INOLD
      EQUIVALENCE (LONG,SHORT)
      READ (INOLD,5) LONG
      IF (LONG(73:80).EQ.'        ') THEN
         BACKSPACE (INOLD)
         INNEW=INOLD
         RETURN
      ELSE
         INNEW=11
    1    WRITE (INNEW,5) SHORT
         READ (INOLD,5,END=3) SHORT
         GO TO 1
    3    END FILE (11)
         REWIND (11)
         RETURN
      END IF
    5 FORMAT (A)
      END
      SUBROUTINE OCLOCK(H,M,S)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CONVERTS THE NON-STANDARD, COMPILER-DEPENDENT
C     DOS TIME FUNCTION CALL ONTO STANDARD FORTRAN77 FORMAT
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER H,M,S
C***** RYAN-MCFARLAND 1.00, 2.42, MICROSOFT FL 5.00 *****
      INTEGER*2 HH,MM,SS,TT
      CALL GETTIM(HH,MM,SS,TT)
      H=HH
      M=MM
      S=SS
C***** RYAN-MCFARLAND 1.00, 2.42, MICROSOFT FL 5.00 *****
      RETURN
      END
      SUBROUTINE PIVOT(S,N,NC,NR,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     MATRIX INVERSION
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER I,IER,J,K,KEEP,L,N,NC,NR,NS,NV,NX,NY
C***** DOUBLE *****
      DOUBLE PRECISION AIJ,BIG,S,TEMP
C***** DOUBLE *****
C***** SINGLE *****
C     REAL AIJ,BIG,S,TEMP
C***** SINGLE *****
      DIMENSION NC(N),NR(N),S(N,N)
      DO 457 I=1,N
      NC(I)=0
      NR(I)=0
  457 CONTINUE
      DO 600 KEEP=1,N
C***** DOUBLE *****
      BIG=0.D0
C***** DOUBLE *****
C***** SINGLE *****
C     BIG=0.
C***** SINGLE *****
      DO 500 NS=1,N
      IF (NR(NS).NE.0) GO TO 500
C***** DOUBLE *****
      AIJ=0.D0
C***** DOUBLE *****
C***** SINGLE *****
C     AIJ=0.
C***** SINGLE *****
      NX=1
      DO 480 K=1,N
      IF (ABS(S(NS,K)).LE.AIJ) GO TO 480
      IF (NC(K).EQ.0) THEN
         AIJ=ABS(S(NS,K))
         NX=K
      END IF
  480 CONTINUE
      IF (AIJ.GT.BIG) THEN
         BIG=AIJ
         I=NS
         J=NX
      END IF
  500 CONTINUE
C***** DOUBLE *****
      IF (BIG.LT.1.0D-15) THEN
C***** DOUBLE *****
C***** SINGLE *****
C     IF (BIG.LT.1.0E-15) THEN
C***** SINGLE *****
         IER=21
         RETURN
      END IF
      L=0
  515 L=L+1
      IF (L.EQ.J) GO TO 515
      IF (L.LE.N) THEN
         S(I,L)=-S(I,L)/S(I,J)
         GO TO 515
      END IF
  540 CONTINUE
C***** DOUBLE *****
      S(I,J)=1.D0/S(I,J)
C***** DOUBLE *****
C***** SINGLE *****
C     S(I,J)=1./S(I,J)
C***** SINGLE *****
      K=0
  550 K=K+1
      IF (K.EQ.I) GO TO 550
      IF (K.GT.N) GO TO 590
      L=0
  565 L=L+1
      IF (L.EQ.J) GO TO 565
      IF (L.LE.N) THEN
         S(K,L)=S(K,L)+S(I,L)*S(K,J)
         GO TO 565
      END IF
  580 CONTINUE
      S(K,J)=S(K,J)*S(I,J)
      GO TO 550
  590 CONTINUE
      NR(I)=J
      NC(J)=I
  600 CONTINUE
      DO 1660 NY=1,N
      DO 660 K=1,N
      IF (NY.NE.NR(K)) GO TO 630
      NR(K)=NR(NY)
      NR(NY)=NY
      DO 620 NV=1,N
      TEMP=S(NY,NV)
      S(NY,NV)=S(K,NV)
      S(K,NV)=TEMP
  620 CONTINUE
  630 CONTINUE
      IF (NY.NE.NC(K)) GO TO 660
      NC(K)=NC(NY)
      NC(NY)=NY
      DO 650 NV=1,N
      TEMP=S(NV,NY)
      S(NV,NY)=S(NV,K)
      S(NV,K)=TEMP
  650 CONTINUE
  660 CONTINUE
 1660 CONTINUE
      RETURN
      END
      SUBROUTINE RESCAL(A,B,KA)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     SCALING AFTER MATRIX INVERSION
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER I,J,KA
C***** DOUBLE *****
      DOUBLE PRECISION A,B
C***** DOUBLE *****
C***** SINGLE *****
C     REAL A,B
C***** SINGLE *****
      DIMENSION A(KA,KA),B(KA)
      DO 2 I=1,KA
      DO 1 J=1,KA
      A(I,J)=A(I,J)/B(J)
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
      SUBROUTINE SCALE(A,B,KA)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     SCALING BEFORE MATRIX INVERSION
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER I,J,KA
C***** DOUBLE *****
      DOUBLE PRECISION A,B
C***** DOUBLE *****
C***** SINGLE *****
C     REAL A,B
C***** SINGLE *****
      DIMENSION A(KA,KA),B(KA)
      DO 11 I=1,KA
      B(I)=A(I,1)
      DO 1 J=2,KA
      IF (B(I).GT.A(I,J)) GO TO 1
      B(I)=A(I,J)
    1 CONTINUE
   11 CONTINUE
      DO 22 I=1,KA
      DO 2 J=1,KA
      A(I,J)=A(I,J)/B(I)
    2 CONTINUE
   22 CONTINUE
      RETURN
      END
      SUBROUTINE TODAY(Y,M,D)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CONVERTS THE NON-STANDARD, COMPILER-DEPENDENT
C     DOS DATE FUNCTION CALL ONTO STANDARD FORTRAN77 FORMAT
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER Y,M,D
C***** RYAN-MCFARLAND 1.00, 2.42, MICROSOFT FL 5.00 *****
      INTEGER*2 YY,MM,DD
      CALL GETDAT(YY,MM,DD)
      Y=YY
      M=MM
      D=DD
C***** RYAN-MCFARLAND 1.00, 2.42, MICROSOFT FL 5.00 *****
      RETURN
      END
      SUBROUTINE TRALER(INP,STRING,L613,ALTRET)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     READ 1 RECORD FROM THE USER'S INPUT AND DELETE THE TRAILER BLANKS
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      CHARACTER*80 STRING
      INTEGER I,INP,J,K,L613
      LOGICAL ALTRET
      ALTRET=.FALSE.
    1 READ (INP,3,END=20) STRING
      WRITE (L613,21) STRING
      CALL UPPCAS(STRING,80)
      DO 2 I=1,80
      IF (STRING(I:I).NE.' ') GO TO 10
    2 CONTINUE
      GO TO 1
    3 FORMAT (A)
   10 IF (STRING(I:I).EQ.'*') GO TO 1
      IF (I.NE.1) THEN
         DO 11 J=I,80
         K=J-I+1
         STRING(K:K)=STRING(J:J)
   11    CONTINUE
      END IF
      K=82-I
      DO 12 J=K,80
      STRING(J:J)=' '
   12 CONTINUE
      WRITE (L613,22) STRING
      RETURN
   20 ALTRET=.TRUE.
      RETURN
   21 FORMAT (' READ IN:     "',A80,'"')
   22 FORMAT (' REFORMATTED: "',A80,'"')
      END
      SUBROUTINE USERQL(L613,L811,NR,NG,NG1,EN,A0,NAME60,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     INTERPRETE THE USER'S CROSS SECTION REQUEST LIST
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'STAYPARM.FOR'
      REAL ANIS,CC,COVLST,EN,G1,GEOLST,TAMTM,XS
      INTEGER ICH,IER,J,L613,KF,L811,MAT,MT,NAMCLR,NB,NDETEC,NG,NG1,NR
C***** DOUBLE *****
      DOUBLE PRECISION A0
C***** DOUBLE *****
C***** SINGLE *****
C     REAL A0
C***** SINGLE *****
      CHARACTER*80 FOIL
      CHARACTER*60 NAME60
      CHARACTER*12 TWLWBL,ITEM
      CHARACTER*8 FOLNAM,EIGTBL
      CHARACTER*2 COVNAM
      CHARACTER*1 EQAT
      LOGICAL ALTRET
      COMMON /DETECT/ NDETEC,GEOLST(2,0:NRMAX),COVLST(2,0:NRMAX),
     1   ANIS(0:NRMAX)
      COMMON /DETECH/ FOLNAM(0:NRMAX),COVNAM(0:NRMAX)
      DIMENSION EN(NG1),A0(NR),NAME60(NRMAX),CC(NGMAX2),XS(NGMAX)
      EQUIVALENCE (TWLWBL,EIGTBL)
      DATA TWLWBL/'            '/
    1 FORMAT (A)
    2 FORMAT (F8.0)
    3 FORMAT (F12.0)
    4 FORMAT (A8,1X,A1,1P,2E10.3,1X,A2,1P,2E10.3,2P,F7.2)
      NDETEC=0
      NAMCLR=0
      DO 5 J=1,NR
      A0(J)=0.
    5 CONTINUE
C-=-=-
C     STORE THE LAST XSEC IDENTIFICATION
C-=-=-
   10 IF (NDETEC.GT.0) THEN
         G1=GEOLST(1,NDETEC)
         EQAT='='
         IF (G1.LT.0.) EQAT='@'
         G1=ABS(G1)
         WRITE (NAME60(NDETEC),4) FOLNAM(NDETEC),EQAT,G1,
     1   GEOLST(2,NDETEC),COVNAM(NDETEC),COVLST(1,NDETEC),
     2   COVLST(2,NDETEC),ANIS(NDETEC)
      END IF
C-=-=-
C     NEW ITEM OF THE USER'S INPUT
C-=-=-
      CALL TRALER(L811,FOIL,L613,ALTRET)
      IF (ALTRET) GO TO 30
      IF (NAMCLR.EQ.1) NDETEC=NDETEC-1
      NAMCLR=1
C-=-=-
C     KEYWORD OR NAME ?
C-=-=-
      KF=1
      CALL NXTWRD(FOIL,KF,NB)
      ITEM=TWLWBL
      ITEM(1:NB)=FOIL(KF:KF+NB-1)
      IF (NB.EQ.3.AND.(ITEM(1:3).EQ.'REL'.OR.ITEM(1:3).EQ.'STD'
     1   .OR.ITEM(1:3).EQ.'MIX') .OR.
     2   NB.EQ.5.AND.ITEM(1:5).EQ.'ENLIM') THEN
         IF (NDETEC.NE.NR) THEN
            IER=MAX(IER,31)
            WRITE (6,41)
            WRITE (6,44) NR,NDETEC
            CALL ERRLOG(31)
         END IF
         BACKSPACE (L811)
         CALL XSLCPY(NG,NG1,EN,XS,CC,IER)
         RETURN
      END IF
C-=-=-
C     EVALUATE NAME
C-=-=-
      NDETEC=NDETEC+1
      WRITE (L613,11) FOIL
   11 FORMAT (1X,A)
      GEOLST(1,NDETEC)=0.
      GEOLST(2,NDETEC)=0.
      COVLST(1,NDETEC)=0.
      COVLST(2,NDETEC)=0.
      ANIS(NDETEC)=0.
      COVNAM(NDETEC)='  '
      FOLNAM(NDETEC)=ITEM(1:8)
      ICH=ICHAR(ITEM(1:1))
      IF (48.LE.ICH.AND.ICH.LE.57) THEN
         READ (ITEM,2) TAMTM
         MAT=INT(TAMTM)
         MT=NINT(MOD(TAMTM,1.)*1000.)
         CALL GENNAM(MAT,MT,FOLNAM(NDETEC))
      ELSE
         IF (ITEM(1:1).NE.'<'.AND.ITEM(1:1).NE.'>') THEN
            FOLNAM(NDETEC)=ITEM
         ELSE
            GO TO 10
         END IF
      END IF
   20 KF=MIN(KF+NB,80)
      CALL NXTWRD(FOIL,KF,NB)
      IF (NB.EQ.0) GO TO 10
      ITEM=TWLWBL
      ITEM(1:NB)=FOIL(KF:KF+NB-1)
      ICH=ICHAR(ITEM(1:1))
      IF (48.LE.ICH.AND.ICH.LE.57.OR.ICH.EQ.46.OR.ICH.EQ.43) THEN
C-=-=-
C        0|1|2|3|4|5|6|7|8|9|.|+   EVALUATE SATACT
C-=-=-
         READ (ITEM,3) A0(NDETEC)
         NAMCLR=2
      ELSE IF (ICH.EQ.61.OR.ICH.EQ.64) THEN
C-=-=-
C        =|@   EVALUATE DETSIZE
C-=-=-
         ITEM(1:1)=' '
         IF (ICH.EQ.64) ITEM(1:1)='-'
         READ (ITEM,3) GEOLST(1,NDETEC)
      ELSE IF (ICH.EQ.37) THEN
C-=-=-
C        %   EVALUATE ANISOTROPY FACTOR
C-=-=-
         ITEM(1:1)=' '
         READ (ITEM,3) ANIS(NDETEC)
      ELSE
C-=-=-
C        EVALUATE COVERNAME
C-=-=-
         IF (NB.LE.2) THEN
            COVNAM(NDETEC)=ITEM(1:2)
         ELSE
            IER=MAX(IER,33)
            WRITE (6,43) ITEM
            CALL ERRLOG(33)
            GO TO 20
         END IF
         KF=MIN(KF+NB,80)
         CALL NXTWRD(FOIL,KF,NB)
         IF (NB.LE.0) THEN
            IER=MAX(IER,13)
            WRITE (6,43) ITEM
            CALL ERRLOG(13)
            GO TO 10
         END IF
         ITEM=TWLWBL
         ITEM(1:NB)=FOIL(KF:KF+NB-1)
         ICH=ICHAR(ITEM(1:1))
         IF (48.LE.ICH.AND.ICH.LE.57.OR.ICH.EQ.46.OR.ICH.EQ.43) THEN
C-=-=-
C           EVALUATE COVERTHCK
C-=-=-
            READ (ITEM,3) COVLST(1,NDETEC)
         ELSE
            IER=MAX(IER,13)
            WRITE (6,43) ITEM
            CALL ERRLOG(13)
            GO TO 20
         END IF
      END IF
      GO TO 20
   30 IF (NDETEC.NE.NR) THEN
         WRITE (6,42)
         WRITE (6,44) NR,NDETEC
         IER=MAX(IER,32)
         CALL ERRLOG(32)
      END IF
      RETURN
   41 FORMAT (' ??? 31 ??? KEYWORD READ INSTEAD OF DETECTOR DATA')
   42 FORMAT (' ??? 32 ??? END OF USER''S INPUT')
   43 FORMAT (' ??? 33 ??? ILLEGAL COVER DATA: ',A)
   44 FORMAT (12X,'EXPECTED NO OF REACTIONS:',I4/
     1        12X,'ACTUAL NO OF REACTIONS:',I6)
      END
