      SUBROUTINE CHESYM(IWHAT,CH,IZ)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CONVERTS THE ATOMIC NUMBER INTO CHEMICAL SYMBOL
C     OR BACKWARDS (IZ = ATOMIC NUMBER, CH = CHEMICAL SYMBOL)
C     IWHAT=1: CONVERT CH=>IZ, IWHAT=2: CONVERT IZ=>CH
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER I,IWHAT,IZ
      CHARACTER*2 CH,SYM
      DIMENSION SYM(103)
      SAVE
      DATA SYM/
     1   'H ','HE','LI','BE','B ','C ','N ','O ','F ','NE',
     2   'NA','MG','AL','SI','P ','S ','CL','AR','K ','CA',
     3   'SC','TI','V ','CR','MN','FE','CO','NI','CU','ZN',
     4   'GA','GE','AS','SE','BR','KR','RB','SR','Y ','ZR',
     5   'NB','MO','TC','RU','RH','PD','AG','CD','IN','SN',
     6   'SB','TE','I ','XE','CS','BA','LA','CE','PR','ND',
     7   'PM','SM','EU','GD','TB','DY','HO','ER','TM','YB',
     8   'LU','HF','TA','W ','RE','OS','IR','PT','AU','HG',
     9   'TL','PB','BI','PO','AT','RN','FR','RA','AC','TH',
     A   'PA','U ','NP','PU','AM','CM','BK','CF','ES','FM',
     B   'MD','NO','LR'/
      IF (IWHAT.EQ.1) THEN
         DO 1 I=1,103
         IF (CH.EQ.SYM(I)) THEN
            IZ=I
            RETURN
         END IF
    1    CONTINUE
         IZ=-1
         RETURN
      ELSE
         IF (IZ.GE.1.AND.IZ.LE.103) THEN
            CH=SYM(IZ)
         ELSE
            CH='??'
         END IF
         RETURN
      END IF
      END
      SUBROUTINE ENDFXS(IPASS,IWHICH,JZ,IA,N1,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE TAKES THE 640 GROUP CROSS SECTION OF THE REACTION
C     "IWHICH" FROM THE ENDF-6 CROSS SECTION LIBRARY
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
      REAL ANIS,COVLST,COVT,ENER,FLSAND,GEOLST,GEOM,WI,WORKE,WORKS,ZA
      INTEGER I1,IA,IER,IN,IPASS,IWHICH,IZ,JZ,N1,MAT,MATLST,MR,MT,
     1   MTLIST,N,NCARD,NDETEC,NP,NRREC
      CHARACTER*8 FOLNAM,NAME,EIGTBL
      CHARACTER*2 COVNAM,COVN,TWOBL
      COMMON /CSAND/ ENER(641),FLSAND(640),WI(640),WORKS(641)
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      COMMON /DETECH/ FOLNAM(0:NDETMX),COVNAM(0:NDETMX)
      SAVE
      DATA EIGTBL/'        '/,TWOBL/'  '/
      IF (IPASS.EQ.1) THEN
         MAT=100*IZ(COVNAM(IWHICH))
         MT=1
      ELSE
         MAT=MATLST(IWHICH)
         MT=MTLIST(IWHICH)
      END IF
      NCARD=NRREC(3-(IPASS/2)*2,IWHICH)
      IF (NCARD.LT.0) THEN
         WRITE (6,80) IWHICH, FOLNAM(IWHICH),GEOLST(1,IWHICH),
     1      GEOLST(2,IWHICH),COVNAM(IWHICH),COVLST(1,IWHICH),
     2      COVLST(2,IWHICH),ANIS(IWHICH),MAT,MT
         IER=31
         CALL ERRLOG(31)
         RETURN
      END IF
      JZ=MAT/100
      GEOM=0.
      COVT=0.
      IF (IPASS.EQ.1) THEN
         MR=NCARD+1
         NAME=EIGTBL
         COVN=COVNAM(IWHICH)
         IA=0
      ELSE
         MR=NCARD
         READ (3,81,REC=MR) ZA
         MR=MR+1
         IA=NINT(AMOD(ZA,1000.))
         NAME=FOLNAM(IWHICH)
         COVN=TWOBL
      END IF
      READ (3,82,REC=MR) NP
      MR=MR+2
      N1=642-NP
      I1=N1
   12 IN=I1+2
      IF (IN.GT.641) IN=641
      READ (3,83,REC=MR) (WORKE,WORKS(N),N=I1,IN)
      MR=MR+1
      IF (IN.EQ.641) GO TO 14
      I1=I1+3
      GO TO 12
   14 CONTINUE
      RETURN
   80 FORMAT (' '//' USER''S REQUEST LIST ITEM NO.:',I3/
     1   ' NAME: ',A/' GEOMETRY:',1P,2E11.3/' COVER NAME: ',A/
     2   ' GEOMETRY:',1P,2E11.3/' ANISOTROPY:',0P,F6.2//
     3   ' ??? 31 ??? FILE MF=3 IS LACKING, MAT =',I5,' MT =',I3)
   81 FORMAT (F11.0)
   82 FORMAT (55X,I11)
   83 FORMAT (6F11.0)
      END
      SUBROUTINE IAFORM(IA,CIA)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE WRITES THE LEFT ALIGNED FORMATTED OUTPUT OF IA
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER IA
      CHARACTER*3 CIA
      IF (IA.LT.10) THEN
         WRITE (CIA,1) IA
      ELSE IF (IA.LT.100) THEN
         WRITE (CIA,2) IA
      ELSE
         WRITE (CIA,3) IA
      END IF
      RETURN
    1 FORMAT (I1,2X)
    2 FORMAT (I2,1X)
    3 FORMAT (I3)
      END
      SUBROUTINE INTERV(X,LEFT,MFLAG)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE WAS TAKEN FROM THE BOOK OF CARL DE BOOR:
C     'A PRACTICAL GUIDE TO SPLINES' (APPLIED MATH.SCI. VOL.27. 1978)
C-=-=-
C     THE ROUTINE COMPUTES LEFT=MAX(I,1.LE.I.LE.640.AND.XT(I).LE.X)
C-=-=-
C     INPUT*********
C     XT= REAL SEQUENCE OF LENGTH 640,ASSUMED TO BE NONDECREASING
C     640= NUMBER OF TERMS IN THE SEQUENCE XT
C     X= THE POINT WHOSE LOCATION WITH RESPECT TO THE SEQUENCE XT
C        IS TO BE DETERMINED
C
C     OUTPUT********
C     LEFT, MFLAG    BOTH INTEGERS,WHOSE VALUE IS
C
C      +1     -1     IF                X.LT.XT(1)
C       I      0     IF       XT(I).LE.X.LT.XT(I+1)
C     640      1     IF     XT(640).LE.X
C
C     IN PARTICULAR, MFLAG=0 IS THE 'USUAL' CASE. MFLAG.NE.0
C     INDICATES THAT X LIES OUTSIDE THE HALFOPEN INTERVAL
C     XT(1).LE.Y.LT.XT(640).
C
C     METHOD*******
C     THE PROGRAM IS DESIGNED TO BE EFFICIENT IN THE COMMON SITUATION
C     THAT IT IS CALLED REPEATEDLY, WITH X TAKEN FROM AN INCREASING OR
C     DECREASING SEQUENCE.THE FIRST GUESS FOR THE 'LEFT' IS THEREFORE
C     TAKEN TO BE THE VALUE RETURNED AT THE PREVIOUS CALL AND STORED
C     IN THE LOCAL VARIABLE 'ILO'. A FIRST CHECK ASCERTAINS THAT
C     ILO.LT.640 (THIS IS NECESSARY SINCE THE PRESENT CALL MAY HAVE
C     NOTHING TO DO WITH THE PREVIOUS CALL. THEN IF XT(ILO).LE.X.LT.
C     XT(ILO+1) WE SET LEFT=ILO  AND WE ARE READY ONLY AFTER THREE
C     COMPARISONS.
C     OTHERWISE WE REPEATEDLY DOUBLE THE DIFFERENCE ISTEP=IHI-ILO
C     WHILE ALSO MOVING ILO AND IHI IN THE DIRECTION OF X, UNTIL
C                   XT(ILO).LE.X.LT.XT(IHI)
C     AFTER WHICH WE USE BISECTION TO GET, IN ADDITION IHI=ILO+1.
C     LEFT=ILO IS THEN RETURNED.
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      REAL FLSAND,WI,WJ,X,XT
      INTEGER IHI,ILO,ISTEP,LEFT,MFLAG,MIDDLE
      COMMON /CSAND/ XT(641),FLSAND(640),WI(640),WJ(641)
      SAVE
      DATA ILO/1/
      IHI=ILO+1
      IF (IHI.LT.640) GO TO 20
      IF (X.GE.XT(640)) GO TO 110
      ILO=639
      IHI=640
   20 IF (X.GE.XT(IHI)) GO TO 40
      IF (X.GE.XT(ILO)) GO TO 100
C-=-=-
C      NOW X.LT.XT(ILO), DECREASE ILO TO CAPTURE X
C-=-=-
      ISTEP=1
   31 IHI=ILO
      ILO=IHI-ISTEP
      IF (ILO.LE.1) GO TO 35
      IF (X.GE.XT(ILO)) GO TO 50
      ISTEP=2*ISTEP
      GO TO 31
   35 ILO=1
      IF (X.LT.XT(1)) GO TO 90
      GO TO 50
C-=-=-
C      NOW X.GE.XT(IHI), INCREASE IHI TO CAPTURE X
C-=-=-
   40 ISTEP=1
   41 ILO=IHI
      IHI=ILO+ISTEP
      IF (IHI.GE.640) GO TO 45
      IF (X.LT.XT(IHI)) GO TO 50
      ISTEP=2*ISTEP
      GO TO 41
   45 IF (X.GE.XT(640)) GO TO 110
      IHI=640
C-=-=-
C      NOW XT(ILO).LE.X.LT.XT(IHI), NARROW THE INTERVAL
C-=-=-
   50 MIDDLE=(ILO+IHI)/2
      IF (MIDDLE.EQ.ILO) GO TO 100
C-=-=-
C      IT IS ASSUMED THAT MIDDLE=ILO IN CASE IHI=ILO+1
C-=-=-
      IF (X.LT.XT(MIDDLE)) GO TO 53
      ILO=MIDDLE
      GO TO 50
   53 IHI=MIDDLE
      GO TO 50
C-=-=-
C     SET OUTPUT AND RETURN
C-=-=-
   90 MFLAG=-1
      LEFT=1
      RETURN
  100 MFLAG=0
      LEFT=ILO
      RETURN
  110 MFLAG=1
      LEFT=640
      RETURN
      END
      SUBROUTINE LASTCH(STRING,LNGTH)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE LOOKS FOR THE LAST NOT-BLANK CHARACTER
C     IN THE STRING
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER I,L,LNGTH
      CHARACTER*(*) STRING
      L=LEN(STRING)
      DO 1 I=L,1,-1
      IF (STRING(I:I).NE.' ') GO TO 2
    1 CONTINUE
      LNGTH=0
      RETURN
    2 LNGTH=I
      RETURN
      END
      FUNCTION LUKREF(MAT0,MF0,MT0)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS FUNCTION LOOKS FOR THE ADDRESS OF REFERENCE ENDF-6
C     SECTION MAT0,MF0,MT0
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER LUKREF,MAT,MAT0,MF,MF0,MT,MT0,NR
      REWIND (10)
    1 READ (10,END=5) NR,MAT,MF,MT
      IF (MAT.LT.MAT0) GO TO 1
      IF (MAT.GT.MAT0) GO TO 5
      IF (MF.LT.MF0) GO TO 1
      IF (MF.GT.MF0) GO TO 5
      IF (MT.LT.MT0) GO TO 1
      IF (MT.GT.MT0) GO TO 5
      LUKREF=NR
      RETURN
    5 LUKREF=-1
      RETURN
      END
      SUBROUTINE LUKSXS(IWHAT,IWHICH,IHOW,NFIRST,SS)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE LOOKS FOR THE "IWHICH" DETECTOR DATA IN THE
C     LIBR_NAME.SXS LIBRARY
C     IF FOUND:
C        POSITIONING TO THE CROSS SECTION RECORD OF "IWHICH"
C        NFIRST = INDEX OF THE FIRST NON-ZERO CROSS SECTION
C     ELSE: POSITIONING BEFORE THE EOF RECORD, NFIRST=0
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
      REAL ANI,ANIS,COVLST,COVSIZ,DETSIZ,GEOLST
      INTEGER IHOW,IWHAT,IWHICH,MAT,MATLST,MT,MTLIST,N1,NDETEC,
     1   NFIRST,NRREC
      LOGICAL SS
      CHARACTER*8 FOLNAM,NAME
      CHARACTER*2 COVNAM,CNAM
      DIMENSION DETSIZ(2),COVSIZ(2)
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      COMMON /DETECH/ FOLNAM(0:NDETMX),COVNAM(0:NDETMX)
      SAVE
      REWIND (9)
      GO TO 2
    1 READ (9)
      READ (9)
    2 READ (9,END=3) NAME,MAT,MT,DETSIZ,CNAM,COVSIZ,ANI,N1
      IF (IWHAT.LT.2) GO TO 10
      IF (IWHAT.EQ.2) GO TO 20
      GO TO 30
    3 BACKSPACE (9)
      NFIRST=0
      RETURN
C-=-=-
C     COVER CROSS SECTIONS
C-=-=-
   10 IF (CNAM.NE.COVNAM(IWHICH)) GO TO 1
      IF (IHOW.EQ.0) THEN
         IF (COVSIZ(1).NE.0.) GO TO 1
C-=-=->  VERSION 91-1 IGNORES ANIS
C-=-=->  IF (ANI.NE.0.) GO TO 1
      ELSE
         IF (COVLST(1,IWHICH).NE.0.) THEN
            IF (ABS(COVSIZ(1)/COVLST(1,IWHICH)-1.).GT..001) GO TO 1
         END IF
         IF (ABS(COVSIZ(2)-COVLST(2,IWHICH)).GT..001) GO TO 1
C-=-=->  VERSION 91-1 IGNORES ANIS
C-=-=->  IF (ABS(ANI-ANIS(IWHICH)).GT..1) GO TO 1
      END IF
   15 NFIRST=N1
      RETURN
C-=-=-
C     DETECTOR CROSS SECTIONS
C-=-=-
   20 IF (MAT.NE.MATLST(IWHICH)) GO TO 1
      IF (MT.NE.MTLIST(IWHICH)) GO TO 1
   21 IF (IHOW.EQ.0.OR..NOT.SS) THEN
         IF (DETSIZ(1).NE.0.) GO TO 1
         IF (COVSIZ(1).NE.0.) GO TO 1
C-=-=->  VERSION 91-1 IGNORES ANIS
C-=-=->  IF (ANI.NE.0.) GO TO 1
      ELSE
         IF(GEOLST(1,IWHICH).NE.0.) THEN
            IF (ABS(DETSIZ(1)/GEOLST(1,IWHICH)-1.).GT..001) GO TO 1
         ENDIF
         IF (ABS(DETSIZ(2)-GEOLST(2,IWHICH)).GT..001) GO TO 1
         IF (IHOW.EQ.1) THEN
            IF (COVSIZ(1).NE.0.) GO TO 1
C-=-=-=-=-> VERSION 91-1 IGNORES ANIS
C-=-=-=-=-> IF (ABS(ANI-ANIS(IWHICH)).GT..1) GO TO 1
         ELSE
            IF (CNAM.NE.COVNAM(IWHICH)) GO TO 1
            IF (COVLST(1,IWHICH).NE.0.) THEN
               IF (ABS(COVSIZ(1)/COVLST(1,IWHICH)-1.).GT..001) GO TO 1
            END IF
            IF (ABS(COVSIZ(2)-COVLST(2,IWHICH)).GT..001) GO TO 1
         END IF
      END IF
      GO TO 15
C-=-=-
C     RADIATION DAMAGE EXPOSURE PARAMETER CROSS SECTIONS
C-=-=-
   30 IF (NAME.NE.FOLNAM(IWHICH)) GO TO 1
      GO TO 21
      END
      SUBROUTINE NOCOMM(COND,INOLD,INNEW)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CHECKS IF THE INPUT IS CARD NUMBERED
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER INNEW,INOLD
      LOGICAL COND
      CHARACTER*80 LONG
      CHARACTER*72 SHORT
      EQUIVALENCE (LONG,SHORT)
      IF (COND) THEN
         INNEW=INOLD
         RETURN
      END IF
      READ (INOLD,5) LONG
      IF (LONG(73:80).EQ.'        ') THEN
         BACKSPACE (INOLD)
         INNEW=INOLD
         RETURN
      ELSE
         INNEW=11
    1    WRITE (INNEW,5) SHORT
         READ (INOLD,5,END=3) SHORT
         GO TO 1
    3    END FILE (11)
         REWIND (11)
         RETURN
      END IF
    5 FORMAT (A)
      END
      SUBROUTINE OCLOCK(H,M,S)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CONVERTS THE NON-STANDARD, COMPILER-DEPENDENT
C     DOS TIME FUNCTION CALL ONTO STANDARD FORTRAN77 FORMAT
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER H,M,S
C***** PROFORT 1.00, RMFORT 2.42, MICROSOFT FL 5.00 *****
      INTEGER*2 HH,MM,SS,TT
      CALL GETTIM(HH,MM,SS,TT)
      H=HH
      M=MM
      S=SS
C***** PROFORT 1.00, RMFORT 2.42, MICROSOFT FL 5.00 *****
      RETURN
      END
      SUBROUTINE RCTION(MT,EPC)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE GENERATES THE EXIT PARTICLE CODE TO THE REACTION
C     CODE MT
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER MT
      CHARACTER*3 EPC,PC
      CHARACTER*1 RC
      EQUIVALENCE (PC,RC)
      IF (MT.EQ.1) THEN
         EPC='TO)'
      ELSE IF (MT.EQ.28) THEN
         EPC='NP)'
      ELSE
         PC=' ) '
         CALL REACOD(2,RC,MT)
         EPC=PC
         IF (EPC.EQ.'2) ') EPC='2N)'
         IF (EPC.EQ.'N) ') EPC='N'')'
      END IF
      RETURN
      END
      SUBROUTINE STEPXS(IP,NFIRST)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE GENERATES STEP-FUNCTION CROSS SECTIONS IN THE
C     640 GROUP SAND II STRUCTURE FOR CALCULATING INTEGRAL FLUX
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
      REAL ANIS,COVLST,EBRK,EHIG,ELOW,EMID,ENER,FLSAND,GEOLST,RAT,WF,
     1   WI,WORKS
      INTEGER I,IHIG,ILOW,IMID,IP,MATLST,MTLIST,NDETEC,NFIRST,NRREC
      CHARACTER*8 FOLNAM
      CHARACTER*2 COVNAM
      CHARACTER*1 SIGN
      COMMON /CSAND/ ENER(641),FLSAND(640),WI(640),WORKS(641)
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      COMMON /DETECH/ FOLNAM(0:NDETMX),COVNAM(0:NDETMX)
      SAVE
      READ (FOLNAM(IP),1) SIGN,EBRK
    1 FORMAT (A1,F7.0)
      EBRK=EBRK*1E6
      ILOW=1
      IHIG=641
      ELOW=ENER(1)
      EHIG=ENER(641)
   10 IMID=(ILOW+IHIG)/2
      EMID=ENER(IMID)
      IF (ABS(EMID/EBRK-1.).LE..001) THEN
         ILOW=IMID
         IHIG=ILOW+1
         RAT=1.
         GO TO 12
      ELSE IF (EMID.GT.EBRK) THEN
         IHIG=IMID
         EHIG=EMID
      ELSE
         ILOW=IMID
         ELOW=EMID
      END IF
      IF (IHIG-ILOW.GT.1) GO TO 10
      RAT=(EBRK-ELOW)/(EHIG-ELOW)
   12 WF=0.
      IF (SIGN.EQ.'<') THEN
         WF=1.
         RAT=1.-RAT
         NFIRST=1
      ELSE
         NFIRST=ILOW
      END IF
      DO 15 I=1,ILOW-1
      WORKS(I)=WF
   15 CONTINUE
      WORKS(ILOW)=RAT
      WF=1.-WF
      DO 16 I=IHIG,640
      WORKS(I)=WF
   16 CONTINUE
      RETURN
      END
      SUBROUTINE SUBNC(L613,MR,INC,MAT,MATS,MTS)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE PROCESSES THE INC-TH NC-TYPE SUB-SUBSECTION
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C
C     * * * * * * * * * * * * * * W A R N I N G * * * * * * * * * *
C     *                                                           *
C     * THE VERSION JAN 29, 1991 OF THE IRDF90G LIBRARY DOES NOT  *
C     * CONTAIN CROSS SECTIONS HAVING NC-TYPE SUB-SUBSECTIONS,    *
C     * THEREFORE THIS PART OF THE PROGRAM COULD NOT BE TESTED    *
C     *                                                           *
C     * * * * * * * * * * * * * * W A R N I N G * * * * * * * * * *
C
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
      REAL CI,E,E1,E2,ESAND,ESUM,FFIJN,FLSAND,WE,WI,WJ,XMT
      INTEGER I,I1,I2,INC,ISUM,ITAPE2,L613,LTY,LUKREF,MAT,MATS,MP,
     1  MR,MTI,MTS,NCI,NEI,NP
      COMMON /CENDF/ E1,E2,E(641),FFIJN(NGEMAX,NGEMAX),LTY,NP,MP
      COMMON /CSAND/ ESAND(641),FLSAND(640),WI(640),WJ(641)
      COMMON /SUMXS/ ISUM,ESUM(2),CI(NSSMAX),MTI(NSSMAX)
      DIMENSION XMT(NSSMAX),WE(2)
      EQUIVALENCE (MTI(1),XMT(1))
      SAVE
      CALL WRKING
      WRITE (L613,80) INC
      READ (3,81,REC=MR) LTY
      MR=MR+1
      WRITE (L613,82) LTY
      IF (LTY.EQ.0) THEN
C-=-=-
C        DERIVED REDUNDANT CROSS SECTIONS
C-=-=-
         IF (ISUM.NE.0) THEN
            CALL ERRLOG(54)
            CALL ERXPLN(54)
         END IF
         READ (3,87,REC=MR) ESUM,NCI
         MR=MR+1
         IF (NCI.GT.NSSMAX) THEN
            CALL ERRLOG(54)
            CALL ERXPLN(54)
         END IF
         ISUM=NCI
         I1=1
    5    I2=I1+2
         IF (I2.GT.NCI) I2=NCI
         READ (3,88,REC=MR) (CI(I),XMT(I),I=I1,I2)
         MR=MR+1
         IF (I2.EQ.NCI) THEN
            DO 6 I=1,NCI
            MTI(I)=NINT(XMT(I)+.5)
    6       CONTINUE
            GO TO 10
         END IF
         I1=I1+3
         GO TO 5
      ELSE
C-=-=-
C        COVARIANCES OF CROSS SECTIONS DERIVED VIA RATIO MEASUREMENTS
C        TO STANDARD CROSS SECTIONS
C-=-=-
         READ (3,82,REC=MR) MATS,MTS,NEI
         MR=MR+1
         IF (NEI.GT.2) THEN
            CALL ERRLOG(54)
            CALL ERXPLN(54)
         END IF
         READ (3,83,REC=MR) (E(I),WE(I),I=1,2)
         MR=MR+1
         E1=E(1)
         E2=E(2)
         WRITE (L613,84) MATS
         WRITE (L613,85) MTS
         IF (LTY.EQ.1) THEN
            IF (MATS.NE.MAT) THEN
               ITAPE2=LUKREF(MATS,33,MTS)
               E(1)=ESAND(1)
               E(2)=ESAND(641)
            END IF
         ELSE
            CALL ERRLOG(54)
            CALL ERXPLN(54)
         END IF
      END IF
   10 WRITE (6,89) INC
      RETURN
   80 FORMAT (////1X,51('-'),' NC-S.S.:',I3,8('-'))
   81 FORMAT (33X,I11)
   82 FORMAT (22X,2I11,11X,I11)
   83 FORMAT (6E11.4)
   84 FORMAT (' STANDARD MATERIAL (MATS)',27X,':',I5)
   85 FORMAT (' STANDARD REACTION TYPE (MTS)',23X,':',I5/1X,72('-'))
   87 FORMAT (2E11.0,33X,I11)
   88 FORMAT (6E11.4)
   89 FORMAT (1X,50('-'),' EOF S.S.:',I3,8('-'))
      END
      SUBROUTINE SUBNI(L613,IPOINT,MR,INI,MAT,MT,MAT1,MF1,MT1,LFS1,
     1   ILOW,IRESP,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE PROCESSES THE INI-TH NI-TYPE SUB-SUBSECTION
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
      REAL ANIS,COVLST,COVXY,E,E1,E2,EK,EL,EL1,ELL,ELL1,ESAND,F,FX,
     1  FY,FXY,FLSAND,GEOLST,WI,WJ
      INTEGER I,I1,I2,I3,IER,ILOW,IND,INI,IPOINT,IRESP,IRF,J,K,K1,L,
     1  L613,LB,LFS1,LIND,LL,LS,LT,LT1,LTY,MAS,MAT,MAT1,MATLST,MF1,
     2  MLIND,MR,MT,MT1,MTLIST,NDETEC,NE,NEC,NEC1,NEIN,NER,NER1,
     3  NFIN,NK,NK1,NL1,NL1N,NP,NPLT,NPNP,NPOI,NREF,NRREC,NT,NT2,NTMNE
      CHARACTER*8 FOLNAM
      CHARACTER*2 COVNAM
      CHARACTER*1 CEK,CEL
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      COMMON /DETECH/ FOLNAM(0:NDETMX),COVNAM(0:NDETMX)
      COMMON /CENDF/ E1,E2,E(641),COVXY(NGEMAX,NGEMAX),LTY,NK1,NL1
      COMMON /CSAND/ ESAND(641),FLSAND(640),WI(640),WJ(641)
      COMMON /SUBSUB/ NPNP,NPOI(3,NSSMAX)
      DIMENSION F(NLIMAX),FX(NLIMAX),FY(NLIMAX),FXY(NLIMAX),IRF(NSSMAX),
     1   IRESP(*)
      EQUIVALENCE (LT,LS),(NP,NE,NER),(F(1),FX(1),FY(1),FXY(1)),
     1   (NK1,NER1),(NL1N,NEC1)
      SAVE
      DATA CEK,CEL/'k','l'/
C-=-=-
      LIND(IND)=NPLT*2+IND
      MLIND(IND)=NPLT+IND
C-=-=-
      CALL WRKING
      WRITE (L613,70) INI
      IF (MF1.NE.0.AND.MF1.NE.3) THEN
         WRITE (L613,71) MF1,LFS1
         WRITE (L613,86) INI
         RETURN
      END IF
      READ (3,80,REC=MR) LT,LB,NT,NP
      MR=MR+1
      IF (0.LE.LB.AND.LB.LE.4.OR.LB.EQ.8) THEN
         WRITE (L613,74) LT,LB,NT,NP
         NEIN=NP
      ELSE IF (LB.EQ.5) THEN
         WRITE (L613,75) LS,LB,NT,NE
         NEIN=NE
      ELSE IF (LB.EQ.6) THEN
         WRITE (L613,76) LB,NT,NER
         NEC=(NT-1)/NER
         NEIN=NER+NEC
      END IF
      NFIN=NT-NEIN
      IF (NEIN.GT.641.OR.NFIN.GT.NLIMAX) THEN
         K=NLIMAX
         WRITE (6,91) NP,NT,K
         WRITE (6,94)
         IER=51
         CALL ERRLOG(51)
         RETURN
      END IF
      IF (LB.LT.0.OR.LB.EQ.7.OR.LB.GT.8) THEN
         WRITE (6,92) LB
         WRITE (6,94)
         IER=52
         CALL ERRLOG(52)
         RETURN
      END IF
C-=-=-
C     COVARIANCE COMPONENT MATRIX SIZE CORRESPONDS WITH E(k) AND E(l)
C-=-=-
      IF (LB.EQ.5) THEN
         NK1=NE-1
         NL1=NK1
      ELSE IF (LB.EQ.6) THEN
         NER1=NER-1
         NEC1=NEC-1
      ELSE
         NK1=NP-LT-1
         NL1=NK1
      END IF
      MAS=MAX(NER1,NEC1)
      IF (MAS.GT.NGEMAX) THEN
         K=NGEMAX
         WRITE (6,93) MAS,K
         WRITE (6,94)
         IER=53
         CALL ERRLOG(53)
         RETURN
      END IF
C-=-=-
C     READ LIST RECORD
C-=-=-
      NT2=NT/2
      NPLT=NP-LT
      IF (LB.LT.5.OR.LB.GT.6) THEN
         I1=1
   10    I2=I1+2
         IF (I2.GT.NT2) I2=NT2
         READ (3,81,REC=MR) (E(I),F(I),I=I1,I2)
         MR=MR+1
         IF (I2.EQ.NT2) GO TO 21
         I1=I1+3
         GO TO 10
      ELSE
         I1=1
   15    I2=I1+5
         IF (I2.GT.NEIN) THEN
            I2=NEIN
            I3=5-(I2-I1)
            READ (3,81,REC=MR) (E(I),I=I1,I2),(F(I),I=1,I3)
            MR=MR+1
            I1=I3+1
            GO TO 16
         END IF
         READ (3,81,REC=MR) (E(I),I=I1,I2)
         MR=MR+1
         IF (I2.EQ.NEIN) THEN
            I1=1
            GO TO 16
         END IF
         I1=I1+6
         GO TO 15
   16    NTMNE=NT-NEIN
   17    I2=I1+5
         IF (I2.GT.NTMNE) I2=NTMNE
         READ (3,81,REC=MR) (F(I),I=I1,I2)
         MR=MR+1
         IF (I2.EQ.NTMNE) GO TO 21
         I1=I1+6
         GO TO 17
      END IF
   21 IF (LB.LT.5.OR.LB.GT.6) THEN
         DO 23 K=1,NK1
         DO 22 K1=1,NK1
         COVXY(K,K1)=0.
   22    CONTINUE
   23    CONTINUE
      END IF
      IF (LB.EQ.0) THEN
         GO TO 1000
      ELSE IF (LB.LE.6) THEN
         GO TO (100,200,300,400,500,600),LB
      ELSE
         GO TO 800
      END IF
   70 FORMAT (////1X,57('-'),' NI-S.S.:',I3,1X,57('-')/)
   71 FORMAT (' THE PROGRAM X333 DOES NOT PROCESS THE FILE    MF  =',I5/
     1        ' FINAL EXCITED STATE OF THE RESIDUAL NUCLEUS:  LFS =',I5)
   74 FORMAT (' NUMBER OF PAIRS IN THE SECOND ARRAY:    LT =',I5/
     1        ' FLAG TO DETERMINE THE MEANINGS OF DATA: LB =',I5/
     2        ' TOTAL NUMBER OF INPUT VALUES:           NT =',I5/
     3        ' TOTAL NUMBER OF DATA PAIRS:             NP =',I5)
   75 FORMAT (' SYMMETRY FLAG:                          LS =',I5/
     1        ' FLAG TO DETERMINE THE MEANINGS OF DATA: LB =',I5/
     2        ' TOTAL NUMBER OF INPUT VALUES:           NT =',I5/
     3        ' NUMBER OF ENTRIES IN THE ENERGY GRID:   NE =',I5)
   76 FORMAT (' FLAG TO DETERMINE THE MEANINGS OF DATA: LB  =',I5/
     1        ' TOTAL NUMBER INPUT VALUES:              NT  =',I5/
     2        ' NUMBER OF ENTRIES IN THE ENERGY GRID:   NER =',I5)
   80 FORMAT (22X,4I11)
   81 FORMAT (6E11.4)
   82 FORMAT (//' ENERGY BOUNDARIES (IN eV)'/)
   83 FORMAT (I5,':  ',1P,12E10.3)
   84 FORMAT (/' COVARIANCE MATRIX',20X,'LOWER TRIANGLE'/)
   85 FORMAT (I5,':  ',1P,12E10.3/(1P,E18.3,1P,11E10.3))
   86 FORMAT (1X,57('-'),' END S.S.:',I3,56('-'))
   87 FORMAT (/' E(',A,') TABLE:'/)
   88 FORMAT (/' COVARIANCE MATRIX',20X,'MAIN DIAGONAL (OFF-DIAGONAL',
     1   ' ELEMENTS = 0)'/)
   89 FORMAT (/' CROSS-COVARIANCE MATRIX',9X,'ROWS: MAT=',I5,' MT=',I4,
     1   9X,'COLUMNS: MAT=',I5,' MT=',I4/)
   91 FORMAT (//' ??? 51 ??? PROGRAM/LIBRARY ERROR: I/O BUFFER OVERFLOW'
     1   //' NO OF ENERGY POINTS =',I9,' > 641    OR:'/
     2   ' NO OF COVARIANCE POINTS=',I6,' >',I6)
   92 FORMAT (//' ??? 52 ??? PROGRAM/LIBRARY ERROR: UNEXPECTED FLAG:',
     1   ' LB =',I6)
   93 FORMAT (//' ??? 53 ??? PROGRAM/LIBRARY ERROR: WORK MATRIX ',
     1   'OVERFLOW'//' SIZE OF THE COV. CONTRIBUTION MATRIX =',I6,
     2   ' >',I6)
   94 FORMAT (/' PROCESSING TERMINATED'//' SORRY.')
C-=-=-
C     FLAG LB = 1
C-=-=-
  100 DO 110 K=1,NK1
      COVXY(K,K)=FXY(K)
  110 CONTINUE
      GO TO 1100
C-=-=-
C     FLAG LB = 2
C-=-=-
  200 DO 211 K=1,NK1
      DO 210 K1=1,NK1
      COVXY(K,K1)=COVXY(K,K1)+FXY(K)*FXY(K1)
  210 CONTINUE
  211 CONTINUE
      GO TO 1100
C-=-=-
C     FLAG LB = 3
C-=-=-
  300 DO 311 K=1,NK1
      DO 310 L=1,NK1
      COVXY(K,L)=COVXY(K,L)+FX(K)*FY(LIND(L))
  310 CONTINUE
  311 CONTINUE
      GO TO 1200
C-=-=-
C     FLAG LB = 4
C-=-=-
  400 LT1=LT-1
      DO 411 K=1,NK1
      EK=E(K)
      DO 410 L=1,LT1
      EL=E(MLIND(L))
      EL1=E(MLIND(L+1))
      DO 410 LL=1,LT1
      ELL=E(MLIND(LL))
      ELL1=E(MLIND(LL+1))
      IF (.NOT.(EL.LE.EK.AND.EK.LT.EL1)) GO TO 410
      IF (.NOT.(ELL.LE.EK.AND.EK.LT.ELL1)) GO TO 410
      COVXY(L,LL)=COVXY(L,LL)+F(K)*FXY(MLIND(L))*FXY(MLIND(LL))
  410 CONTINUE
  411 CONTINUE
      GO TO 1200
C-=-=-
C     FLAG LB = 5
C-=-=-
  500 J=0
      IF (LS.EQ.0) THEN
         DO 511 K=1,NK1
         DO 510 K1=1,NK1
         J=J+1
         COVXY(K,K1)=F(J)
  510    CONTINUE
  511    CONTINUE
      ELSE
         DO 521 K=1,NK1
         DO 520 K1=K,NK1
         J=J+1
         COVXY(K,K1)=F(J)
         IF (K.EQ.K1) GO TO 520
         COVXY(K1,K)=F(J)
  520    CONTINUE
  521    CONTINUE
      END IF
      GO TO 1100
C-=-=-
C     FLAG LB = 6
C-=-=-
  600 J=0
      DO 602 K=1,NER1
      DO 601 K1=1,NEC1
      J=J+1
      COVXY(K,K1)=FXY(J)
  601 CONTINUE
  602 CONTINUE
      IF (MAT1.NE.MAT.OR.MT1.NE.MT) THEN
         CALL LUKRFD(IPOINT,MAT1,MT1,NREF,IRF)
         DO 620 I=1,NREF
         J=IRF(I)
         WRITE (12) IPOINT,FOLNAM(IPOINT),GEOLST(1,IPOINT),
     1      GEOLST(2,IPOINT),COVNAM(IPOINT),COVLST(1,IPOINT),
     2      COVLST(2,IPOINT),ANIS(IPOINT)
         WRITE (12) J,FOLNAM(J),GEOLST(1,J),GEOLST(2,J),COVNAM(J),
     1      COVLST(1,J),COVLST(2,J),ANIS(J)
         WRITE (12) NER1,NEC1
         WRITE (12) (E(K),K=1,NEIN)
         DO 610 K=1,NER1
  610    WRITE (12) (COVXY(K,K1),K1=1,NEC1)
  620    CONTINUE
      END IF
      GO TO 1300
C-=-=-
C     FLAG LB = 8
C-=-=-
  800 DO 810 K=1,NK1
      COVXY(K,K)=FXY(K)
  810 CONTINUE
      GO TO 1100
C-=-=-
C     FLAG LB = 0 (ABSOLUTE COVARIANCE MATRIX)
C-=-=-
 1000 CONTINUE
C-=-=-
C     LB = 0,1,2,5,8: ONE ENERGY TABLE
C-=-=-
 1100 WRITE (L613,82)
      I1=1
 1101 I2=I1+11
      IF (I2.GT.NE) I2=NE
      WRITE (L613,83) I1,(E(I),I=I1,I2)
      IF (I2.EQ.NE) GO TO 1110
      I1=I1+12
      GO TO 1101
 1110 IF (LB.EQ.1.OR.LB.EQ.8) THEN
         WRITE (L613,88)
         I1=1
 1111    I2=I1+11
         IF (I2.GT.NK1) I2=NK1
         WRITE (L613,83) I1,(COVXY(I,I),I=I1,I2)
         IF (I2.EQ.NK1) GO TO 1500
         I1=I1+12
         GO TO 1111
      ELSE
         WRITE (L613,84)
         DO 1120 I=1,NK1
         WRITE (L613,85) I,(COVXY(I,J),J=1,I)
 1120    CONTINUE
         GO TO 1500
      END IF
C-=-=-
C     LB = 3,4: TWO ENERGY TABLES
C-=-=-
 1200 WRITE (L613,82)
      WRITE (L613,87) CEK
      NK=NK1+1
      I1=1
 1201 I2=I1+11
      IF (I2.GT.NK) I2=NK
      WRITE (L613,83) I1,(E(I),I=I1,I2)
      IF (I2.EQ.NK) GO TO 1210
      I1=I1+12
      GO TO 1201
 1210 WRITE (L613,87) CEL
      I1=MLIND(1)
      J=1
 1211 I2=I1+11
      I3=J+11
      IF (I3.GT.LT) I2=I1+11-(I3-LT)
      WRITE (L613,83) J,(E(I),I=I1,I2)
      IF (I3.GT.LT) GO TO 1212
      I1=I1+12
      J=J+12
      GO TO 1211
 1212 WRITE (L613,84)
      DO 1220 I=1,NK1
      WRITE (L613,85) I,(COVXY(I,J),J=1,I)
 1220 CONTINUE
      GO TO 1500
C-=-=-
C     LB = 6: ONE ENERGY TABLES IN TWO PARTS, NOT SQUARE MATRIX
C-=-=-
 1300 WRITE (L613,82)
      WRITE (L613,87) CEK
      I1=1
 1301 I2=I1+11
      IF (I2.GT.NER) I2=NER
      WRITE (L613,83) I1,(E(I),I=I1,I2)
      IF (I2.EQ.NER) GO TO 1310
      I1=I1+12
      GO TO 1301
 1310 WRITE (L613,87) CEL
      I1=NER+1
      J=1
 1311 I2=I1+11
      I3=J+11
      IF (I3.GT.NEC) I2=I2-(I3-NEC)
      WRITE (L613,83) J,(E(I),I=I1,I2)
      IF (I3.GE.NEC) GO TO 1312
      I1=I1+12
      J=J+12
      GO TO 1311
 1312 WRITE (L613,89) MAT,MT,MAT1,MT1
      DO 1320 I=1,NER1
      WRITE (L613,85) I,(COVXY(I,J),J=1,NEC1)
 1320 CONTINUE
C-=-=-
C     END OF DATA PREPARATION, ENERGY GRID CONVERSION FOLLOWS
C-=-=-
 1500 WRITE (L613,86) INI
      IF (LB.NE.6) CALL STRUC(INI,LB,ILOW,IPOINT,IRESP)
      RETURN
      END
      SUBROUTINE TODAY(Y,M,D)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CONVERTS THE NON-STANDARD, COMPILER-DEPENDENT
C     DOS DATE FUNCTION CALL ONTO STANDARD FORTRAN77 FORMAT
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER Y,M,D
C***** PROFORT 1.00, RMFORT 2.42, MICROSOFT FL 5.00 *****
      INTEGER*2 YY,MM,DD
      CALL GETDAT(YY,MM,DD)
      Y=YY
      M=MM
      D=DD
C***** PROFORT 1.00, RMFORT 2.42, MICROSOFT FL 5.00 *****
      RETURN
      END
      SUBROUTINE TRALER(INP,LIST,STRING,ALTRET)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE READS THE NEXT NOT-COMMENT RECORD FROM THE
C     USER'S INPUT, AND DELETES THE TRAILER BLANKS, THE COMMAS,
C     AND THE APOSTROPHES
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER I,INP,J,K,LIST
      CHARACTER*80 STRING
      LOGICAL ALTRET
      ALTRET=.FALSE.
    1 READ (INP,3,END=20) STRING
      WRITE (LIST,4) STRING
      DO 2 I=1,80
      IF (STRING(I:I).NE.' ') GO TO 10
    2 CONTINUE
      GO TO 1
    3 FORMAT (A)
    4 FORMAT (' READ IN    : "',A,'"')
    5 FORMAT (' REFORMATTED: "',A,'"')
   10 IF (STRING(I:I).EQ.'*') GO TO 1
      DO 11 J=I,80
      K=J-I+1
      STRING(K:K)=STRING(J:J)
   11 CONTINUE
      K=81-I
      DO 12 J=K,80
      STRING(K:K)=' '
   12 CONTINUE
      CALL UPPCAS(STRING,K-1)
      WRITE (LIST,5) STRING
      RETURN
   20 ALTRET=.TRUE.
      RETURN
      END
      SUBROUTINE USERQL(L613,L78,NR,A0,NAME,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE INTERPRETES THE USER'S CROSS SECTION REQUEST LIST
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
      REAL A0,ANIS,COVLST,CSD,CX,DSD,DX,GEOLST,TAMTM
      INTEGER I,ICH,IDUMMY,IER,J,JDUMMY,JER,KF,L613,L78,MAT10,MATLST,
     1   MF10,MT10,MTLIST,NAMCLR,NB,NDETEC,NEWNAM,NR,NR10,NRREAD,NRREC
      CHARACTER*80 FOIL
      CHARACTER*12 TWLWBL,ITEM
      CHARACTER*8 NAME,FOLNAM,EIGTBL
      CHARACTER*2 COVNAM
      LOGICAL ALTRET
      DIMENSION A0(NR),NAME(NR)
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      COMMON /DETECH/ FOLNAM(0:NDETMX),COVNAM(0:NDETMX)
      EQUIVALENCE (TWLWBL,EIGTBL)
      SAVE
      DATA TWLWBL/'            '/
    1 FORMAT (A)
    2 FORMAT (F8.0)
    3 FORMAT (F12.0)
      NDETEC=0
      NRREAD=0
      NAMCLR=0
      DO 5 J=1,NR
      NAME(J)=EIGTBL
      A0(J)=0.
    5 CONTINUE
   10 CALL TRALER(L78,L613,FOIL,ALTRET)
      IF (ALTRET) GO TO 30
      IF (NAMCLR.EQ.1) NRREAD=NRREAD-1
      NAMCLR=0
C-=-=-
C     KEYWORD OR NAME ?
C-=-=-
      KF=1
      CALL NXTWRD(FOIL,KF,NB)
      ITEM=TWLWBL
      ITEM(1:NB)=FOIL(KF:KF+NB-1)
      IF (NB.EQ.3.AND.(ITEM(1:3).EQ.'REL'.OR.ITEM(1:3).EQ.'STD'
     1   .OR.ITEM(1:3).EQ.'MIX') .OR.
     2   NB.EQ.5.AND.ITEM(1:5).EQ.'ENLIM') THEN
         IF (NRREAD.NE.NR) THEN
            IER=MAX(IER,22)
            WRITE (6,41) NR,NRREAD
            CALL ERRLOG(22)
         END IF
      BACKSPACE (L78)
      GO TO 31
      END IF
C-=-=-
C     EVALUATE NAME
C-=-=-
      NDETEC=NDETEC+1
      IF (NDETEC.GT.NDETMX) THEN
         NDETEC=NDETMX
         IER=MAX(IER,12)
         WRITE (6,42)
         CALL ERRLOG(12)
      END IF
      GEOLST(1,NDETEC)=0.
      GEOLST(2,NDETEC)=0.
      COVLST(1,NDETEC)=0.
      COVLST(2,NDETEC)=0.
C-=-=- VERSION 91-1: ANIS = 100 %
      ANIS(NDETEC)=100.
      COVNAM(NDETEC)='  '
      DO 12 J=1,3
      NRREC(J,NDETEC)=-1
   12 CONTINUE
      FOLNAM(NDETEC)=ITEM(1:8)
      ICH=ICHAR(ITEM(1:1))
      IF (48.LE.ICH.AND.ICH.LE.57) THEN
C-=-=-
C        MAT.MT
C-=-=-
         READ (ITEM,2) TAMTM
         MATLST(NDETEC)=INT(TAMTM)
         MTLIST(NDETEC)=NINT(MOD(TAMTM,1.)*1000.)
         CALL GENNAM(MATLST(NDETEC),MTLIST(NDETEC),FOLNAM(NDETEC))
         NRREAD=NRREAD+1
         NAME(NRREAD)=FOLNAM(NDETEC)
         NAMCLR=1
         REWIND (10)
   13    READ (10,END=19) NR10,MAT10,MF10,MT10
         IF (MAT10.LT.MATLST(NDETEC)) GO TO 13
         IF (MAT10.GT.MATLST(NDETEC)) GO TO 19
         IF (MT10.NE.MTLIST(NDETEC)) GO TO 13
         IF (MF10.EQ.3) NRREC(1,NDETEC)=NR10
         IF (MF10.EQ.33) NRREC(2,NDETEC)=NR10
         GO TO 13
   19    CONTINUE
      ELSE
         IF (ITEM(1:1).NE.'<'.AND.ITEM(1:1).NE.'>') THEN
C-=-=-
C           McELROY'S NAME
C-=-=-
            CALL FNDNDF(FOLNAM(NDETEC),
     1         NRREC(1,NDETEC),NRREC(2,NDETEC),NRREC(3,NDETEC),
     2         MATLST(NDETEC),MTLIST(NDETEC))
            IF (MATLST(NDETEC).NE.0) THEN
               NRREAD=NRREAD+1
               NAME(NRREAD)=FOLNAM(NDETEC)
               NAMCLR=1
            END IF
         ELSE
            MATLST(NDETEC)=-1
            MTLIST(NDETEC)=-1
         END IF
      END IF
   20 KF=MIN(KF+NB,80)
      CALL NXTWRD(FOIL,KF,NB)
      IF (NB.EQ.0) GO TO 10
      ITEM=TWLWBL
      ITEM(1:NB)=FOIL(KF:KF+NB-1)
      ICH=ICHAR(ITEM(1:1))
      IF (48.LE.ICH.AND.ICH.LE.57.OR.ICH.EQ.46.OR.ICH.EQ.43) THEN
C-=-=-
C        0|1|2|3|4|5|6|7|8|9|.|+   EVALUATE SATACT
C-=-=-
         READ (ITEM,3) A0(NRREAD)
         NAMCLR=2
      ELSE IF (ICH.EQ.61.OR.ICH.EQ.64) THEN
C-=-=-
C        =|@   EVALUATE DETSIZE
C-=-=-
         ITEM(1:1)=' '
         IF (ICH.EQ.64) ITEM(1:1)='-'
         READ (ITEM,3) GEOLST(1,NDETEC)
      ELSE IF (ICH.EQ.37) THEN
C-=-=-
C        %   EVALUATE ANISOTROPY FACTOR
C-=-=-
         ITEM(1:1)=' '
         READ (ITEM,3) ANIS(NDETEC)
C-=-=-=- VERSION 91-1: ANIS = 100 %
         ANIS(NDETEC)=100.
      ELSE
C-=-=-
C        EVALUATE COVERNAME
C-=-=-
         IF (NB.LE.2) THEN
            COVNAM(NDETEC)=ITEM(1:2)
            CALL FNDNDF(COVNAM(NDETEC),
     1         NRREC(1,NDETEC),NRREC(2,NDETEC),NRREC(3,NDETEC),
     2         IDUMMY,JDUMMY)
         ELSE
            IER=MAX(IER,13)
            WRITE (6,43) ITEM
            CALL ERRLOG(13)
            GO TO 20
         END IF
         KF=MIN(KF+NB,80)
         CALL NXTWRD(FOIL,KF,NB)
         IF (NB.LE.0) THEN
            IER=MAX(IER,13)
            WRITE (6,43) ITEM
            CALL ERRLOG(13)
            GO TO 10
         END IF
         ITEM=TWLWBL
         ITEM(1:NB)=FOIL(KF:KF+NB-1)
         ICH=ICHAR(ITEM(1:1))
         IF (48.LE.ICH.AND.ICH.LE.57.OR.ICH.EQ.46.OR.ICH.EQ.43) THEN
C-=-=-
C           EVALUATE COVERTHCK
C-=-=-
            READ (ITEM,3) COVLST(1,NDETEC)
         ELSE
            IER=MAX(IER,13)
            WRITE (6,43) ITEM
            CALL ERRLOG(13)
            GO TO 20
         END IF
      END IF
      GO TO 20
   30 IF (NRREAD.NE.NR) THEN
         IER=MAX(IER,12)
         CALL ERRLOG(12)
      END IF
   31 NEWNAM=0
      DO 35 I=1,NDETEC
      JER=0
      CALL IPRGEO(MATLST(I),MTLIST(I),GEOLST(1,I),COVNAM(I),
     1   COVLST(1,I),DSD,DX,CSD,CX,IER)
      IER=MAX(IER,JER)
      IF (GEOLST(1,I).NE.DSD.OR.GEOLST(2,I).NE.DX .OR.
     1    COVLST(1,I).NE.CSD.OR.COVLST(2,I).NE.CX) THEN
          NEWNAM=NEWNAM+1
          IF (NEWNAM.EQ.1) WRITE (6,44)
          IF (GEOLST(1,I).NE.DSD.OR.GEOLST(2,I).NE.DX) THEN
             WRITE (6,45) I,FOLNAM(I),COVNAM(I)
             WRITE (6,46) GEOLST(1,I),GEOLST(2,I)
             WRITE (6,47) DSD,DX
          END IF
          IF (COVLST(1,I).NE.CSD.OR.COVLST(2,I).NE.CX) THEN
             IF (GEOLST(1,I).EQ.DSD.AND.GEOLST(2,I).EQ.DX)
     1          WRITE (6,45) I,FOLNAM(I),COVNAM(I)
             WRITE (6,46) COVLST(1,I),COVLST(2,I)
             WRITE (6,48) CSD,CX
          END IF
      END IF
      GEOLST(1,I)=DSD
      GEOLST(2,I)=DX
      COVLST(1,I)=CSD
      COVLST(2,I)=CX
   35 CONTINUE
      RETURN
   41 FORMAT (' ??? 22 ??? EXPECTED NO OF REACTIONS:',I4/
     1        '            ACTUAL NO OF REACTIONS:',I6)
   42 FORMAT (' ??? 12 ??? NO OF DETECTORS INCORRECT')
   43 FORMAT (' ??? 13 ??? ILLEGAL COVER DATA: ',A)
   44 FORMAT (' ')
   45 FORMAT (/' USER''S REQUEST No',I3,' NAME = ',A8,' COVER = ',A2)
   46 FORMAT
     1   (' THE INPUT GEOMETRY DATA:',1P,2E10.3,' ARE CONVERTED TO:')
   47 FORMAT (5X,' DETECTOR "SIZE" =',1P,E23.3,' atom/barn'/
     1   5X,' DETECTOR THICKNESS/DIAMETER =',1P,E10.3,' cm')
   48 FORMAT (5X,' COVER "SIZE" =',1P,E13.3,' atom/barn'/
     1   5X,' COVER THICKNESS =',1P,E10.3,' cm')
      END
