      FUNCTION DENSTY(IZ)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS FUNCTION RETURNS THE DENSITY FOR IZ (NATURAL ELEMENT)
C     REFERENCE: W. SEELMANN-EGGBERT, G. PFENNIG, H. MNZEL:
C     CHART OF THE NUCLIDES. G. f. KERNFORSCHUNG mbH, KARLSRUHE, 1974.
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      REAL D,DENSTY
      INTEGER IZ
      DIMENSION D(92)
      SAVE
      DATA D/
     1   0.00008989,0.00017847,0.534,1.86,2.33,2.2,0.00125046,
     2   0.0014289,0.001696,0.0009006,0.971,1.741,2.698,2.3263,2.69,
     3   2.07,0.003214,0.0017837,0.862,1.540,2.99,4.505,6.12,7.2,7.43,
     4   7.87,8.9,8.91,8.96,7.13,5.91,5.3263,5.72,4.7924,3.14,0.003744,
     5   1.532,2.67,4.472,6.50,8.55,10.22,-1.0,12.3,12.5,12.1,10.5,
     6   8.642,7.30,7.29,6.69,6.25,4.932,0.005896,1.873,3.61,6.162,
     7   6.768,6.769,7.007,-1.0,7.53,5.24,7.886,8.253,8.559,8.799,9.062,
     8   9.318,6.959,9.849,13.36,16.6,19.27,21.04,22.48,22.4,21.5,19.3,
     9   13.5459,11.85,11.337,9.79,-1.0,-1.0,-1.0,-1.0,-1.0,-1.0,11.7,
     A   -1.0,19.1/
      IF (IZ.LT.1.OR.IZ.GT.92) THEN
         DENSTY=-1.
      ELSE
         DENSTY=D(IZ)
      END IF
      RETURN
      END
      FUNCTION MTCODE(R)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS FUNCTION CALCULATES MT TO THE MCELROY'S DOSIMETRY
C     REACTION CODE
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER M,MTCODE
      CHARACTER*1 R
      CALL REACOD(1,R,M)
      MTCODE=M
      RETURN
      END
      FUNCTION MTDEXP(R)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS FUNCTION CALCULATES MT TO DAMAGE EXPOSURE PARAMETERS
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER I,KODES,L,MTDEXP
      CHARACTER*(*) R
      CHARACTER*1 CODES
      DIMENSION CODES(5),KODES(5)
      SAVE
      DATA CODES /'H','D','T','3','E'/
      DATA KODES /203,204,205,206,207/
      CALL LASTCH(R,L)
      DO 1 I=1,5
      IF (R(L:L).EQ.CODES(I)) THEN
         MTDEXP=KODES(I)
         GO TO 10
      END IF
    1 CONTINUE
    2 MTDEXP=-1
   11 RETURN
   10 IF (L.LT.2) THEN
         RETURN
      ELSE IF (L.EQ.2) THEN
         IF (R(1:1).EQ.CODES(I-4)) RETURN
      ELSE
         IF (R(1:1).EQ.CODES(1).AND.R(2:2).EQ.CODES(5)) RETURN
      END IF
      GO TO 2
      END
      SUBROUTINE NAMEZA(RNAME,ZA,MT,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CALCULATES ZA AND MT TO THE MCELROY'S
C     DOSIMETRY REACTION CODE
C     RNAME =   REACTION NAME
C     ZA =      1000*ATOMIC NUMBER + MASS NUMBER
C     MT =      REACTION NUMBER OF THE ENDF-6 LIBRARY
C     IER = 0   NORMAL RETURN
C     IER = 1   UNKNOWN REACTION CODE
C     IER = 2   UNKNOWN CHEMICAL SYMBOL
C     IER = 3   BOTH
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      REAL ZA
      INTEGER I,IE,IER,IZ,J,JE,JN,K,L,MT,MTCODE
      CHARACTER*(*) RNAME
      CHARACTER*8 NAME
      CHARACTER*4 II,JJ
      CHARACTER*2 CHMSYM
      CHARACTER*1 REACOD,NPCODE
      DIMENSION II(1),JJ(7)
      SAVE
      DATA JJ/'(I1)','(I2)','(I3)','(I4)','(I5)','(I6)','(I7)'/
      IE=0
      NAME=RNAME
      CALL LASTCH(NAME,L)
      CHMSYM(1:1)=NAME(1:1)
      NAME(1:1)=' '
      I=ICHAR(NAME(2:2))
      IF (65.LE.I.AND.I.LE.90) THEN
         CHMSYM(2:2)=NAME(2:2)
         NAME(2:2)=' '
         I=2
      ELSE
         CHMSYM(2:2)=' '
         I=1
      END IF
      IF (I.EQ.L) THEN
         I=IZ(CHMSYM)
         IF (I.GT.0) THEN
            ZA=I*1000.
            MT=1
         ELSE
            IE=3
         END IF
         RETURN
      END IF
      REACOD=NAME(L:L)
      NAME(L:L)=' '
      L=L-1
      I=IZ(CHMSYM)
      IF (I.LT.0) IE=2
      IF (REACOD.EQ.'-') THEN
         JE=1
         J=0
      ELSE
         JE=0
         J=MTCODE(REACOD)
         IF (J.EQ.103) THEN
            NPCODE=NAME(L:L)
            JN=MTCODE(NPCODE)
            IF (JN.EQ.51) THEN
               NAME(L:L)=' '
               L=L-1
               J=28
            END IF
         END IF
      END IF
      IF (J.LT.0) THEN
         IE=IE+1
         MT=0
      ELSE
         MT=J
      END IF
      II(1)=JJ(L)
      IF (IE.LE.1) READ (NAME,II) K
      IER=IE-JE
      IE=IE+1-JE
      GO TO (10,20,30,40),IE
   10 ZA=FLOAT(1000*I+K)
      RETURN
   20 MT=0
      GO TO 10
   30 ZA=0.
      RETURN
   40 MT=0
      GO TO 30
      END
      SUBROUTINE NZCURV(IZ,IA,AWR,ABUD)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE RETURNS THE ATOMIC WEIGHT AND ISOTOPE ABUDANCE
C     FOR IZ,IA
C     REFERENCE: W. SEELMANN-EGGBERT, G. PFENNIG, H. MNZEL:
C     CHART OF THE NUCLIDES. G. f. KERNFORSCHUNG mbH, KARLSRUHE, 1974.
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      REAL AB,AB1,AB2,AB3,AB4,ABUD,AW,AWR
      INTEGER I1,I3,IA,INDX,INDX1,INDX2,IZ,JA,JZ
      DIMENSION AB(354),AB1(99),AB2(94),AB3(92),AB4(69),AW(92),
     1   INDX(3,92),INDX1(3,46),INDX2(3,46)
      EQUIVALENCE (AB(1),AB1(1)),(AB(100),AB2(1)),
     1   (AB(194),AB3(1)),(AB(286),AB4(1)),
     2   (INDX(1,1),INDX1(1,1)),(INDX(1,47),INDX2(1,1))
      SAVE
C-=-=-
C     DATA AB
C-=-=-
      DATA AB1/
     1 99.985,0.015,0.00013,99.99987,7.5,92.5,20.0,80.0,98.89,1.11,
     2 99.64,0.36,99.756,0.039,0.205,90.5,0.27,9.2,78.99,10.00,11.01,
     3 92.2,4.7,3.1,95.0,0.75,4.2,0.0,0.015,75.77,0.0,24.23,0.34,0.0,
     4 0.07,0.0,99.59,93.3,0.012,6.7,96.94,0.0,0.65,0.14,2.08,0.0,
     5 0.003,0.0,0.19,8.0,7.5,73.7,5.5,5.3,0.25,99.75,4.35,0.0,83.79,
     6 9.50,2.36,5.8,0.0,91.7,2.14,0.31,67.76,0.0,26.42,1.16,3.71,
     7 0.0,0.95,69.1,0.0,30.9,48.9,0.0,27.8,4.1,18.6,0.0,0.62,60.0,0.0,
     8 40.0,20.7,0.0,27.5,7.7,36.4,0.0,7.7,0.9,0.0,9.0,7.5,23.5,0.0/
      DATA AB2/
     9 50.0,0.0,9.0,50.69,0.0,49.31,0.35,0.0,2.25,0.0,11.6,11.5,57.0,
     A 0.0,17.3,72.17,0.0,27.83,0.56,0.0,9.9,7.0,82.6,51.4,11.2,17.1,
     B 0.0,17.5,0.0,2.8,14.8,0.0,9.1,15.9,16.7,9.5,24.4,0.0,9.6,5.5,0.0,
     C 1.9,12.7,12.6,17.1,31.6,0.0,18.6,1.0,0.0,11.0,22.2,27.3,0.0,
     D 26.7,0.0,11.8,51.83,0.0,48.17,1.2,0.0,0.9,0.0,12.4,12.8,24.0,
     E 12.3,28.8,0.0,7.6,4.3,0.0,95.7,1.0,0.0,0.66,0.35,14.4,7.6,
     F 24.1,8.6,32.8,0.0,4.7,0.0,5.8,57.3,0.0,42.7,0.09,0.0,2.4,0.87/
      DATA AB3/
     G 4.6,7.0,18.7,0.0,31.8,0.0,34.5,0.10,0.0,0.09,0.0,1.9,26.4,3.3,
     H 21.2,27.0,0.0,10.5,0.0,8.9,0.10,0.0,0.095,0.0,2.4,6.5,7.8,
     I 11.2,71.9,0.09,99.91,0.19,0.0,0.26,0.0,88.5,0.0,11.1,27.1,
     J 12.2,23.9,8.3,17.2,0.0,5.7,0.0,5.6,3.1,0.0,0.0,15.0,11.2,13.8,
     K 7.4,0.0,26.7,0.0,22.8,47.8,0.0,52.2,0.20,0.0,2.2,14.9,20.6,
     L 15.7,24.7,0.0,21.7,0.06,0.0,0.10,0.0,2.3,18.9,25.5,24.9,28.2,
     M 0.14,0.0,1.6,0.0,33.4,22.9,27.0,0.0,15.0,0.14,0.0,3.0,14.3/
      DATA AB4/
     N 21.9,16.2,31.8,0.0,12.7,97.4,2.6,0.18,0.0,5.2,18.5,27.2,13.8,
     O 35.1,0.012,99.988,0.13,0.0,26.3,14.3,30.7,0.0,28.6,37.40,0.0,
     P 62.60,0.02,0.0,1.6,1.6,13.3,16.1,26.4,0.0,41.0,37.4,0.0,62.6,
     Q 0.013,0.0,0.78,0.0,3209,33.8,25.3,0.0,7.2,0.15,0.0,10.1,16.9,
     R 23.1,13.2,29.7,0.0,6.8,29.5,0.0,70.5,1.4,0.0,24.1,22.1,52.4,
     S 0.0055,0.720,0.0,0.0,99.28/
      DATA AW/
     1 1.0079,4.0026,6.941,9.01218,10.81,12.011,14.0067,15.9994,
     2 18.9984,20.179,22.98977,24.305,26.98154,28.086,30.97376,32.06,
     3 35.453,39.948,39.039,40.08,44.9559,47.90,50.9414,51.996,
     4 54.9380,55.847,58.9332,58.70,63.546,65.38,69.72,72.59,74.9216,
     5 78.96,79.904,83.80,85.4678,87.62,88.9059,91.22,92.9064,95.94,
     6 0.0,101.07,102.9055,106.4,107.868,112.40,114.82,118.69,121.75,
     7 127.60,126.9045,131.3,132.9054,137.34,138.9055,140.12,
     8 140.9077,144.24,0.0,150.4,151.96,157.25,158.9254,162.50,
     9 164.9304,167.26,168.9342,173.04,174.97,178.49,180.9479,183.85,
     A 186.207,190.2,192.2,195.09,196.9665,200.59,204.37,207.2,
     B 208.9804,0.0,0.0,0.0,0.0,0.0,0.0,232.0381,0.0,238.029/
C-=-=-
C     DATA INDX/
C-=-=-
      DATA INDX1/
     1 2,1,1,2,3,3,2,5,6,1,7,9,2,7,10,2,9,12,2,11,14,3,13,16,1,16,19,
     2 3,16,20,1,19,23,3,19,24,1,22,27,3,22,28,1,25,31,5,25,32,3,30,
     3 35,5,33,36,3,38,39,9,41,40,1,50,45,5,50,46,2,55,50,5,57,50,1,
     4 62,55,5,62,54,1,67,59,7,67,58,3,74,63,7,77,64,3,84,69,7,87,70,
     5 1,94,75,9,94,74,3,103,79,9,106,78,3,115,85,5,118,84,1,123,89,7,
     6 123,90,1,130,93,9,130,92,0,139,0,9,139,96,1,148,103,9,148,102/
      DATA INDX2/
     7 3,157,107,11,160,106,3,171,113,13,174,112,3,187,121,11,190,
     8 120,1,201,127,13,201,124,1,214,133,9,214,130,2,223,138,7,225,
     9 136,1,232,141,9,232,142,0,241,0,11,241,144,3,252,151,9,255,
     A 152,1,252,159,9,264,156,1,273,165,9,273,162,1,282,169,9,282,
     B 168,2,291,175,7,293,174,2,300,180,7,302,180,3,309,185,9,312,
     C 184,3,321,191,9,324,190,1,333,197,9,333,196,3,342,203,5,345,
     D 204,1,350,209,0,350,0,0,350,0,0,350,0,0,350,0,0,350,0,0,350,0,
     E 1,350,232,0,350,0,5,350,234/
      JZ=IZ
      JA=IA
      IF (JZ.LT.1.OR.JZ.GT.92) THEN
         AWR=0.
         ABUD=0.
      ELSE
         AWR=AW(JZ)
         I1=INDX(1,JZ)
         I3=INDX(3,JZ)
         IF (I1.EQ.1) THEN
            IF (JA.EQ.I3) THEN
               ABUD=100.
            ELSE
               ABUD=0.
            END IF
         ELSE IF (I1.EQ.0..OR.JA.LT.I3) THEN
            ABUD=0.
         ELSE
            IF (JA.GE.I1+I3) THEN
               ABUD=0.
            ELSE
               ABUD=AB(INDX(2,JZ)+JA-I3)
            END IF
         END IF
      END IF
      RETURN
      END
