      PROGRAM XSSPPP
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C
C     XS = CROSS SECTIONS OF THE LIBRARY TASKNAME.XSL
C     SP = NEUTRON SPECTRA OF THE DATA SET TASKNAME.OUT
C     PP = PREPARATION FOR PLOTTING BY THE PLOTTING CODES OF THE
C          PACKAGE "ENDF PRE-PROCESSING CODES, VERSION 94-1"
C          AVAILABLE AT THE NUCLEAR DATA SECTION OF IAEA
C
C     WRITTEN BY E. J. SZONDI
C     INSTITUTE OF NUCLEAR TECHNIQUES
C     TECHNICAL UNIVERSITY OF BUDAPEST
C
C     THE ONLY INPUT OF THIS PROGRAM IS THE "TASKNAME" AS IT IS
C     DEFINED IN THE USER'S GUIDES OF THE CODES X333 AND STAYNL
C     (SEE THE DOCUMENTATION OF THE NEUTRON METROLOGY FILE NMF-90)
C
C     THE OUTPUT IS A DATA SET ACCORDING TO THE ENDF-6 FORMAT RULES
C     EXCEPT THE FICTIOUS MAT AND MT NUMBERS (FURTHER INSTRUCTION
C     WILL BE FOUND IN THE SESSION LOG XSSPPP.LOG)
C
C     COMPUTER DEPENDENT CODING
C     =========================
C
C     THIS PROGRAM HAS BEEN WRITTEN IN STANDARD FORTRAN-77 FOR RUNNING
C     ON AN IBM PC/AT. SPECIAL REQUIREMENTS TO THE JOB OF THE XSSPPP
C         REQUIRED MEMORY:  DEPENDS ON THE MAXIMUM PROBLEM SIZE
C                           (IF THE VALUE OF THE PARAMETERS:
C                           NGUMAX=100, NDETMX=100 THEN ABOUT 330 KB
C                           FREE MEMORY IS NECESSARY)
C         OPERATING SYSTEM: IBM PERSONAL COMPUTER DOS 3.30 OR ABOVE
C         COMPILER:         RYAN-MCFARLAND FORTRAN 2.42
C                               (MATH COPROCESSOR REQUIRED)
C                           OR: MICROSOFT FORTRAN 5.00
C         WORD LENGTH:      32 BITS (BOTH THE REAL AND INTEGER TYPE)
C
C     THE COMPUTER-SPECIFIC STATEMENTS ARE MARKED LIKE THE NEXT LINES:
C
C     C***** ANY EXPRESSION *****
C            ANY FORTRAN STATEMENT
C            ANY FORTRAN STATEMENT
C     C***** ANY EXPRESSION *****
C
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      IMPLICIT NONE
      INCLUDE 'XSSPPARM.FOR'
      INTEGER I,IP1,J,K,KOVFLG,L,LR,MAT,MM,MT,N,N1STU,NDBLK,
     1   NGUSER,NGUSE1,NM1,NOTUSD,NRC,NS
      REAL ANIS,ATWI,CRUSER,ESAND,EUSER,G,G1,G2,G3,G4,
     1   W,WSP,ZAI
      CHARACTER*80 FIL,TITCRD
      CHARACTER*76 TSKNAME
      CHARACTER*8 NAME,TASK
      CHARACTER*3 CHNGUS,KEYWRD
      CHARACTER*2 COVER,CV
      CHARACTER*1 CHIN
      LOGICAL EX,ENDF
      DIMENSION EUSER(NGUMX1),CRUSER(NGUMAX),ESAND(641),WSP(640),
     1   MM(3,NDETMX),COVER(NDETMX),G(4,NDETMX)
      DATA ENDF/.FALSE./
      WRITE (6,70)
    1 WRITE (6,71)
      READ (5,80) TSKNAME
      DO 2 L=76,1,-1
      IF (TSKNAME(L:L).NE.' ') GO TO 3
    2 CONTINUE
      GO TO 1
    3 CALL FI2TN(TSKNAME,L,TASK)
C-=-=-
C     TASKNAME.OUT
C-=-=-
      FIL=TSKNAME(1:L)//'.OUT'
      INQUIRE (FILE=FIL,EXIST=EX)
      IF (.NOT.EX) THEN
         WRITE (*,*) FIL,' DOES NOT EXIST'
         GO TO 100
      END IF
      WRITE (*,*) 'PROCESSING ',FIL
      OPEN (UNIT=8,FILE=FIL,FORM='FORMATTED',STATUS='OLD',ERR=92)
      FIL=TSKNAME(1:L)//'.NDF'
      INQUIRE (FILE=FIL,EXIST=EX)
      IF (EX) THEN
         OPEN (UNIT=7,FILE=FIL,FORM='FORMATTED',STATUS='OLD',ERR=93)
         CLOSE (UNIT=7,STATUS='DELETE')
      END IF
      OPEN (UNIT=7,FILE=FIL,FORM='FORMATTED',STATUS='NEW',ERR=94)
      ENDF=.TRUE.
      READ (8,80) TITCRD
      READ (8,80) TITCRD
      WRITE (7,7) TITCRD(1:66)
    7 FORMAT (A66,'   0 0  0    0')
   10 IF (TITCRD(74:78).EQ.'INPUT') GO TO 11
      READ (8,80) TITCRD
      GO TO 10
   11 READ (8,*) NGUSER
      NGUSE1=NGUSER+1
      DO 30 MT=991,993
         MAT=MOD(MT,10)
   20    READ (8,80) KEYWRD
         IF (KEYWRD.NE.'SPE') GO TO 20
         READ (8,*) (CRUSER(J),J=1,NGUSER)
   21    READ (8,80) KEYWRD
         IF (KEYWRD.NE.'END') GO TO 21
         READ (8,*) (EUSER(J),J=1,NGUSE1)
         DO 25 J=1,NGUSE1
   25    EUSER(J)=EUSER(J)*1E6
         CALL MF1(MAT,MT,NGUSE1,TASK,MM,0,0,NS,ZAI,ATWI)
         CALL MF3HDR(MAT,MT,NGUSE1,ZAI,ATWI,NS)
         CALL MF3SP(MT,CRUSER,NGUSER,EUSER,NGUSE1,NS)
         WRITE (7,81) NS
   30 CONTINUE
      CLOSE (UNIT=8,STATUS='KEEP')
      GO TO 100
   70 FORMAT (10(/),
     1   13X,'XSSPPP utility to generate problem dependent input'/
     2   13X,'for the plotting programs of the ENDF pre-processing'/
     3   13X,'code package (see: IAEA-NDS-39, Rev. 8, 1994).')
   71 FORMAT (///' [drive:] [path] taskname ? ')
   80 FORMAT (A)
   81 FORMAT (69X,'0 0  0',I5)
   92 STOP 'DOS OPEN ERROR, FILE=taskname.OUT'
   93 STOP 'DOS OPEN ERROR, FILE=taskname.NDF STATUS=OLD'
   94 STOP 'DOS OPEN ERROR, FILE=taskname.NDF STATUS=NEW'
C-=-=-
C     TASKNAME.DAT OR TASKNAME.WSP
C-=-=-
  100 FIL=TSKNAME(1:L)//'.DAT'
      INQUIRE (FILE=FIL,EXIST=EX)
      IF (.NOT.EX) THEN
         WRITE (*,*) FIL,' DOES NOT EXIST'
         GO TO 150
      END IF
      WRITE (*,*) 'PROCESSING ',FIL
      OPEN (UNIT=8,FILE=FIL,FORM='FORMATTED',STATUS='OLD',ERR=192)
      FIL=TSKNAME(1:L)//'.NDF'
      INQUIRE (FILE=FIL,EXIST=EX)
      IF (EX.AND..NOT.ENDF) THEN
         OPEN (UNIT=7,FILE=FIL,FORM='FORMATTED',STATUS='OLD',ERR=93)
         CLOSE (UNIT=7,STATUS='DELETE')
      END IF
      IF (.NOT.ENDF) THEN
         READ (8,80) TITCRD
         OPEN (UNIT=7,FILE=FIL,FORM='FORMATTED',STATUS='NEW',ERR=94)
         WRITE (7,7) TITCRD(1:66)
      END IF
      ENDF=.TRUE.
  110 READ (8,80,END=150) KEYWRD
      IF (KEYWRD.NE.'WSP'.AND.KEYWRD.NE.'wsp') GO TO 110
      READ (8,*)
      READ (8,*) WSP
      GO TO 190
  150 CLOSE (UNIT=8,STATUS='KEEP')
      FIL=TSKNAME(1:L)//'.WSP'
      INQUIRE (FILE=FIL,EXIST=EX)
      IF (.NOT.EX) THEN
         WRITE (*,*) FIL,' DOES NOT EXIST'
         GO TO 200
      END IF
      WRITE (*,*) 'PROCESSING ',FIL
      OPEN (UNIT=8,FILE=FIL,FORM='FORMATTED',STATUS='OLD',ERR=193)
      FIL=TSKNAME(1:L)//'.NDF'
      INQUIRE (FILE=FIL,EXIST=EX)
      IF (EX.AND..NOT.ENDF) THEN
         OPEN (UNIT=7,FILE=FIL,FORM='FORMATTED',STATUS='OLD',ERR=93)
         CLOSE (UNIT=7,STATUS='DELETE')
      END IF
      IF (.NOT.ENDF) THEN
         READ (8,80) TITCRD
         OPEN (UNIT=7,FILE=FIL,FORM='FORMATTED',STATUS='NEW',ERR=94)
         WRITE (7,7) TITCRD(1:66)
      END IF
      ENDF=.TRUE.
      READ (8,*)
      READ (8,*)
      READ (8,*) WSP
  190 CLOSE (UNIT=8,STATUS='KEEP')
      CALL ETAP(ESAND)
      CALL MF1(4,994,641,TASK,MM,0,0,NS,ZAI,ATWI)
      CALL MF3HDR(4,994,641,ZAI,ATWI,NS)
      CALL MF3SP(994,WSP,640,ESAND,641,NS)
      WRITE (7,81) NS
      GO TO 200
  192 STOP 'DOS OPEN ERROR, FILE=taskname.DAT'
  193 STOP 'DOS OPEN ERROR, FILE=taskname.WSP'
C-=-=-
C     TASKNAME.XSL
C-=-=-
  200 FIL=TSKNAME(1:L)//'.XSL'
      INQUIRE (FILE=FIL,EXIST=EX)
      IF (.NOT.EX) THEN
         WRITE (*,*) FIL,' DOES NOT EXIST'
         GO TO 300
      END IF
      WRITE (*,*) 'PROCESSING ',FIL
      OPEN (UNIT=4,FILE=FIL,STATUS='OLD',ACCESS='DIRECT',
     1   RECL=1,FORM='UNFORMATTED',ERR=290)
      DO 210 I=1,3
      READ (4,REC=I) CHIN
  210 CHNGUS(I:I)=CHIN
      READ (CHNGUS,280) NGUSER
      CLOSE (UNIT=4,STATUS='KEEP')
      NGUSE1=NGUSER+1
      LR=MAX(4*NGUSE1,54)
      OPEN (UNIT=4,FILE=FIL,STATUS='OLD',ACCESS='DIRECT',
     1   RECL=LR,FORM='UNFORMATTED',ERR=190)
      READ (4,REC=4) NDBLK,NOTUSD
      NRC=5
      DO 220 N=1,NDBLK
      MM(3,N)=NRC
      READ (4,REC=NRC) NAME,G(1,N),G(2,N),COVER(N),G(3,N),G(4,N),
     1   ANIS,MM(1,N),MM(2,N),N1STU,KOVFLG
      IF (KOVFLG.GT.0) NRC=NRC+(NGUSER-N1STU+1)
      IF (KOVFLG.EQ.2) MM(1,N)=-2
  220 NRC=NRC+2
      NM1=NDBLK-1
      DO 230 I=1,NM1
      IP1=I+1
      DO 230 J=IP1,NDBLK
      IF (MM(1,J).LT.MM(1,I) .OR.
     1    MM(1,J).EQ.MM(1,I) .AND. MM(2,J).LT.MM(2,I))
     2   THEN
         DO 222 K=1,3
            N=MM(K,I)
            MM(K,I)=MM(K,J)
            MM(K,J)=N
  222    CONTINUE
         DO 224 K=1,4
            W=G(K,I)
            G(K,I)=G(K,J)
            G(K,J)=W
  224    CONTINUE
         CV=COVER(I)
         COVER(I)=COVER(J)
         COVER(J)=CV
      END IF
  230 CONTINUE
      FIL=TSKNAME(1:L)//'.NDF'
      INQUIRE (FILE=FIL,EXIST=EX)
      IF (EX.AND..NOT.ENDF) THEN
         OPEN (UNIT=7,FILE=FIL,FORM='FORMATTED',STATUS='OLD',ERR=93)
         CLOSE (UNIT=7,STATUS='DELETE')
      END IF
      IF (.NOT.ENDF)
     1    OPEN (UNIT=7,FILE=FIL,FORM='FORMATTED',STATUS='NEW',ERR=94)
      IF (NGUSE1*4.GT.80) THEN
         READ (4,REC=2) TITCRD
      ELSE
         READ (4,REC=2) TITCRD(1:NGUSE1*4)
      END IF
      IF (.NOT.ENDF)  WRITE (7,7) TITCRD(1:66)
      ENDF=.TRUE.
      READ (4,REC=3) (EUSER(I),I=1,NGUSE1)
      DO 235 I=1,NGUSE1
  235 EUSER(I)=EUSER(I)*1E6
      DO 250 N=1,NDBLK
      IF (MM(1,N).LT.0) GO TO 250
      NRC=MM(3,N)
      READ (4,REC=NRC) NAME,G1,G2,CV,G3,G4,ANIS,MAT,MT,N1STU,KOVFLG
      NRC=NRC+1
      IF (N.GT.1) THEN
         IF (MM(1,N).EQ.MM(1,N-1).AND.
     1       MM(2,N).EQ.MM(2,N-1)) THEN
             WRITE (6,281) NAME,MM(1,N),MM(2,N),
     1          G(1,N-1),G(2,N-1),G(1,N),G(2,N),
     2          COVER(N-1),G(3,N-1),G(4,N-1),
     3          COVER(N),G(3,N),G(4,N)
             READ (*,*)
         END IF
      END IF
      DO 240 J=1,N1STU
  240 CRUSER(J)=0.
      READ (4,REC=NRC) (CRUSER(J),J=N1STU,NGUSER)
      IF (N.GT.1.AND.(MM(1,N).NE.MM(1,N-1)) .OR. N.EQ.1)
     1   CALL MF1(MAT,MT,NGUSE1,TASK,MM,N,NDBLK,NS,ZAI,ATWI)
      CALL MF3HDR(MAT,MT,NGUSE1,ZAI,ATWI,NS)
      CALL MF3XS(MAT,MT,CRUSER,NGUSER,EUSER,NGUSE1,NS)
      IF (N.LT.NDBLK.AND.(MM(1,N).NE.MM(1,N+1)) .OR. N.EQ.NDBLK)
     1    WRITE (7,81) NS
  250 CONTINUE
      CLOSE (UNIT=4,STATUS='KEEP')
      GO TO 300
  280 FORMAT (I3)
  281 FORMAT (//' WARNING: REACTION: ',A/
     1   ' TWO CROSS SECTIONS HAVE THE SAME ENDF-6 IDENTIFICATION:',
     2   ' MAT=',I4,' MT=',I3/' BUT THEIR GEOMETRY IS DIFFERENT:'/
     3   ' DETECTOR: FIRST ONE:  ',1P2E11.3/
     4   '           SECOND ONE: ',1P2E11.3/
     5   ' COVER: FIRST ONE:  ',A2,1X,1P2E11.3/
     6   '        SECOND ONE: ',A2,1X,1P2E11.3/
     7   ' THE FILE taskname.NDF HAS TO BE MANUALLY EDITED'/
     8   ' (MODIFY THE MAT-NUMBER OF ONE OF THESE CROSS SECTIONS)'/
     9   ' (HIT THE ENTER KEY TO CONTINUE)'/)
  290 STOP 'DOS OPEN ERROR, FILE=taskname.XSL'
C-=-=-
C     END OF JOB
C-=-=-
  300 IF (ENDF) THEN
         WRITE (7,301)
         END FILE (UNIT=7)
         CLOSE (UNIT=7,STATUS='KEEP')
      END IF
      STOP
  301 FORMAT (68X,'-1 0  0    0')
      END
      SUBROUTINE ETAP(ENER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE GENERATES THE SAND II ENERGY GRID
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      REAL ENER,ENUL,P
      INTEGER I,IK,IN,J
      DIMENSION ENUL(45),ENER(641)
      SAVE
      DATA ENUL/1.,1.05,1.1,1.15,1.2,1.275,1.35,1.425,1.5,1.6,1.7,1.8,
     11.9,2.,2.1,2.2,2.3,2.4,2.55,2.7,2.8,3.,3.2,3.4,3.6,3.8,4.,4.25,4.5
     2,4.75,5.,5.25,5.5,5.75,6.,6.3,6.6,6.9,7.2,7.6,8.,8.4,8.8,9.2,9.6/
      J=0
      DO 12 I=1,10
      IN=I-5
      P=10.**IN
      DO 12 IK=1,45
      J=J+1
   12 ENER(J)=ENUL(IK)*P
      ENER(451)=1.E+6
      DO 24 I=452,641
   24 ENER(I)=(I-441)*1.E+5
      RETURN
      END
      SUBROUTINE FI2TN(DRPAFI,L,TSN)
      IMPLICIT NONE
      CHARACTER*76 DRPAFI
      CHARACTER*8 TSN
      CHARACTER*1 C
      INTEGER I,J,K,L
      DO 2 I=L,1,-1
      C=DRPAFI(I:I)
      IF (C.EQ.'\'.OR.C.EQ.':') GO TO 3
    2 CONTINUE
      TSN=DRPAFI(1:L)
      RETURN
    3 J=I+1
      DO 5 I=J,L
      K=I-J+1
    5 TSN(K:K)=DRPAFI(I:I)
      RETURN
      END
      SUBROUTINE MF1(MAT,MT,NG1,TASK,MLIST,N,NMAX,NS,ZAI,ATWI)
      IMPLICIT NONE
      INCLUDE 'XSSPPARM.FOR'
      INTEGER I,L3,M,MAT,MATS,MLIST,MT,N,N1,ND,NG1,NMAX,NS,NULL
     #              ,namiez
      REAL ZA,ZAI,ATW,ATWI,ZERO,ONE
      CHARACTER*11 CHSYM,CHSYMI
      CHARACTER*8 TASK
      LOGICAL FIRST
      DIMENSION MATS(NDETMX),ZA(NDETMX),ATW(NDETMX),CHSYM(NDETMX),
     1   MLIST(3,NMAX)
      SAVE
      DATA FIRST/.TRUE./,NULL/0/,ZERO/0./,ONE/1./
     *                                          ,namiez/3/
      IF (FIRST) THEN
         OPEN (UNIT=1,FILE='MATZA.DAT',STATUS='OLD',FORM='FORMATTED')
         READ (1,*) ND
         IF (ND.GT.NDETMX) STOP 'MF1 DIMENSION OVERFLOW'
         READ (1,1) (MATS(I),ZA(I),ATW(I),CHSYM(I),I=1,ND)
         CLOSE (UNIT=1,STATUS='KEEP')
         FIRST=.FALSE.
      END IF
    1 FORMAT (I4,2F11.0,A11)
      IF (MAT.LT.100) THEN
         ZAI=0.
         ATWI=0.
         CHSYMI=TASK
      ELSE
         DO 10 I=1,ND
            IF (MAT.EQ.MATS(I)) THEN
               ZAI=ZA(I)
               ATWI=ATW(I)
               CHSYMI=CHSYM(I)
               GO TO 11
            END IF
   10    CONTINUE
         ZAI=(MAT/100)*1000.
         ATWI=0.
         CHSYMI='  ?-??-  ? '
      END IF
   11 L3=NG1/3
      IF (MOD(NG1,3).NE.0) L3=L3+1
      L3=L3+3
      WRITE (7,21) ZAI,ATWI,NULL,NULL,NULL,NULL,MAT
      WRITE (7,22) ZERO,ZERO,NULL,NULL,NULL,MAT
      WRITE (7,23) ONE,ZERO,NULL,NULL,namiez,MAT
      WRITE (7,24) ZERO,ZERO,NULL,NULL,MAT
      WRITE (7,25) CHSYMI,MAT,MAT
      NS=7
      IF (N.EQ.0) THEN
         WRITE (7,30) MT,L3,MAT,NS
         NS=NS+1
      ELSE
         M=N
         N1=N+1
         DO 12 I=N1,NMAX
         IF (MLIST(1,I).EQ.MLIST(1,N)) M=I
   12    CONTINUE
         DO 13 I=N,M
         WRITE (7,30) MLIST(2,I),L3,MLIST(1,I),NS
         NS=NS+1
   13    CONTINUE
      END IF
      WRITE (7,31) MAT,NS
      NS=NS+1
      WRITE (7,32) MAT,NS
      NS=NS+1
      RETURN
   21 FORMAT (1P2E11.4,4I11,I4,' 1451    1')
   22 FORMAT (1P2E11.4,3I11,10X,'6',I4,' 1451    2')
   23 FORMAT (1P2E11.4,2I11,9X,'10',I11,I4,' 1451    3')
   24 FORMAT (1P2E11.4,2I11,10X,'1',10X,'2',I4,' 1451    4')
   25 FORMAT (A11,11X,' OUTPUT OF THE CODE XSSPPP (STAYNL,X333)',
     1   I8,' 1451    5'/
     2   32X,'1',8X,'451',2(10X,'1'),I4,' 1451    6')
   30 FORMAT (32X,'3',2I11,10X,'1',I4,' 1451',I5)
   31 FORMAT (66X,I4,' 1  0',I5)
   32 FORMAT (66X,I4,' 0  0',I5)
      END
      SUBROUTINE MF3HDR(MAT,MT,NG1,ZAI,ATWI,NS)
      IMPLICIT NONE
      INTEGER MAT,MT,NG1,NS
      REAL ZAI,ATWI
      WRITE (7,21) ZAI,ATWI,MAT,MT,NS
      NS=NS+1
      WRITE (7,22) NG1,MAT,MT,NS
      NS=NS+1
      WRITE (7,23) NG1,MAT,MT,NS
      NS=NS+1
      RETURN
   21 FORMAT (1P2E11.4,4(10X,'1'),I4,' 3',I3,I5)
   22 FORMAT (54X,'1',I11,I4,' 3',I3,I5)
   23 FORMAT (I11,10X,'1',44X,I4,' 3',I3,I5)
      END
      SUBROUTINE MF3SP(M,SP,NG,E,NG1,NS)
      IMPLICIT NONE
      INTEGER I,I1,I2,L,LINES,M,M1,NG,NG1,NGEND,NS
      REAL SP,E,Z
      DIMENSION SP(NG),E(NG1)
      DATA Z/0./
      DO 1 L=1,NG-1
    1 SP(L)=SP(L)*(E(L+1)-E(L))/ALOG(E(L+1)/E(L))
      M1=MOD(M,10)
      LINES=NG1/3
      NGEND=NG1-LINES*3
      IF (NGEND.EQ.0) THEN
         NGEND=3
         LINES=LINES-1
      END IF
      DO 5 L=1,LINES
         I2=L*3
         I1=I2-2
         WRITE (7,10) (E(I),SP(I),I=I1,I2),M1,M,NS
         NS=NS+1
    5 CONTINUE
      IF (NGEND.EQ.1) THEN
         WRITE (7,11) E(NG1),Z,M1,M,NS
      ELSE IF (NGEND.EQ.2) THEN
         WRITE (7,12) E(NG),SP(NG),E(NG1),Z,M1,M,NS
      ELSE
         WRITE (7,10) E(NG-1),SP(NG-1),E(NG),SP(NG),E(NG1),Z,M1,M,NS
      END IF
      NS=NS+1
      WRITE (7,20) M1,NS
      NS=NS+1
      WRITE (7,21) M1,NS
      NS=NS+1
      RETURN
   10 FORMAT (1P6E11.4,I4,' 3',I3,I5)
   11 FORMAT (1P2E11.4,44X,I4,' 3',I3,I5)
   12 FORMAT (1P4E11.4,22X,I4,' 3',I3,I5)
   20 FORMAT (66X,I4,' 3  0',I5)
   21 FORMAT (66X,I4,' 0  0',I5)
      END
      SUBROUTINE MF3XS(MAT,MT,SP,NG,E,NG1,NS)
      IMPLICIT NONE
      INTEGER I,I1,I2,L,LINES,MAT,MT,NG,NG1,NGEND,NS
      REAL SP,E,Z
      DIMENSION SP(NG),E(NG1)
      DATA Z/0./
      LINES=NG1/3
      NGEND=NG1-LINES*3
      IF (NGEND.EQ.0) THEN
         NGEND=3
         LINES=LINES-1
      END IF
      DO 1 L=1,LINES
         I2=L*3
         I1=I2-2
         WRITE (7,10) (E(I),SP(I),I=I1,I2),MAT,MT,NS
         NS=NS+1
    1 CONTINUE
      IF (NGEND.EQ.1) THEN
         WRITE (7,11) E(NG1),Z,MAT,MT,NS
      ELSE IF (NGEND.EQ.2) THEN
         WRITE (7,12) E(NG),SP(NG),E(NG1),Z,MAT,MT,NS
      ELSE
         WRITE (7,10) E(NG-1),SP(NG-1),E(NG),SP(NG),E(NG1),Z,MAT,MT,NS
      END IF
      NS=NS+1
      WRITE (7,20) MAT,NS
      NS=NS+1
      WRITE (7,21) MAT,NS
      NS=NS+1
      RETURN
   10 FORMAT (1P6E11.4,I4,' 3',I3,I5)
   11 FORMAT (1P2E11.4,44X,I4,' 3',I3,I5)
   12 FORMAT (1P4E11.4,22X,I4,' 3',I3,I5)
   20 FORMAT (66X,I4,' 3  0',I5)
   21 FORMAT (66X,I4,' 0  0',I5)
      END
